// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function ce(e, n) {
        return n.indexOf(e) >= 0;
    }
    function le(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function o(e, n) {
        this.message = e;
        this.defs = n;
    }
    o.prototype = Object.create(Error.prototype);
    o.prototype.constructor = o;
    o.prototype.name = "DefaultsError";
    n(o);
    function te(e, n, t) {
        if (e === true) e = {};
        var i = e || {};
        if (t) for (var r in i) if (_e(i, r) && !_e(n, r)) {
            throw new o("`" + r + "` is not a supported option", n);
        }
        for (var r in n) if (_e(n, r)) {
            i[r] = e && _e(e, r) ? e[r] : n[r];
        }
        return i;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (_e(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Q() {}
    function pe() {
        return false;
    }
    function ee() {
        return true;
    }
    function O() {
        return this;
    }
    function $() {
        return null;
    }
    var de = function() {
        function e(t, i, r) {
            var o = [], a = [], s;
            function e() {
                var e = i(t[s], s);
                var n = e instanceof l;
                if (n) e = e.v;
                if (e instanceof f) {
                    e = e.v;
                    if (e instanceof c) {
                        a.push.apply(a, r ? e.v.slice().reverse() : e.v);
                    } else {
                        a.push(e);
                    }
                } else if (e !== u) {
                    if (e instanceof c) {
                        o.push.apply(o, r ? e.v.slice().reverse() : e.v);
                    } else {
                        o.push(e);
                    }
                }
                return n;
            }
            if (Array.isArray(t)) {
                if (r) {
                    for (s = t.length; --s >= 0; ) if (e()) break;
                    o.reverse();
                    a.reverse();
                } else {
                    for (s = 0; s < t.length; ++s) if (e()) break;
                }
            } else {
                for (s in t) if (_e(t, s)) if (e()) break;
            }
            return a.concat(o);
        }
        e.at_top = function(e) {
            return new f(e);
        };
        e.splice = function(e) {
            return new c(e);
        };
        e.last = function(e) {
            return new l(e);
        };
        var u = e.skip = {};
        function f(e) {
            this.v = e;
        }
        function c(e) {
            this.v = e;
        }
        function l(e) {
            this.v = e;
        }
        return e;
    }();
    function v(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function z(e, t) {
        return e.replace(/\{(.+?)\}/g, function(e, n) {
            return t && t[n];
        });
    }
    function M(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function he(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function ve(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t])) return false;
        return true;
    }
    function q() {
        this._values = Object.create(null);
        this._size = 0;
    }
    q.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new q();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    q.fromObject = function(e) {
        var n = new q();
        n._size = t(n._values, e);
        return n;
    };
    function _e(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function j(e) {
        var n = e.parent(-1);
        for (var t = 0, i; i = e.parent(t++); n = i) {
            if (i.TYPE == "Call") {
                if (i.expression === n) continue;
            } else if (i instanceof cn) {
                if (i.left === n) continue;
            } else if (i instanceof ln) {
                if (i.condition === n) continue;
            } else if (i instanceof rn) {
                if (i.expression === n) continue;
            } else if (i instanceof tn) {
                if (i.expressions[0] === n) continue;
            } else if (i instanceof ge) {
                return i.body === n;
            } else if (i instanceof fn) {
                if (i.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = me;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = i && new i();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var u in t) if (_e(t, u)) {
            if (/^\$/.test(u)) {
                s[u.substr(1)] = t[u];
            } else {
                s.prototype[u] = t[u];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var ne = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var me = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new tt(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        _walk: function(e) {
            return e._visit(this);
        },
        walk: function(e) {
            return this._walk(e);
        }
    }, null);
    (me.log_function = function(n, e) {
        var t = Object.create(null);
        if (n) {
            me.info = e ? function(e, n) {
                i("INFO: " + z(e, n));
            } : Q;
            me.warn = function(e, n) {
                i("WARN: " + z(e, n));
            };
        } else {
            me.info = me.warn = Q;
        }
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var ge = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var be = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, ge);
    var ye = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        }
    }, ge);
    var we = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
            });
        }
    }, ge);
    function H(e, n) {
        var t = e.body;
        if (t instanceof ge) {
            t._walk(n);
        } else t.forEach(function(e) {
            e._walk(n);
        });
    }
    var xe = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                H(this, e);
            });
        }
    }, ge);
    var Ae = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, xe);
    var Ee = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, ge);
    var g = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        }
    }, ge);
    var ke = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.label._walk(e);
                this.body._walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new qn(function(e) {
                    if (e instanceof Ie && e.label && e.label.thedef === i) {
                        e.label.thedef = t;
                        t.references.push(e);
                    }
                }));
            }
            return n;
        }
    }, g);
    var De = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, g);
    var Fe = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        }
    }, De);
    var Ce = i("Do", null, {
        $documentation: "A `do` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
                this.condition._walk(e);
            });
        }
    }, Fe);
    var Be = i("While", null, {
        $documentation: "A `while` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
            });
        }
    }, Fe);
    var Se = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                if (this.init) this.init._walk(e);
                if (this.condition) this.condition._walk(e);
                if (this.step) this.step._walk(e);
                this.body._walk(e);
            });
        }
    }, De);
    var Te = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.init._walk(e);
                this.object._walk(e);
                this.body._walk(e);
            });
        }
    }, De);
    var Oe = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.body._walk(e);
            });
        }
    }, g);
    var $e = i("Scope", "variables functions uses_with uses_eval parent_scope enclosed cname", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            cname: "[integer/S] current index for mangling variables (used internally by the mangler)"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.variables) n.variables = this.variables.clone();
            if (this.functions) n.functions = this.functions.clone();
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            return n;
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        }
    }, xe);
    var ze = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return nt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new tt(function(e) {
                if (e instanceof ye && e.value == "$ORIG") {
                    return de.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return nt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new tt(function(e) {
                if (e instanceof ye && e.value == "$ORIG") {
                    return de.splice(t);
                }
            }));
        }
    }, $e);
    var Me = i("Lambda", "name argnames uses_arguments length_read", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[AST_SymbolFunarg*] array of function arguments",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                if (this.name) this.name._walk(n);
                this.argnames.forEach(function(e) {
                    e._walk(n);
                });
                H(this, n);
            });
        }
    }, $e);
    var qe = i("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null."
    }, Me);
    var je = i("Function", "inlined", {
        $documentation: "A function expression"
    }, Me);
    var He = i("Defun", "inlined", {
        $documentation: "A function definition"
    }, Me);
    var N = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, ge);
    var Ne = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        _walk: function(e) {
            return e._visit(this, this.value && function() {
                this.value._walk(e);
            });
        }
    }, N);
    var Re = i("Return", null, {
        $documentation: "A `return` statement"
    }, Ne);
    var ie = i("Throw", null, {
        $documentation: "A `throw` statement"
    }, Ne);
    var Ie = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        _walk: function(e) {
            return e._visit(this, this.label && function() {
                this.label._walk(e);
            });
        }
    }, N);
    var Ue = i("Break", null, {
        $documentation: "A `break` statement"
    }, Ie);
    var Pe = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, Ie);
    var Ve = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
                if (this.alternative) this.alternative._walk(e);
            });
        }
    }, g);
    var Le = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                H(this, e);
            });
        }
    }, xe);
    var R = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, xe);
    var Ye = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, R);
    var Je = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                H(this, e);
            });
        }
    }, R);
    var We = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                H(this, e);
                if (this.bcatch) this.bcatch._walk(e);
                if (this.bfinally) this.bfinally._walk(e);
            });
        }
    }, xe);
    var Ge = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch] symbol for the exception"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.argname._walk(e);
                H(this, e);
            });
        }
    }, xe);
    var Xe = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, xe);
    var Ze = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.definitions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    }, ge);
    var Ke = i("Var", null, {
        $documentation: "A `var` statement"
    }, Ze);
    var Qe = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.name._walk(e);
                if (this.value) this.value._walk(e);
            });
        }
    });
    var en = i("Call", "expression args", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expression._walk(n);
                this.args.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var nn = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, en);
    var tn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expressions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var rn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof En) {
                return e.getValue();
            }
            if (e instanceof un && e.operator == "void" && e.expression instanceof En) {
                return;
            }
            return e;
        }
    });
    var on = i("Dot", null, {
        $documentation: "A dotted property access expression",
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    }, rn);
    var an = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.property._walk(e);
            });
        }
    }, rn);
    var sn = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    });
    var un = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, sn);
    var fn = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, sn);
    var cn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.left._walk(e);
                this.right._walk(e);
            });
        }
    });
    var ln = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.consequent._walk(e);
                this.alternative._walk(e);
            });
        }
    });
    var pn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`"
    }, cn);
    var dn = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.elements.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var hn = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.properties.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var I = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_SymbolAccessor] property name. For ObjectKeyVal this is a string. For getters and setters this is an AST_SymbolAccessor.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.value._walk(e);
            });
        }
    });
    var vn = i("ObjectKeyVal", "quote", {
        $documentation: "A key: value object property",
        $propdoc: {
            quote: "[string] the original quote character"
        }
    }, I);
    var re = i("ObjectSetter", null, {
        $documentation: "An object setter property"
    }, I);
    var oe = i("ObjectGetter", null, {
        $documentation: "An object getter property"
    }, I);
    var U = i("Symbol", "scope name thedef", {
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        $documentation: "Base class for all symbols"
    });
    var ae = i("SymbolAccessor", null, {
        $documentation: "The name of a property accessor (setter/getter function)"
    }, U);
    var _n = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, U);
    var mn = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, _n);
    var gn = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, mn);
    var bn = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, _n);
    var yn = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, _n);
    var wn = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, _n);
    var se = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, U);
    var xn = i("SymbolRef", "fixed", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, U);
    var ue = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, U);
    var An = i("This", null, {
        $documentation: "The `this` symbol"
    }, U);
    var En = i("Constant", null, {
        $documentation: "Base class for all constants",
        getValue: function() {
            return this.value;
        }
    });
    var kn = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        }
    }, En);
    var Dn = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        }
    }, En);
    var Fn = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        }
    }, En);
    var a = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, En);
    var Cn = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, a);
    var Bn = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, a);
    var Sn = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, a);
    var Tn = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, a);
    var On = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, a);
    var $n = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, a);
    var zn = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, $n);
    var Mn = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, $n);
    function qn(e) {
        this.visit = e;
        this.stack = [];
        this.directives = Object.create(null);
    }
    qn.prototype = {
        _visit: function(e, n) {
            this.push(e);
            var t = this.visit(e, n ? function() {
                n.call(e);
            } : Q);
            if (!t && n) {
                n.call(e);
            }
            this.pop();
            return t;
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Me) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof ye && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof Me) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof $e) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof ye)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof ke && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof De || e instanceof Ue && i instanceof Le) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof we || t instanceof ln && t.condition === e || t instanceof Fe && t.condition === e || t instanceof Se && t.condition === e || t instanceof Ve && t.condition === e || t instanceof un && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof cn && (t.operator == "&&" || t.operator == "||") || t instanceof ln || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof Re) {
                    var i;
                    do {
                        i = this.parent(++n);
                        if (!i) return false;
                    } while (!(i instanceof Me));
                    if (i.name) return false;
                    e = this.parent(++n);
                    if (!e || e.TYPE != "Call" || e.expression !== i) return false;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var fe = "break case catch const continue debugger default delete do else finally for function if in instanceof new return switch throw try typeof var void while with";
    var P = "false null true";
    var b = "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield" + " " + P + " " + fe;
    var V = "return new delete throw else case";
    fe = he(fe);
    b = he(b);
    V = he(V);
    P = he(P);
    var L = he(e("+-*&%=<>!?|~^"));
    var r = /^0x[0-9a-f]+$/i;
    var Y = /^0[0-7]+$/;
    var J = he([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var W = he(e("  \n\r\t\f\v​           \u2028\u2029  　\ufeff"));
    var G = he(e("\n\r\u2028\u2029"));
    var X = he(e("[{(,;:"));
    var Z = he(e("[]{}(),;:"));
    var s = {
        letter: new RegExp("[\\u0041-\\u005A\\u0061-\\u007A\\u00AA\\u00B5\\u00BA\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0370-\\u0374\\u0376\\u0377\\u037A-\\u037D\\u037F\\u0386\\u0388-\\u038A\\u038C\\u038E-\\u03A1\\u03A3-\\u03F5\\u03F7-\\u0481\\u048A-\\u052F\\u0531-\\u0556\\u0559\\u0561-\\u0587\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06E5\\u06E6\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u07F4\\u07F5\\u07FA\\u0800-\\u0815\\u081A\\u0824\\u0828\\u0840-\\u0858\\u08A0-\\u08B2\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0971-\\u0980\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E46\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EC6\\u0EDC-\\u0EDF\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10A0-\\u10C5\\u10C7\\u10CD\\u10D0-\\u10FA\\u10FC-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u16EE-\\u16F8\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17D7\\u17DC\\u1820-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191E\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1AA7\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BBA-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C7D\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u1CF5\\u1CF6\\u1D00-\\u1DBF\\u1E00-\\u1F15\\u1F18-\\u1F1D\\u1F20-\\u1F45\\u1F48-\\u1F4D\\u1F50-\\u1F57\\u1F59\\u1F5B\\u1F5D\\u1F5F-\\u1F7D\\u1F80-\\u1FB4\\u1FB6-\\u1FBC\\u1FBE\\u1FC2-\\u1FC4\\u1FC6-\\u1FCC\\u1FD0-\\u1FD3\\u1FD6-\\u1FDB\\u1FE0-\\u1FEC\\u1FF2-\\u1FF4\\u1FF6-\\u1FFC\\u2071\\u207F\\u2090-\\u209C\\u2102\\u2107\\u210A-\\u2113\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u212F-\\u2139\\u213C-\\u213F\\u2145-\\u2149\\u214E\\u2160-\\u2188\\u2C00-\\u2C2E\\u2C30-\\u2C5E\\u2C60-\\u2CE4\\u2CEB-\\u2CEE\\u2CF2\\u2CF3\\u2D00-\\u2D25\\u2D27\\u2D2D\\u2D30-\\u2D67\\u2D6F\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u2E2F\\u3005-\\u3007\\u3021-\\u3029\\u3031-\\u3035\\u3038-\\u303C\\u3041-\\u3096\\u309D-\\u309F\\u30A1-\\u30FA\\u30FC-\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400-\\u4DB5\\u4E00-\\u9FCC\\uA000-\\uA48C\\uA4D0-\\uA4FD\\uA500-\\uA60C\\uA610-\\uA61F\\uA62A\\uA62B\\uA640-\\uA66E\\uA67F-\\uA69D\\uA6A0-\\uA6EF\\uA717-\\uA71F\\uA722-\\uA788\\uA78B-\\uA78E\\uA790-\\uA7AD\\uA7B0\\uA7B1\\uA7F7-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uA9CF\\uA9E0-\\uA9E4\\uA9E6-\\uA9EF\\uA9FA-\\uA9FE\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA76\\uAA7A\\uAA7E-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB-\\uAADD\\uAAE0-\\uAAEA\\uAAF2-\\uAAF4\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uAB30-\\uAB5A\\uAB5C-\\uAB5F\\uAB64\\uAB65\\uABC0-\\uABE2\\uAC00-\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA6D\\uFA70-\\uFAD9\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF21-\\uFF3A\\uFF41-\\uFF5A\\uFF66-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC]"),
        digit: new RegExp("[\\u0030-\\u0039\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0DE6-\\u0DEF\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uA9F0-\\uA9F9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]"),
        non_spacing_mark: new RegExp("[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065E\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0900-\\u0902\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0955\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F90-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFD-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26]"),
        space_combining_mark: new RegExp("[\\u0903\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]"),
        connector_punctuation: new RegExp("[\\u005F\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]")
    };
    function u(e) {
        return e >= 97 && e <= 122 || e >= 65 && e <= 90 || e >= 170 && s.letter.test(String.fromCharCode(e));
    }
    function jn(e) {
        if (typeof e == "string") e = e.charCodeAt(0);
        return e >= 55296 && e <= 56319;
    }
    function Hn(e) {
        if (typeof e == "string") e = e.charCodeAt(0);
        return e >= 56320 && e <= 57343;
    }
    function Nn(e) {
        return e >= 48 && e <= 57;
    }
    function Rn(e) {
        return Nn(e) || u(e);
    }
    function f(e) {
        return s.digit.test(String.fromCharCode(e));
    }
    function c(e) {
        return s.non_spacing_mark.test(e) || s.space_combining_mark.test(e);
    }
    function l(e) {
        return s.connector_punctuation.test(e);
    }
    function In(e) {
        return e == 36 || e == 95 || u(e);
    }
    function Un(e) {
        var n = e.charCodeAt(0);
        return In(n) || Nn(n) || n == 8204 || n == 8205 || c(e) || l(e) || f(n);
    }
    function Pn(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Vn(e) {
        if (r.test(e)) {
            return parseInt(e.substr(2), 16);
        } else if (Y.test(e)) {
            return parseInt(e.substr(1), 8);
        } else {
            var n = parseFloat(e);
            if (n == e) return n;
        }
    }
    function Ln(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Ln.prototype = Object.create(Error.prototype);
    Ln.prototype.constructor = Ln;
    Ln.prototype.name = "SyntaxError";
    n(Ln);
    function Yn(e, n, t, i, r) {
        throw new Ln(e, n, t, i, r);
    }
    function Jn(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var Wn = {};
    function Gn(r, o, a, s) {
        var u = {
            text: r,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        function f() {
            return u.text.charAt(u.pos);
        }
        function c(e, n) {
            var t = u.text.charAt(u.pos++);
            if (e && !t) throw Wn;
            if (G[t]) {
                u.newline_before = u.newline_before || !n;
                ++u.line;
                u.col = 0;
                if (!n && t == "\r" && f() == "\n") {
                    ++u.pos;
                    t = "\n";
                }
            } else {
                ++u.col;
            }
            return t;
        }
        function l(e) {
            while (e-- > 0) c();
        }
        function p(e) {
            return u.text.substr(u.pos, e.length) == e;
        }
        function d() {
            var e = u.text;
            for (var n = u.pos; n < u.text.length; ++n) {
                if (G[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = u.text.indexOf(e, u.pos);
            if (n && t == -1) throw Wn;
            return t;
        }
        function h() {
            u.tokline = u.line;
            u.tokcol = u.col;
            u.tokpos = u.pos;
        }
        var v = false;
        function _(e, n, t) {
            u.regex_allowed = e == "operator" && !Zn[n] || e == "keyword" && V[n] || e == "punc" && X[n];
            if (e == "punc" && n == ".") {
                v = true;
            } else if (!t) {
                v = false;
            }
            var i = {
                type: e,
                value: n,
                line: u.tokline,
                col: u.tokcol,
                pos: u.tokpos,
                endline: u.line,
                endcol: u.col,
                endpos: u.pos,
                nlb: u.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = u.comments_before;
                i.comments_after = u.comments_before = [];
            }
            u.newline_before = false;
            return new ne(i);
        }
        function m() {
            while (W[f()]) c();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = f()) && e(t, i++)) n += c();
            return n;
        }
        function g(e) {
            Yn(e, o, u.tokline, u.tokcol, u.tokpos);
        }
        function b(i) {
            var r = false, o = false, a = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : r ? false : r = o = true;

                  case 45:
                    return o || n == 0 && !i;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !r ? s = true : false;
                }
                return Rn(t);
            });
            if (i) e = i + e;
            if (Y.test(e) && T.has_directive("use strict")) {
                g("Legacy octal literals are not allowed in strict mode");
            }
            var n = Vn(e);
            if (!isNaN(n)) {
                return _("num", n);
            } else {
                g("Invalid syntax: " + e);
            }
        }
        function y(e) {
            var n = c(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                return String.fromCharCode(x(4));

              case 10:
                return "";

              case 13:
                if (f() == "\n") {
                    c(true, e);
                    return "";
                }
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = f();
            if (n >= "0" && n <= "7") {
                e += c(true);
                if (e[0] <= "3" && (n = f()) >= "0" && n <= "7") e += c(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && T.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(c(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var A = n("Unterminated string constant", function(e) {
            var n = c(), t = "";
            for (;;) {
                var i = c(true, true);
                if (i == "\\") i = y(true); else if (G[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = u.regex_allowed;
            var t = d(), i;
            if (t == -1) {
                i = u.text.substr(u.pos);
                u.pos = u.text.length;
            } else {
                i = u.text.substring(u.pos, t);
                u.pos = t;
            }
            u.col = u.tokcol + (u.pos - u.tokpos);
            u.comments_before.push(_(e, i, true));
            u.regex_allowed = n;
            return T;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = u.regex_allowed;
            var n = i("*/", true);
            var t = u.text.substring(u.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            l(t.length + 2);
            u.comments_before.push(_("comment2", t, true));
            u.regex_allowed = e;
            return T;
        });
        function k() {
            var e = false, n = "", t, i = false, r;
            while ((t = f()) != null) {
                if (!e) {
                    if (t == "\\") i = e = true, c(); else if (Un(t)) n += c(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!Un(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (fe[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var D = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = c(true)) if (G[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = k();
            try {
                var o = new RegExp(e, r);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function F(e) {
            function t(e) {
                if (!f()) return e;
                var n = e + f();
                if (J[n]) {
                    c();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || c()));
        }
        function C() {
            c();
            switch (f()) {
              case "/":
                c();
                return E("comment1");

              case "*":
                c();
                return e();
            }
            return u.regex_allowed ? D("") : F("/");
        }
        function B() {
            c();
            return Nn(f().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function S() {
            var e = k();
            if (v) return _("name", e);
            return P[e] ? _("atom", e) : !fe[e] ? _("name", e) : J[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === Wn) g(n); else throw e;
                }
            };
        }
        function T(e) {
            if (e != null) return D(e);
            if (s && u.pos == 0 && p("#!")) {
                h();
                l(2);
                E("comment5");
            }
            for (;;) {
                m();
                h();
                if (a) {
                    if (p("\x3c!--")) {
                        l(4);
                        E("comment3");
                        continue;
                    }
                    if (p("--\x3e") && u.newline_before) {
                        l(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = f();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return A(n);

                  case 46:
                    return B();

                  case 47:
                    {
                        var i = C();
                        if (i === T) continue;
                        return i;
                    }
                }
                if (Nn(t)) return b();
                if (Z[n]) return _("punc", c());
                if (L[n]) return F();
                if (t == 92 || In(t)) return S();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        T.context = function(e) {
            if (e) u = e;
            return u;
        };
        T.add_directive = function(e) {
            u.directive_stack[u.directive_stack.length - 1].push(e);
            if (u.directives[e] === undefined) {
                u.directives[e] = 1;
            } else {
                u.directives[e]++;
            }
        };
        T.push_directives_stack = function() {
            u.directive_stack.push([]);
        };
        T.pop_directives_stack = function() {
            var e = u.directive_stack[u.directive_stack.length - 1];
            for (var n = 0; n < e.length; n++) {
                u.directives[e[n]]--;
            }
            u.directive_stack.pop();
        };
        T.has_directive = function(e) {
            return u.directives[e] > 0;
        };
        return T;
    }
    var Xn = he([ "typeof", "void", "delete", "--", "++", "!", "~", "-", "+" ]);
    var Zn = he([ "--", "++" ]);
    var Kn = he([ "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=" ]);
    var Qn = function(e, n) {
        for (var t = 0; t < e.length; ++t) {
            var i = e[t];
            for (var r = 0; r < i.length; ++r) {
                n[i[r]] = t + 1;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var et = he([ "atom", "num", "string", "regexp", "name" ]);
    function nt(e, u) {
        u = te(u, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? Gn(e, u.filename, u.html5_comments, u.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = p();
        function c(e, n) {
            return Jn(f.token, e, n);
        }
        function l() {
            return f.peeked || (f.peeked = f.input());
        }
        function p() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || c("punc", ";"));
            return f.token;
        }
        function d() {
            return f.prev;
        }
        function h(e, n, t, i) {
            var r = f.input.context();
            Yn(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function t(e, n) {
            h(n, e.line, e.col);
        }
        function i(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function v(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + i(e.type, e.value));
        }
        function _(e, n) {
            if (c(e, n)) {
                return p();
            }
            t(f.token, "Unexpected token: " + i(f.token.type, f.token.value) + ", expected: " + i(e, n));
        }
        function m(e) {
            return _("punc", e);
        }
        function g(e) {
            return e.nlb || !ve(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function b() {
            return !u.strict && (c("eof") || c("punc", "}") || g(f.token));
        }
        function y(e) {
            if (c("punc", ";")) p(); else if (!e && !b()) _("punc", ";");
        }
        function w() {
            m("(");
            var e = ee(true);
            m(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = f.token;
                var n = i.apply(null, arguments);
                var t = d();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function x() {
            if (c("operator", "/") || c("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var A = n(function(e) {
            x();
            switch (f.token.type) {
              case "string":
                if (f.in_directives) {
                    var n = l();
                    if (f.token.raw.indexOf("\\") == -1 && (Jn(n, "punc", ";") || Jn(n, "punc", "}") || g(n) || Jn(n, "eof"))) {
                        f.input.add_directive(f.token.value);
                    } else {
                        f.in_directives = false;
                    }
                }
                var t = f.in_directives, i = k();
                return t ? new ye(i.body) : i;

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return k();

              case "name":
                return Jn(l(), "punc", ":") ? E() : k();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new Ae({
                        start: f.token,
                        body: S(),
                        end: d()
                    });

                  case "[":
                  case "(":
                    return k();

                  case ";":
                    f.in_directives = false;
                    p();
                    return new Ee();

                  default:
                    v();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    p();
                    return D(Ue);

                  case "continue":
                    p();
                    return D(Pe);

                  case "debugger":
                    p();
                    y();
                    return new be();

                  case "do":
                    p();
                    var r = ne(A);
                    _("keyword", "while");
                    var o = w();
                    y(true);
                    return new Ce({
                        body: r,
                        condition: o
                    });

                  case "while":
                    p();
                    return new Be({
                        condition: w(),
                        body: ne(A)
                    });

                  case "for":
                    p();
                    return F();

                  case "function":
                    if (!e && f.input.has_directive("use strict")) {
                        h("In strict mode code, functions can only be declared at top level or immediately within another function.");
                    }
                    p();
                    return C(He);

                  case "if":
                    p();
                    return B();

                  case "return":
                    if (f.in_function == 0 && !u.bare_returns) h("'return' outside of function");
                    p();
                    var a = null;
                    if (c("punc", ";")) {
                        p();
                    } else if (!b()) {
                        a = ee(true);
                        y();
                    }
                    return new Re({
                        value: a
                    });

                  case "switch":
                    p();
                    return new Le({
                        expression: w(),
                        body: ne(T)
                    });

                  case "throw":
                    p();
                    if (g(f.token)) h("Illegal newline after 'throw'");
                    var a = ee(true);
                    y();
                    return new ie({
                        value: a
                    });

                  case "try":
                    p();
                    return O();

                  case "var":
                    p();
                    var s = $();
                    y();
                    return s;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        h("Strict mode may not include a with statement");
                    }
                    p();
                    return new Oe({
                        expression: w(),
                        body: A()
                    });
                }
            }
            v();
        });
        function E() {
            var n = V(se);
            if (!ve(f.labels, function(e) {
                return e.name != n.name;
            })) {
                h("Label " + n.name + " defined twice");
            }
            m(":");
            f.labels.push(n);
            var e = A();
            f.labels.pop();
            if (!(e instanceof De)) {
                n.references.forEach(function(e) {
                    if (e instanceof Pe) {
                        e = e.label.start;
                        h("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new ke({
                body: e,
                label: n
            });
        }
        function k(e) {
            return new we({
                body: (e = ee(true), y(), e)
            });
        }
        function D(e) {
            var n = null, t;
            if (!b()) {
                n = V(ue, true);
            }
            if (n != null) {
                t = le(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) h("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) h(e.TYPE + " not inside a loop or switch");
            y();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function F() {
            m("(");
            var e = null;
            if (!c("punc", ";")) {
                e = c("keyword", "var") ? (p(), $(true)) : ee(true, true);
                if (c("operator", "in")) {
                    if (e instanceof Ke) {
                        if (e.definitions.length > 1) h("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!K(e)) {
                        h("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    p();
                    return o(e);
                }
            }
            return r(e);
        }
        function r(e) {
            m(";");
            var n = c("punc", ";") ? null : ee(true);
            m(";");
            var t = c("punc", ")") ? null : ee(true);
            m(")");
            return new Se({
                init: e,
                condition: n,
                step: t,
                body: ne(A)
            });
        }
        function o(e) {
            var n = ee(true);
            m(")");
            return new Te({
                init: e,
                object: n,
                body: ne(A)
            });
        }
        var C = function(e) {
            var n = e === He;
            var t = c("name") ? V(n ? bn : yn) : null;
            if (n && !t) _("name");
            if (t && e !== qe && !(t instanceof _n)) v(d());
            m("(");
            var i = [];
            for (var r = true; !c("punc", ")"); ) {
                if (r) r = false; else m(",");
                i.push(V(gn));
            }
            p();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = S(true);
            if (f.input.has_directive("use strict")) {
                if (t) P(t);
                i.forEach(P);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: i,
                body: s
            });
        };
        function B() {
            var e = w(), n = A(), t = null;
            if (c("keyword", "else")) {
                p();
                t = A();
            }
            return new Ve({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function S(e) {
            m("{");
            var n = [];
            while (!c("punc", "}")) {
                if (c("eof")) _("punc", "}");
                n.push(A(e));
            }
            p();
            return n;
        }
        function T() {
            m("{");
            var e = [], n = null, t = null, i;
            while (!c("punc", "}")) {
                if (c("eof")) _("punc", "}");
                if (c("keyword", "case")) {
                    if (t) t.end = d();
                    n = [];
                    t = new Je({
                        start: (i = f.token, p(), i),
                        expression: ee(true),
                        body: n
                    });
                    e.push(t);
                    m(":");
                } else if (c("keyword", "default")) {
                    if (t) t.end = d();
                    n = [];
                    t = new Ye({
                        start: (i = f.token, p(), m(":"), i),
                        body: n
                    });
                    e.push(t);
                } else {
                    if (!n) v();
                    n.push(A());
                }
            }
            if (t) t.end = d();
            p();
            return e;
        }
        function O() {
            var e = S(), n = null, t = null;
            if (c("keyword", "catch")) {
                var i = f.token;
                p();
                m("(");
                var r = V(wn);
                m(")");
                n = new Ge({
                    start: i,
                    argname: r,
                    body: S(),
                    end: d()
                });
            }
            if (c("keyword", "finally")) {
                var i = f.token;
                p();
                t = new Xe({
                    start: i,
                    body: S(),
                    end: d()
                });
            }
            if (!n && !t) h("Missing catch/finally blocks");
            return new We({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function a(e) {
            var n = [];
            for (;;) {
                n.push(new Qe({
                    start: f.token,
                    name: V(mn),
                    value: c("operator", "=") ? (p(), ee(false, e)) : null,
                    end: d()
                }));
                if (!c("punc", ",")) break;
                p();
            }
            return n;
        }
        var $ = function(e) {
            return new Ke({
                start: d(),
                definitions: a(e),
                end: d()
            });
        };
        var s = function(e) {
            var n = f.token;
            _("operator", "new");
            var t = M(false), i;
            if (c("punc", "(")) {
                p();
                i = q(")");
            } else {
                i = [];
            }
            var r = new nn({
                start: n,
                expression: t,
                args: i,
                end: d()
            });
            L(r);
            return Y(r, e);
        };
        function z() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = U(xn);
                break;

              case "num":
                n = new Dn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new kn({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new Fn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new zn({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new Mn({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new Cn({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            p();
            return n;
        }
        var M = function(e) {
            if (c("operator", "new")) {
                return s(e);
            }
            var n = f.token;
            if (c("punc")) {
                switch (n.value) {
                  case "(":
                    p();
                    var t = ee(true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    m(")");
                    var o = d();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof en) L(t);
                    return Y(t, e);

                  case "[":
                    return Y(j(), e);

                  case "{":
                    return Y(N(), e);
                }
                v();
            }
            if (c("keyword", "function")) {
                p();
                var a = C(je);
                a.start = n;
                a.end = d();
                return Y(a, e);
            }
            if (et[f.token.type]) {
                return Y(z(), e);
            }
            v();
        };
        function q(e, n, t) {
            var i = true, r = [];
            while (!c("punc", e)) {
                if (i) i = false; else m(",");
                if (n && c("punc", e)) break;
                if (c("punc", ",") && t) {
                    r.push(new Tn({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    r.push(ee(false));
                }
            }
            p();
            return r;
        }
        var j = n(function() {
            m("[");
            return new dn({
                elements: q("]", !u.strict, true)
            });
        });
        var H = n(function() {
            return C(qe);
        });
        var N = n(function() {
            m("{");
            var e = true, n = [];
            while (!c("punc", "}")) {
                if (e) e = false; else m(",");
                if (!u.strict && c("punc", "}")) break;
                var t = f.token;
                var i = t.type;
                var r = R();
                if (i == "name" && !c("punc", ":")) {
                    var o = new ae({
                        start: f.token,
                        name: "" + R(),
                        end: d()
                    });
                    if (r == "get") {
                        n.push(new oe({
                            start: t,
                            key: o,
                            value: H(),
                            end: d()
                        }));
                        continue;
                    }
                    if (r == "set") {
                        n.push(new re({
                            start: t,
                            key: o,
                            value: H(),
                            end: d()
                        }));
                        continue;
                    }
                }
                m(":");
                n.push(new vn({
                    start: t,
                    quote: t.quote,
                    key: "" + r,
                    value: ee(false),
                    end: d()
                }));
            }
            p();
            return new hn({
                properties: n
            });
        });
        function R() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!fe[e.value]) v();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                p();
                return e.value;

              default:
                v();
            }
        }
        function I() {
            if (!c("name")) _("name");
            var e = f.token.value;
            p();
            return e;
        }
        function U(e) {
            var n = f.token.value;
            return new (n == "this" ? An : e)({
                name: String(n),
                start: f.token,
                end: f.token
            });
        }
        function P(e) {
            if (e.name == "arguments" || e.name == "eval") h("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function V(e, n) {
            if (!c("name")) {
                if (!n) h("Name expected");
                return null;
            }
            var t = U(e);
            if (f.input.has_directive("use strict") && t instanceof _n) {
                P(t);
            }
            p();
            return t;
        }
        function L(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = _e(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var Y = function(e, n) {
            var t = e.start;
            if (c("punc", ".")) {
                p();
                return Y(new on({
                    start: t,
                    expression: e,
                    property: I(),
                    end: d()
                }), n);
            }
            if (c("punc", "[")) {
                p();
                var i = ee(true);
                m("]");
                return Y(new an({
                    start: t,
                    expression: e,
                    property: i,
                    end: d()
                }), n);
            }
            if (n && c("punc", "(")) {
                p();
                var r = new en({
                    start: t,
                    expression: e,
                    args: q(")"),
                    end: d()
                });
                L(r);
                return Y(r, true);
            }
            return e;
        };
        var J = function(e) {
            var n = f.token;
            if (c("operator") && Xn[n.value]) {
                p();
                x();
                var t = W(un, n, J(e));
                t.start = n;
                t.end = d();
                return t;
            }
            var i = M(e);
            while (c("operator") && Zn[f.token.value] && !g(f.token)) {
                i = W(fn, f.token, i);
                i.start = n;
                i.end = f.token;
                p();
            }
            return i;
        };
        function W(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!K(t)) h("Invalid use of " + i + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof xn && f.input.has_directive("use strict")) h("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var G = function(e, n, t) {
            var i = c("operator") ? f.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Qn[i] : null;
            if (r != null && r > n) {
                p();
                var o = G(J(true), r, t);
                return G(new cn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function X(e) {
            return G(J(true), 0, e);
        }
        var Z = function(e) {
            var n = f.token;
            var t = X(e);
            if (c("operator", "?")) {
                p();
                var i = ee(false);
                m(":");
                return new ln({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: ee(false, e),
                    end: d()
                });
            }
            return t;
        };
        function K(e) {
            return e instanceof rn || e instanceof xn;
        }
        var Q = function(e) {
            var n = f.token;
            var t = Z(e), i = f.token.value;
            if (c("operator") && Kn[i]) {
                if (K(t)) {
                    p();
                    return new pn({
                        start: n,
                        left: t,
                        operator: i,
                        right: Q(e),
                        end: d()
                    });
                }
                h("Invalid assignment");
            }
            return t;
        };
        var ee = function(e, n) {
            var t = f.token;
            var i = [];
            while (true) {
                i.push(Q(n));
                if (!e || !c("punc", ",")) break;
                p();
                e = true;
            }
            return i.length == 1 ? i[0] : new tn({
                start: t,
                expressions: i,
                end: l()
            });
        };
        function ne(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (u.expression) {
            x();
            return ee(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!c("eof")) n.push(A(true));
            f.input.pop_directives_stack();
            var t = d();
            var i = u.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new ze({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function tt(e, n) {
        qn.call(this);
        this.before = e;
        this.after = n;
    }
    tt.prototype = new qn();
    (function(e) {
        function t(e, n) {
            return de(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(me, Q);
        e(ke, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(we, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(xe, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Ce, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Be, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(Se, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(Te, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Oe, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Ne, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Ie, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(Ve, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Le, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Je, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(We, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(Ge, function(e, n) {
            e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Ze, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Qe, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Me, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(en, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(tn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(on, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(an, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(sn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(cn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(ln, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(dn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(hn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(I, function(e, n) {
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function p(e, n, t) {
        this.name = n.name;
        this.orig = [ n ];
        this.init = t;
        this.eliminated = 0;
        this.scope = e;
        this.references = [];
        this.replaced = 0;
        this.global = false;
        this.mangled_name = null;
        this.undeclared = false;
        this.id = p.next_id++;
        this.lambda = n instanceof yn;
    }
    p.next_id = 1;
    p.prototype = {
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof yn || this.orig[0] instanceof bn);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t;
                if (t = this.redefined()) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = _(this.scope, e, this);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            return this.defun && this.defun.variables.get(this.name);
        }
    };
    ze.DEFMETHOD("figure_out_scope", function(a) {
        a = te(a, {
            cache: null,
            ie8: false
        });
        var o = this;
        var s = o.parent_scope = null;
        var u = null;
        var f = new qn(function(e, n) {
            if (e instanceof Ge) {
                var t = s;
                s = new $e(e);
                s.init_scope_vars(t);
                n();
                s = t;
                return true;
            }
            if (e instanceof $e) {
                e.init_scope_vars(s);
                var t = s;
                var i = u;
                u = s = e;
                n();
                s = t;
                u = i;
                return true;
            }
            if (e instanceof Oe) {
                for (var r = s; r; r = r.parent_scope) r.uses_with = true;
                return;
            }
            if (e instanceof U) {
                e.scope = s;
            }
            if (e instanceof se) {
                e.thedef = e;
                e.references = [];
            }
            if (e instanceof bn) {
                (e.scope = u.parent_scope.resolve()).def_function(e, u);
            } else if (e instanceof yn) {
                var o = u.def_function(e, e.name == "arguments" ? undefined : u);
                if (a.ie8) o.defun = u.parent_scope.resolve();
            } else if (e instanceof mn) {
                u.def_variable(e, e.TYPE == "SymbolVar" ? null : undefined);
                if (u !== s) {
                    e.mark_enclosed(a);
                    var o = s.find_variable(e);
                    if (e.thedef !== o) {
                        e.thedef = o;
                    }
                    e.reference(a);
                }
            } else if (e instanceof wn) {
                s.def_variable(e).defun = u;
            }
        });
        o.walk(f);
        o.globals = new q();
        var f = new qn(function(e) {
            if (e instanceof Ie) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof xn) {
                var n = e.name;
                if (n == "eval" && f.parent() instanceof en) {
                    for (var t = e.scope; t && !t.uses_eval; t = t.parent_scope) {
                        t.uses_eval = true;
                    }
                }
                var i = e.scope.find_variable(n);
                if (!i) {
                    i = o.def_global(e);
                } else if (i.scope instanceof Me && n == "arguments") {
                    i.scope.uses_arguments = true;
                }
                e.thedef = i;
                e.reference(a);
                return true;
            }
            if (e instanceof wn) {
                var r = e.definition().redefined();
                if (r) for (var t = e.scope; t; t = t.parent_scope) {
                    v(t.enclosed, r);
                    if (t === r.scope) break;
                }
                return true;
            }
        });
        o.walk(f);
        if (a.ie8) o.walk(new qn(function(e) {
            if (e instanceof wn) {
                var n = e.thedef.defun;
                if (n.name instanceof yn && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof yn) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            var r = n.find_variable(t) || o.globals.get(t) || n.def_variable(e);
            i.orig.concat(i.references).forEach(function(e) {
                e.thedef = r;
                e.reference(a);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) o.variables.set(t, r);
        }
    });
    ze.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = new p(this, e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    $e.DEFMETHOD("init_scope_vars", function(e) {
        this.variables = new q();
        this.functions = new q();
        this.uses_with = false;
        this.uses_eval = false;
        this.parent_scope = e;
        this.enclosed = [];
        this.cname = -1;
    });
    Me.DEFMETHOD("init_scope_vars", function() {
        $e.prototype.init_scope_vars.apply(this, arguments);
        this.uses_arguments = false;
        this.def_variable(new gn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
    });
    U.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            v(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    v(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    U.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    $e.DEFMETHOD("find_variable", function(e) {
        if (e instanceof U) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    $e.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof He) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    $e.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init && (t.scope !== e.scope || t.init instanceof je)) {
                t.init = n;
            }
        } else {
            t = new p(this, e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    Me.DEFMETHOD("resolve", O);
    $e.DEFMETHOD("resolve", function() {
        return this.parent_scope.resolve();
    });
    ze.DEFMETHOD("resolve", O);
    function d(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.names_in_use = t = Object.create(e.mangled_names || null);
            e.cname_holes = [];
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function _(e, i, n) {
        var t = d(e, i);
        var r = e.cname_holes;
        var o = Object.create(null);
        var a = [ e ];
        n.references.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in d(n, i)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var u = 0; u < r.length; u++) {
            s = y(r[u]);
            if (o[s]) continue;
            r.splice(u, 1);
            e.names_in_use[s] = true;
            return s;
        }
        while (true) {
            s = y(++e.cname);
            if (t[s] || b[s] || i.reserved.has[s]) continue;
            if (!o[s]) break;
            r.push(e.cname);
        }
        e.names_in_use[s] = true;
        return s;
    }
    U.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    se.DEFMETHOD("unmangleable", pe);
    U.DEFMETHOD("unreferenced", function() {
        return !this.definition().references.length && !this.scope.pinned();
    });
    U.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    U.DEFMETHOD("global", function() {
        return this.definition().global;
    });
    function m(e) {
        e = te(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        v(e.reserved, "arguments");
        e.reserved.has = he(e.reserved);
        return e;
    }
    ze.DEFMETHOD("mangle_names", function(a) {
        a = m(a);
        var s = -1;
        if (a.cache && a.cache.props) {
            var n = this.mangled_names = Object.create(null);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var r = [];
        var e = new qn(function(e, n) {
            if (e instanceof ke) {
                var t = s;
                n();
                s = t;
                return true;
            }
            if (e instanceof $e) {
                n();
                if (a.cache && e instanceof ze) {
                    e.globals.each(u);
                }
                e.variables.each(function(e) {
                    if (!f(e)) u(e);
                });
                return true;
            }
            if (e instanceof se) {
                var i;
                do {
                    i = y(++s);
                } while (b[i]);
                e.mangled_name = i;
                return true;
            }
            if (!a.ie8 && e instanceof Ge) {
                var r = e.argname.definition();
                var o = f(r, e.argname);
                n();
                if (!o) u(r);
                return true;
            }
        });
        this.walk(e);
        r.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function f(n, e) {
            var t = n.redefined();
            if (!t) return false;
            r.push(n);
            n.references.forEach(i);
            if (e) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
    });
    ze.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(null);
        t.reserved.forEach(r);
        this.globals.each(o);
        this.walk(new qn(function(e) {
            if (e instanceof $e) e.variables.each(o);
            if (e instanceof wn) o(e.definition());
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    ze.DEFMETHOD("expand_names", function(i) {
        y.reset();
        y.sort();
        i = m(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(o);
        this.walk(new qn(function(e) {
            if (e instanceof $e) e.variables.each(o);
            if (e instanceof wn) o(e.definition());
        }));
        function r() {
            var e;
            do {
                e = y(t++);
            } while (n[e] || b[e]);
            return e;
        }
        function o(e) {
            if (e.global && i.cache) return;
            if (e.unmangleable(i)) return;
            if (i.reserved.has[e.name]) return;
            var n = e.redefined();
            var t = n ? n.rename || n.name : r();
            e.rename = t;
            e.orig.forEach(function(e) {
                e.name = t;
            });
            e.references.forEach(function(e) {
                e.name = t;
            });
        }
    });
    me.DEFMETHOD("tail_node", O);
    tn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    ze.DEFMETHOD("compute_char_frequency", function(t) {
        t = m(t);
        y.reset();
        try {
            me.prototype.print = function(e, n) {
                this._print(e, n);
                if (this instanceof U && !this.unmangleable(t)) {
                    y.consider(this.name, -1);
                } else if (t.properties) {
                    if (this instanceof on) {
                        y.consider(this.property, -1);
                    } else if (this instanceof an) {
                        i(this.property);
                    }
                }
            };
            y.consider(this.print_to_string(), 1);
        } finally {
            me.prototype.print = me.prototype._print;
        }
        y.sort();
        function i(e) {
            if (e instanceof kn) {
                y.consider(e.value, -1);
            } else if (e instanceof ln) {
                i(e.consequent);
                i(e.alternative);
            } else if (e instanceof tn) {
                i(e.tail_node());
            }
        }
    });
    var y = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, o;
        function a() {
            o = Object.create(r);
        }
        u.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                o[e[t]] += n;
            }
        };
        function s(e, n) {
            return o[n] - o[e];
        }
        u.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        u.reset = a;
        a();
        function u(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return u;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var it = /^$|[;{][\s\n]*$/;
    function rt(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ot(u) {
        var e = !u;
        u = te(u, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var f = pe;
        if (u.comments) {
            var n = u.comments;
            if (typeof u.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(u.comments)) {
                var t = u.comments.lastIndexOf("/");
                n = new RegExp(u.comments.substr(1, t - 1), u.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                f = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                f = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                f = rt;
            } else {
                f = ee;
            }
        }
        var r = 0;
        var o = 0;
        var a = 1;
        var c = 0;
        var s = "";
        var l = u.ascii_only ? function(e, t) {
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0; t < e.length; t++) {
                if (jn(e[t]) && !Hn(e[t + 1]) || Hn(e[t]) && !jn(e[t - 1])) {
                    n += "\\u" + e.charCodeAt(t).toString(16);
                } else {
                    n += e[t];
                }
            }
            return n;
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return u.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (u.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return i > r ? n() : o();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (u.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        function h(e) {
            return K(" ", u.indent_start + r - e * u.indent_level);
        }
        var v = false;
        var _ = 0;
        var m = true;
        var g = false;
        var b = false;
        var y = false;
        var w = false;
        var x = -1;
        var A = "";
        var E, k, D = u.source_map && [];
        var F = D ? function(n, t) {
            D.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Q;
        var C = D ? function() {
            D.forEach(function(e) {
                u.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            D = [];
        } : Q;
        function B(e) {
            var n = s.lastIndexOf("\n");
            if (_ < n) _ = n;
            var t = s.slice(0, _);
            var i = s.slice(_);
            F(e, i.length - o);
            a += e;
            c += e;
            o = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var S = u.max_line_len ? function() {
            if (m) {
                if (o > u.max_line_len) {
                    me.warn("Output exceeds {max_line_len} characters", u);
                }
                return;
            }
            if (o > u.max_line_len) B(1);
            m = true;
            C();
        } : Q;
        var T = he("( [ + * / - , .");
        function O(e) {
            e = String(e);
            var n = e.charAt(0);
            if (y && n) {
                y = false;
                if (n != "\n") {
                    O("\n");
                    z();
                }
            }
            if (w && n) {
                w = false;
                if (!/[\s;})]/.test(n)) {
                    $();
                }
            }
            x = -1;
            var t = A.charAt(A.length - 1);
            if (b) {
                b = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (u.semicolons || T[n]) {
                        s += ";";
                        o++;
                        c++;
                    } else {
                        S();
                        s += "\n";
                        c++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            b = true;
                        }
                    }
                    if (!u.beautify) g = false;
                }
            }
            if (g) {
                if (Un(t) && (Un(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == A) {
                    s += " ";
                    o++;
                    c++;
                }
                g = false;
            }
            if (E) {
                D.push({
                    token: E,
                    name: k,
                    line: a,
                    col: o
                });
                E = false;
                if (m) C();
            }
            s += e;
            v = e[e.length - 1] == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            a += r;
            o += i[0].length;
            if (r > 0) {
                S();
                o = i[r].length;
            }
            A = e;
        }
        var $ = u.beautify ? function() {
            O(" ");
        } : function() {
            g = true;
        };
        var z = u.beautify ? function(e) {
            if (u.beautify) {
                O(h(e ? .5 : 0));
            }
        } : Q;
        var M = u.beautify ? function(e, n) {
            if (e === true) e = R();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = u.max_line_len || u.preserve_line ? function() {
            S();
            _ = s.length;
            m = false;
        } : Q;
        var j = u.beautify ? function() {
            if (x < 0) return O("\n");
            if (s[x] != "\n") {
                s = s.slice(0, x) + "\n" + s.slice(x);
                c++;
                a++;
            }
            x++;
        } : q;
        var H = u.beautify ? function() {
            O(";");
        } : function() {
            b = true;
        };
        function N() {
            b = false;
            O(";");
        }
        function R() {
            return r + u.indent_level;
        }
        function I(e) {
            var n;
            O("{");
            j();
            M(R(), function() {
                n = e();
            });
            z();
            O("}");
            return n;
        }
        function U(e) {
            O("(");
            q();
            var n = e();
            q();
            O(")");
            return n;
        }
        function P(e) {
            O("[");
            q();
            var n = e();
            q();
            O("]");
            return n;
        }
        function V() {
            q();
            O(",");
            q();
            $();
        }
        function L() {
            O(":");
            $();
        }
        var Y = D ? function(e, n) {
            E = e;
            k = n;
        } : Q;
        function J() {
            if (!m) S();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function G(e) {
            var i = this;
            var r = e instanceof Ne && e.value;
            var o = s(e);
            if (!o) return;
            if (r) {
                var a = new qn(function(e) {
                    var n = a.parent();
                    if (n instanceof Ne || n instanceof cn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof ln && n.condition === e || n instanceof on && n.expression === e || n instanceof tn && n.expressions[0] === e || n instanceof an && n.expression === e || n instanceof fn) {
                        var t = s(e);
                        if (t) o = o.concat(t);
                    } else {
                        return true;
                    }
                });
                a.push(e);
                e.value.walk(a);
            }
            if (c == 0) {
                if (o.length > 0 && u.shebang && o[0].type == "comment5") {
                    O("#!" + o.shift().value + "\n");
                    z();
                }
                var n = u.preamble;
                if (n) {
                    O(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            o = o.filter(f, e);
            if (o.length == 0) return;
            var t = W();
            o.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        O("\n");
                        z();
                        t = true;
                    } else if (n > 0) {
                        $();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    z();
                    t = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    O("\n");
                    z();
                } else {
                    $();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new ne();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function X(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof ge || ve(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var o = s.length;
            r.filter(f, e).forEach(function(e, n) {
                w = false;
                if (y) {
                    O("\n");
                    z();
                    y = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    O("\n");
                    z();
                } else if (n > 0 || !t) {
                    $();
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    y = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    w = true;
                }
            });
            if (s.length > o) x = o;
        }
        var Z = [];
        return {
            get: J,
            toString: J,
            indent: z,
            indentation: function() {
                return r;
            },
            current_width: function() {
                return o - r;
            },
            should_break: function() {
                return u.width && this.current_width() >= u.width;
            },
            has_parens: function() {
                return v;
            },
            newline: j,
            print: O,
            space: $,
            comma: V,
            colon: L,
            last: function() {
                return A;
            },
            semicolon: H,
            force_semicolon: N,
            to_utf8: l,
            print_name: function(e) {
                O(d(e));
            },
            print_string: function(e, n, t) {
                var i = p(e, n);
                if (t === true && i.indexOf("\\") === -1) {
                    if (!it.test(s)) {
                        N();
                    }
                    N();
                }
                O(i);
            },
            next_indent: R,
            with_indent: M,
            with_block: I,
            with_parens: U,
            with_square: P,
            add_mapping: Y,
            option: function(e) {
                return u[e];
            },
            prepend_comments: e ? Q : G,
            append_comments: e || f === pe ? Q : X,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                Z.push(e);
            },
            pop_node: u.preserve_line ? function() {
                var e = Z.pop();
                if (e.start && e.start.line > a) {
                    B(e.start.line - a);
                }
            } : function() {
                Z.pop();
            },
            parent: function(e) {
                return Z[Z.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var o = false;
        var a = null;
        var s = null;
        me.DEFMETHOD("print", function(e, n) {
            var t = this, i = t._codegen;
            if (t instanceof $e) {
                a = t;
            } else if (!s && t instanceof ye && t.value == "use asm") {
                s = a;
            }
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                i(t, e);
                e.append_comments(t);
            }
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            if (t === s) {
                s = null;
            }
        });
        me.DEFMETHOD("_print", me.prototype.print);
        me.DEFMETHOD("print_to_string", function(e) {
            var n = ot(e);
            this.print(n);
            return n.get();
        });
        function t(e, n) {
            if (Array.isArray(e)) {
                e.forEach(function(e) {
                    t(e, n);
                });
            } else {
                e.DEFMETHOD("needs_parens", n);
            }
        }
        t(me, pe);
        t(je, function(e) {
            if (!e.has_parens() && j(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof rn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof en && n.expression === this) return true;
            }
        });
        t(hn, function(e) {
            return !e.has_parens() && j(e);
        });
        t(sn, function(e) {
            var n = e.parent();
            return n instanceof rn && n.expression === this || n instanceof en && n.expression === this;
        });
        t(tn, function(e) {
            var n = e.parent();
            return n instanceof en || n instanceof sn || n instanceof cn || n instanceof Qe || n instanceof rn || n instanceof dn || n instanceof I || n instanceof ln;
        });
        t(cn, function(e) {
            var n = e.parent();
            if (n instanceof en && n.expression === this) return true;
            if (n instanceof sn) return true;
            if (n instanceof rn && n.expression === this) return true;
            if (n instanceof cn) {
                var t = n.operator, i = Qn[t];
                var r = this.operator, o = Qn[r];
                if (i > o || i == o && this === n.right) {
                    return true;
                }
            }
        });
        t(rn, function(e) {
            var n = e.parent();
            if (n instanceof nn && n.expression === this) {
                var t = false;
                this.walk(new qn(function(e) {
                    if (t || e instanceof $e) return true;
                    if (e instanceof en) {
                        t = true;
                        return true;
                    }
                }));
                return t;
            }
        });
        t(en, function(e) {
            var n = e.parent();
            if (n instanceof nn && n.expression === this) return true;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof je && n instanceof rn && n.expression === this && t instanceof pn && t.left === n;
            }
        });
        t(nn, function(e) {
            var n = e.parent();
            if (!h(this, e) && (n instanceof rn || n instanceof en && n.expression === this)) return true;
        });
        t(Dn, function(e) {
            var n = e.parent();
            if (n instanceof rn && n.expression === this) {
                var t = this.getValue();
                if (t < 0 || /^0/.test(_(t))) {
                    return true;
                }
            }
        });
        t([ pn, ln ], function(e) {
            var n = e.parent();
            if (n instanceof sn) return true;
            if (n instanceof cn && !(n instanceof pn)) return true;
            if (n instanceof en && n.expression === this) return true;
            if (n instanceof ln && n.condition === this) return true;
            if (n instanceof rn && n.expression === this) return true;
        });
        e(ye, function(e, n) {
            n.print_string(e.value, e.quote);
            n.semicolon();
        });
        e(be, function(e, n) {
            n.print("debugger");
            n.semicolon();
        });
        function i(e, t, i, n) {
            var r = e.length - 1;
            o = n;
            e.forEach(function(e, n) {
                if (o === true && !(e instanceof ye || e instanceof Ee || e instanceof we && e.body instanceof kn)) {
                    o = false;
                }
                if (!(e instanceof Ee)) {
                    i.indent();
                    e.print(i);
                    if (!(n == r && t)) {
                        i.newline();
                        if (t) i.newline();
                    }
                }
                if (o === true && e instanceof we && e.body instanceof kn) {
                    o = false;
                }
            });
            o = false;
        }
        g.DEFMETHOD("_do_print_body", function(e) {
            d(this.body, e);
        });
        e(ge, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        e(ze, function(e, n) {
            i(e.body, true, n, true);
            n.print("");
        });
        e(ke, function(e, n) {
            e.label.print(n);
            n.colon();
            e.body.print(n);
        });
        e(we, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        function r(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function u(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    i(e.body, false, n, t);
                });
            } else r(e, n);
        }
        e(Ae, function(e, n) {
            u(e, n);
        });
        e(Ee, function(e, n) {
            n.semicolon();
        });
        e(Ce, function(e, n) {
            n.print("do");
            n.space();
            m(e.body, n);
            n.space();
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.semicolon();
        });
        e(Be, function(e, n) {
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Se, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                if (e.init) {
                    if (e.init instanceof Ze) {
                        e.init.print(n);
                    } else {
                        l(e.init, n, true);
                    }
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.condition) {
                    e.condition.print(n);
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.step) {
                    e.step.print(n);
                }
            });
            n.space();
            e._do_print_body(n);
        });
        e(Te, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                e.init.print(n);
                n.space();
                n.print("in");
                n.space();
                e.object.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Oe, function(e, n) {
            n.print("with");
            n.space();
            n.with_parens(function() {
                e.expression.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        Me.DEFMETHOD("_do_print", function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            u(n, t, true);
        });
        e(Me, function(e, n) {
            e._do_print(n);
        });
        function f(e, n, t) {
            e.print(n);
            if (t) {
                e.space();
                t.print(e);
            }
            e.semicolon();
        }
        e(Re, function(e, n) {
            f(n, "return", e.value);
        });
        e(ie, function(e, n) {
            f(n, "throw", e.value);
        });
        e(Ue, function(e, n) {
            f(n, "break", e.label);
        });
        e(Pe, function(e, n) {
            f(n, "continue", e.label);
        });
        function c(e, n) {
            var t = e.body;
            if (n.option("braces") || n.option("ie8") && t instanceof Ce) return m(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof Ve) {
                    if (!t.alternative) {
                        m(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof g) {
                    t = t.body;
                } else break;
            }
            d(e.body, n);
        }
        e(Ve, function(e, n) {
            n.print("if");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            if (e.alternative) {
                c(e, n);
                n.space();
                n.print("else");
                n.space();
                if (e.alternative instanceof Ve) e.alternative.print(n); else d(e.alternative, n);
            } else {
                e._do_print_body(n);
            }
        });
        e(Le, function(e, t) {
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) r(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        R.DEFMETHOD("_do_print_body", function(n) {
            n.newline();
            this.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        });
        e(Ye, function(e, n) {
            n.print("default:");
            e._do_print_body(n);
        });
        e(Je, function(e, n) {
            n.print("case");
            n.space();
            e.expression.print(n);
            n.print(":");
            e._do_print_body(n);
        });
        e(We, function(e, n) {
            n.print("try");
            n.space();
            u(e, n);
            if (e.bcatch) {
                n.space();
                e.bcatch.print(n);
            }
            if (e.bfinally) {
                n.space();
                e.bfinally.print(n);
            }
        });
        e(Ge, function(e, n) {
            n.print("catch");
            n.space();
            n.with_parens(function() {
                e.argname.print(n);
            });
            n.space();
            u(e, n);
        });
        e(Xe, function(e, n) {
            n.print("finally");
            n.space();
            u(e, n);
        });
        e(Ke, function(e, t) {
            t.print("var");
            t.space();
            e.definitions.forEach(function(e, n) {
                if (n) t.comma();
                e.print(t);
            });
            var n = t.parent();
            if (n && n.init !== e || !(n instanceof Se || n instanceof Te)) t.semicolon();
        });
        function l(e, n, t) {
            var i = false;
            if (t) e.walk(new qn(function(e) {
                if (i || e instanceof $e) return true;
                if (e instanceof cn && e.operator == "in") {
                    i = true;
                    return true;
                }
            }));
            e.print(n, i);
        }
        e(Qe, function(e, n) {
            e.name.print(n);
            if (e.value) {
                n.space();
                n.print("=");
                n.space();
                var t = n.parent(1);
                var i = t instanceof Se || t instanceof Te;
                l(e.value, n, i);
            }
        });
        e(en, function(e, t) {
            e.expression.print(t);
            if (e instanceof nn && !h(e, t)) return;
            if (e.expression instanceof en || e.expression instanceof Me) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        });
        e(nn, function(e, n) {
            n.print("new");
            n.space();
            en.prototype._codegen(e, n);
        });
        e(tn, function(e, t) {
            e.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(on, function(e, n) {
            var t = e.expression;
            t.print(n);
            var i = e.property;
            if (n.option("ie8") && b[i]) {
                n.print("[");
                n.add_mapping(e.end);
                n.print_string(i);
                n.print("]");
            } else {
                if (t instanceof Dn && t.getValue() >= 0) {
                    if (!/[xa-f.)]/i.test(n.last())) {
                        n.print(".");
                    }
                }
                n.print(".");
                n.add_mapping(e.end);
                n.print_name(i);
            }
        });
        e(an, function(e, n) {
            e.expression.print(n);
            n.print("[");
            e.property.print(n);
            n.print("]");
        });
        e(un, function(e, n) {
            var t = e.operator;
            n.print(t);
            if (/^[a-z]/i.test(t) || /[+-]$/.test(t) && e.expression instanceof un && /^[+-]/.test(e.expression.operator)) {
                n.space();
            }
            e.expression.print(n);
        });
        e(fn, function(e, n) {
            e.expression.print(n);
            n.print(e.operator);
        });
        e(cn, function(e, n) {
            var t = e.operator;
            e.left.print(n);
            if (t[0] == ">" && e.left instanceof fn && e.left.operator == "--") {
                n.print(" ");
            } else {
                n.space();
            }
            n.print(t);
            if ((t == "<" || t == "<<") && e.right instanceof un && e.right.operator == "!" && e.right.expression instanceof un && e.right.expression.operator == "--") {
                n.print(" ");
            } else {
                n.space();
            }
            e.right.print(n);
        });
        e(ln, function(e, n) {
            e.condition.print(n);
            n.space();
            n.print("?");
            n.space();
            e.consequent.print(n);
            n.space();
            n.colon();
            e.alternative.print(n);
        });
        e(dn, function(n, i) {
            i.with_square(function() {
                var e = n.elements, t = e.length;
                if (t > 0) i.space();
                e.forEach(function(e, n) {
                    if (n) i.comma();
                    e.print(i);
                    if (n === t - 1 && e instanceof Tn) i.comma();
                });
                if (t > 0) i.space();
            });
        });
        e(hn, function(e, t) {
            if (e.properties.length > 0) t.with_block(function() {
                e.properties.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else r(e, t);
        });
        function p(e, n, t) {
            if (t.option("quote_keys")) {
                t.print_string(e);
            } else if ("" + +e == e && e >= 0) {
                t.print(_(e));
            } else if (b[e] ? !t.option("ie8") : Pn(e)) {
                if (n && t.option("keep_quoted_props")) {
                    t.print_string(e, n);
                } else {
                    t.print_name(e);
                }
            } else {
                t.print_string(e, n);
            }
        }
        e(vn, function(e, n) {
            p(e.key, e.quote, n);
            n.colon();
            e.value.print(n);
        });
        I.DEFMETHOD("_print_getter_setter", function(e, n) {
            n.print(e);
            n.space();
            p(this.key.name, this.quote, n);
            this.value._do_print(n, true);
        });
        e(re, function(e, n) {
            e._print_getter_setter("set", n);
        });
        e(oe, function(e, n) {
            e._print_getter_setter("get", n);
        });
        e(U, function(e, n) {
            var t = e.definition();
            n.print_name(t && t.mangled_name || e.name);
        });
        e(Tn, Q);
        e(An, function(e, n) {
            n.print("this");
        });
        e(En, function(e, n) {
            n.print(e.getValue());
        });
        e(kn, function(e, n) {
            n.print_string(e.getValue(), e.quote, o);
        });
        e(Dn, function(e, n) {
            if (s && e.start && e.start.raw != null) {
                n.print(e.start.raw);
            } else {
                n.print(_(e.getValue()));
            }
        });
        e(Fn, function(e, n) {
            var t = e.getValue();
            var i = t.toString();
            if (t.raw_source) {
                i = "/" + t.raw_source + i.slice(i.lastIndexOf("/"));
            }
            n.print(n.to_utf8(i).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = n.parent();
            if (r instanceof cn && /^in/.test(r.operator) && r.left === e) n.print(" ");
        });
        function d(e, n) {
            if (n.option("braces")) {
                m(e, n);
            } else {
                if (!e || e instanceof Ee) n.force_semicolon(); else e.print(n);
            }
        }
        function h(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function v(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function _(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, o;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                o = n.slice(r);
                t.push(o + "e-" + (o.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return v(t);
        }
        function m(e, n) {
            if (!e || e instanceof Ee) n.print("{}"); else if (e instanceof Ae) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function n(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        n([ me, ke, ze ], Q);
        n([ dn, Ae, Ge, En, be, Ze, ye, Xe, N, Me, nn, hn, g, U, Le, R, We ], function(e) {
            e.add_mapping(this.start);
        });
        n([ oe, re ], function(e) {
            e.add_mapping(this.start, this.key.name);
        });
        n([ I ], function(e) {
            e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function at(e, n) {
        if (!(this instanceof at)) return new at(e, n);
        tt.call(this, this.before, this.after);
        this.options = te(e, {
            arguments: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            negate_iife: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n
        }, true);
        var t = this.options["global_defs"];
        if (typeof t == "object") for (var i in t) {
            if (/^@/.test(i) && _e(t, i)) {
                t[i.slice(1)] = nt(t[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var r = this.options["keep_fargs"];
        this.drop_fargs = r == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        } : r ? pe : ee;
        var o = this.options["pure_funcs"];
        if (typeof o == "function") {
            this.pure_funcs = o;
        } else if (typeof o == "string") {
            this.pure_funcs = function(e) {
                return o !== e.expression.print_to_string();
            };
        } else if (Array.isArray(o)) {
            this.pure_funcs = function(e) {
                return !ce(e.expression.print_to_string(), o);
            };
        } else {
            this.pure_funcs = ee;
        }
        var a = this.options["sequences"];
        this.sequences_limit = a == 1 ? 800 : a | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return ce(e.name, s);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    at.prototype = new tt();
    t(at.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.global) for (var n = 0; n < e.orig.length; n++) if (!this.toplevel[e.orig[n] instanceof bn ? "funcs" : "vars"]) return true;
            return false;
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(r);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new qn(function() {
                        a++;
                    }));
                    me.info("pass " + o + ": last_count: " + t + ", count: " + a);
                    if (a < t) {
                        t = a;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof $e;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i) {
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(me, function(e, n) {
            return e;
        });
        me.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        $e.DEFMETHOD("process_expression", function(i, r) {
            var o = this;
            var a = new tt(function(e) {
                if (i && e instanceof we) {
                    return re(Re, e, {
                        value: e.body
                    });
                }
                if (!i && e instanceof Re) {
                    if (r) {
                        var n = e.value && e.value.drop_side_effect_free(r, true);
                        return n ? re(we, e, {
                            body: n
                        }) : re(Ee, e);
                    }
                    return re(we, e, {
                        body: e.value || re(un, e, {
                            operator: "void",
                            expression: re(Dn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Me && e !== o) {
                    return e;
                }
                if (e instanceof xe) {
                    var t = e.body.length - 1;
                    if (t >= 0) {
                        e.body[t] = e.body[t].transform(a);
                    }
                } else if (e instanceof Ve) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof Oe) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            o.transform(a);
        });
        function g(e, n) {
            var t = n.getProperty();
            if (t instanceof me) return;
            var i;
            if (e instanceof dn) {
                var r = e.elements;
                if (t == "length") return V(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof Me) {
                if (t == "length") {
                    e.length_read = true;
                    return V(e.argnames.length, e);
                }
            } else if (e instanceof hn) {
                t = "" + t;
                var o = e.properties;
                for (var a = o.length; --a >= 0; ) {
                    var s = o[a];
                    if (!(s instanceof vn)) return;
                    if (!i && o[a].key === t) i = o[a].value;
                }
            }
            return i instanceof xn && i.fixed_value() || i;
        }
        function c(e, n) {
            if (e instanceof $n) return v.Boolean[n];
            if (e instanceof Dn) return v.Number[n];
            if (e instanceof kn) return v.String[n];
            if (n == "valueOf") return false;
            if (e instanceof dn) return v.Array[n];
            if (e instanceof je) return v.Function[n];
            if (e instanceof hn) return v.Object[n];
            if (e instanceof Fn) return v.RegExp[n];
        }
        function ne(e, n, t, i, r, o) {
            var a = n.parent(r);
            if (e.option("unsafe") && a instanceof on && c(i, a.property)) {
                return;
            }
            var s = fe(t, a);
            if (s) return s;
            if (!o && a instanceof en && a.expression === t && !a.is_expr_pure(e) && (!(i instanceof je) || !(a instanceof nn) && i.contains_this())) {
                return true;
            }
            if (a instanceof dn) {
                return ne(e, n, a, a, r + 1);
            }
            if (a instanceof vn && t === a.value) {
                var u = n.parent(r + 1);
                return ne(e, n, u, u, r + 2);
            }
            if (a instanceof rn && a.expression === t) {
                var f = g(i, a);
                return !o && ne(e, n, a, f, r + 1);
            }
        }
        function te(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof gn;
        }
        (function(e) {
            e(me, Q);
            function i(e, n, t) {
                t.assignments = 0;
                t.chained = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof je && t.init !== t.scope) && t.init;
                if (t.fixed instanceof He && !ve(t.references, function(e) {
                    var n = e.scope;
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof je && (n = n.parent_scope));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function a(n, t, e) {
                e.variables.each(function(e) {
                    i(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        l(n, e, true);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        l(n, e, true);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Q;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof He && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
            }
            function s(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!p(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function u(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof He && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function f(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function c(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function l(e, n, t) {
                e.safe_ids[n.id] = t;
            }
            function p(e, n) {
                if (n.single_use == "m") return false;
                if (e.safe_ids[n.id]) {
                    if (n.fixed == null) {
                        if (te(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        n.fixed = re(Sn, n.orig);
                    }
                    return true;
                }
                return n.fixed instanceof He;
            }
            function d(e, n, t, i) {
                if (n.fixed === undefined) return true;
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (!_e(e.safe_ids, n.id)) return false;
                if (!p(e, n)) return false;
                if (n.fixed === false) return false;
                if (n.fixed != null && (!i || n.references.length > n.assignments)) return false;
                if (n.fixed instanceof He) {
                    return i instanceof me && n.fixed.parent_scope === t;
                }
                return ve(n.orig, function(e) {
                    return !(e instanceof bn || e instanceof yn);
                });
            }
            function h(e, n, t) {
                return n.option("unused") && !t.scope.pinned() && t.references.length - t.recursive_refs == 1 && e.loop_ids[t.id] === e.in_loop;
            }
            function v(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof Me || e instanceof An;
            }
            function _(e, n, t, i, r, o, a) {
                var s = e.parent(o);
                if (r && r.is_constant()) return;
                if (s instanceof pn && s.operator == "=" && i === s.right || s instanceof en && (i !== s.expression || s instanceof nn) || s instanceof Ne && i === s.value && i.scope !== n.scope || s instanceof Qe && i === s.value) {
                    n.escaped.push(s);
                    if (a > 1 && !(r && r.is_constant_expression(t))) a = 1;
                    if (!n.escaped.depth || n.escaped.depth > a) n.escaped.depth = a;
                    return;
                } else if (s instanceof dn || s instanceof cn && se[s.operator] || s instanceof ln && i !== s.condition || s instanceof tn && i === s.tail_node()) {
                    _(e, n, t, s, s, o + 1, a);
                } else if (s instanceof vn && i === s.value) {
                    var u = e.parent(o + 1);
                    _(e, n, t, u, u, o + 2, a);
                } else if (s instanceof rn && i === s.expression) {
                    r = g(r, s);
                    _(e, n, t, s, r, o + 1, a + 1);
                    if (r) return;
                }
                if (o > 0) return;
                if (s instanceof en && i === s.expression) return;
                if (s instanceof tn && i !== s.tail_node()) return;
                if (s instanceof we) return;
                if (s instanceof sn && !y[s.operator]) return;
                n.direct_access = true;
            }
            function m(e) {
                if (!(e instanceof an)) return;
                var n = e.expression;
                if (!(n instanceof xn)) return;
                var t = n.definition();
                if (te(t) && e.property instanceof Dn) t.reassigned = true;
            }
            var t = new qn(function(e) {
                if (!(e instanceof U)) return;
                var n = e.definition();
                if (!n) return;
                if (e instanceof xn) n.references.push(e);
                n.fixed = false;
            });
            e(qe, function(e, n, t) {
                f(e);
                a(e, t, this);
                n();
                c(e);
                u(e, this);
                return true;
            });
            e(pn, function(e, n, t) {
                var i = this;
                var r = i.left;
                if (!(r instanceof xn)) {
                    m(r);
                    return;
                }
                if (r.fixed) delete r.fixed;
                var o = r.definition();
                var a = d(e, o, r.scope, i.right);
                o.assignments++;
                var s = o.fixed;
                if (!s && i.operator != "=") return;
                var u = i.operator == "=";
                var f = u ? i.right : i;
                if (ne(t, e, i, f, 0)) return;
                if (!u) o.chained = true;
                r.fixed = o.fixed = u ? function() {
                    return i.right;
                } : function() {
                    return re(cn, i, {
                        operator: i.operator.slice(0, -1),
                        left: s instanceof me ? s : s(),
                        right: i.right
                    });
                };
                if (!a) return;
                o.references.push(r);
                l(e, o, false);
                i.right.walk(e);
                l(e, o, true);
                if (u) _(e, o, r.scope, i, f, 0, 1);
                return true;
            });
            e(cn, function(e) {
                if (!se[this.operator]) return;
                this.left.walk(e);
                f(e);
                this.right.walk(e);
                c(e);
                return true;
            });
            e(en, function(e, n) {
                e.find_parent($e).may_call_this();
                var t = this.expression;
                if (!(t instanceof xn)) return;
                var i = t.definition();
                if (!(i.fixed instanceof He)) return;
                var r = s(e, i);
                if (!r) return;
                n();
                r.walk(e);
                return true;
            });
            e(Je, function(e) {
                f(e);
                this.expression.walk(e);
                c(e);
                f(e);
                H(this, e);
                c(e);
                return true;
            });
            e(ln, function(e) {
                this.condition.walk(e);
                f(e);
                this.consequent.walk(e);
                c(e);
                f(e);
                this.alternative.walk(e);
                c(e);
                return true;
            });
            e(Ye, function(e, n) {
                f(e);
                n();
                c(e);
                return true;
            });
            e(He, function(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                f(e);
                a(e, t, this);
                n();
                c(e);
                u(e, this);
                return true;
            });
            e(Ce, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                this.body.walk(e);
                if (w(this)) {
                    c(e);
                    f(e);
                }
                this.condition.walk(e);
                c(e);
                e.in_loop = n;
                return true;
            });
            e(Se, function(e) {
                if (this.init) this.init.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                if (this.condition) this.condition.walk(e);
                this.body.walk(e);
                if (this.step) {
                    if (w(this)) {
                        c(e);
                        f(e);
                    }
                    this.step.walk(e);
                }
                c(e);
                e.in_loop = n;
                return true;
            });
            e(Te, function(e) {
                this.init.walk(t);
                this.object.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                this.body.walk(e);
                c(e);
                e.in_loop = n;
                return true;
            });
            e(je, function(i, e, n) {
                var r = this;
                r.inlined = false;
                f(i);
                a(i, n, r);
                var o;
                if (!r.name && (o = i.parent()) instanceof en && o.expression === r) {
                    r.argnames.forEach(function(e, n) {
                        var t = e.definition();
                        if (t.fixed === undefined && (!r.uses_arguments || i.has_directive("use strict"))) {
                            t.fixed = function() {
                                return o.args[n] || re(Sn, o);
                            };
                            i.loop_ids[t.id] = i.in_loop;
                            l(i, t, true);
                        } else {
                            t.fixed = false;
                        }
                    });
                }
                e();
                c(i);
                u(i, r);
                return true;
            });
            e(Ve, function(e) {
                this.condition.walk(e);
                f(e);
                this.body.walk(e);
                c(e);
                if (this.alternative) {
                    f(e);
                    this.alternative.walk(e);
                    c(e);
                }
                return true;
            });
            e(ke, function(e) {
                f(e);
                this.body.walk(e);
                c(e);
                return true;
            });
            e(wn, function() {
                this.definition().fixed = false;
            });
            e(xn, function(e, n, t) {
                if (this.fixed) delete this.fixed;
                var i = this.definition();
                i.references.push(this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof bn) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                var r;
                if (i.fixed === undefined || !p(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    r = this.fixed_value();
                    if (Z(e, i)) {
                        i.recursive_refs++;
                    } else if (r && h(e, t, i)) {
                        i.single_use = r instanceof Me && !r.pinned() || i.scope === this.scope && r.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (ne(t, e, this, r, 0, v(r))) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    _(e, i, this.scope, this, r, 0, 1);
                }
                var o;
                if (i.fixed instanceof He && !((o = e.parent()) instanceof en && o.expression === this)) {
                    var a = s(e, i);
                    if (a) a.walk(e);
                }
            });
            e(ze, function(n, e, t) {
                this.globals.each(function(e) {
                    i(n, t, e);
                });
                f(n);
                a(n, t, this);
                e();
                c(n);
                u(n, this);
                return true;
            });
            e(We, function(e) {
                f(e);
                H(this, e);
                c(e);
                if (this.bcatch) {
                    f(e);
                    this.bcatch.walk(e);
                    c(e);
                }
                if (this.bfinally) this.bfinally.walk(e);
                return true;
            });
            e(sn, function(e, n) {
                var t = this;
                if (!ue[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof xn)) {
                    m(i);
                    return;
                }
                if (i.fixed) delete i.fixed;
                var r = i.definition();
                var o = d(e, r, i.scope, true);
                r.assignments++;
                var a = r.fixed;
                if (!a) return;
                r.chained = true;
                i.fixed = r.fixed = function() {
                    return re(cn, t, {
                        operator: t.operator.slice(0, -1),
                        left: re(un, t, {
                            operator: "+",
                            expression: a instanceof me ? a : a()
                        }),
                        right: re(Dn, t, {
                            value: 1
                        })
                    });
                };
                if (!o) return;
                r.references.push(i);
                l(e, r, true);
                return true;
            });
            e(Qe, function(e, n) {
                var t = this;
                var i = t.name.definition();
                if (t.value) {
                    if (d(e, i, t.name.scope, t.value)) {
                        i.fixed = function() {
                            return t.value;
                        };
                        e.loop_ids[i.id] = e.in_loop;
                        l(e, i, false);
                        n();
                        l(e, i, true);
                        return true;
                    } else {
                        i.fixed = false;
                    }
                }
            });
            e(Be, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                f(e);
                n();
                c(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        ze.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new qn(t.option("reduce_vars") ? function(e, n) {
                e._squeezed = false;
                e._optimized = false;
                return e.reduce_vars(i, n, t);
            } : function(e) {
                e._squeezed = false;
                e._optimized = false;
            });
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        U.DEFMETHOD("fixed_value", function(e) {
            var n = this.definition().fixed;
            if (!n) return n;
            if (!e && this.fixed) n = this.fixed;
            return n instanceof me ? n : n();
        });
        xn.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof yn && e.scope.name === n;
        });
        function ie(e, n) {
            if (e instanceof An) return true;
            if (e instanceof xn) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && W[t.name];
            }
            if (e instanceof rn) {
                e = e.expression;
                if (e instanceof xn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return ie(e, n);
            }
            return false;
        }
        function o(e, n) {
            var t, i = 0;
            while (t = e.parent(i++)) {
                if (t instanceof $e) break;
                if (t instanceof Ge) {
                    t = t.argname.definition().scope;
                    break;
                }
            }
            return t.find_variable(n);
        }
        function re(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function P(e, n) {
            if (n.length == 1) return n[0];
            return re(tn, e, {
                expressions: n.reduce(h, [])
            });
        }
        function V(e, n) {
            switch (typeof e) {
              case "string":
                return re(kn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return re(Bn, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? re(un, n, {
                        operator: "-",
                        expression: re(Dn, n, {
                            value: -e
                        })
                    }) : re(Dn, n, {
                        value: e
                    });
                }
                return e < 0 ? re(un, n, {
                    operator: "-",
                    expression: re(On, n)
                }) : re(On, n);

              case "boolean":
                return re(e ? Mn : zn, n);

              case "undefined":
                return re(Sn, n);

              default:
                if (e === null) {
                    return re(Cn, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return re(Fn, n, {
                        value: e
                    });
                }
                throw new Error(z("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function a(e, n) {
            return n instanceof rn || e.has_directive("use strict") && J(n) && n.name == "eval";
        }
        function oe(e, n, t, i) {
            if (n instanceof un && n.operator == "delete" || n.TYPE == "Call" && n.expression === t && a(e, i)) {
                return P(t, [ re(Dn, t, {
                    value: 0
                }), i ]);
            }
            return i;
        }
        function h(e, n) {
            if (n instanceof tn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function x(e) {
            if (e === null) return [];
            if (e instanceof Ae) return e.body;
            if (e instanceof Ee) return [];
            if (e instanceof ge) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function L(e) {
            if (e === null) return true;
            if (e instanceof Ee) return true;
            if (e instanceof Ae) return e.body.length == 0;
            return false;
        }
        function A(e) {
            if (e instanceof De) {
                return e.body instanceof Ae ? e.body : e;
            }
            return e;
        }
        function ae(e) {
            while (e instanceof rn) e = e.expression;
            return e;
        }
        function Y(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof je || Y(e.expression);
        }
        function J(e) {
            return e instanceof xn && e.definition().undeclared;
        }
        var n = he("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        xn.DEFMETHOD("is_declared", function(e) {
            return !this.definition().undeclared || e.option("unsafe") && n[this.name];
        });
        var W = he("Infinity NaN undefined");
        function s(e) {
            return e instanceof On || e instanceof Bn || e instanceof Sn;
        }
        function i(e, u) {
            var Z, K, Q;
            t();
            var ee, n = 10;
            do {
                ee = false;
                r(e);
                if (u.option("dead_code")) {
                    a(e, u);
                }
                if (u.option("if_return")) {
                    o(e, u);
                }
                if (u.sequences_limit > 0) {
                    s(e, u);
                    f(e, u);
                }
                if (u.option("join_vars")) {
                    d(e);
                }
                if (u.option("collapse_vars")) {
                    i(e, u);
                }
            } while (ee && n-- > 0);
            function t() {
                var e = u.self(), n = 0;
                do {
                    if (e instanceof Ge || e instanceof Xe) {
                        n++;
                    } else if (e instanceof De) {
                        Z = true;
                    } else if (e instanceof $e) {
                        Q = e;
                        break;
                    } else if (e instanceof We) {
                        K = true;
                    }
                } while (e = u.parent(n++));
            }
            function i(t, u) {
                if (Q.pinned()) return t;
                var f;
                var c = [];
                var o = t.length;
                var a = new tt(function(e) {
                    if (E) return e;
                    if (!A) {
                        if (e !== s[l]) return e;
                        l++;
                        if (l < s.length) return B(e);
                        A = true;
                        h = M(e, 0);
                        if (h === e) E = true;
                        return e;
                    }
                    var n = a.parent();
                    if (S(e, n)) {
                        E = true;
                        return e;
                    }
                    if (!v && T(e, n)) {
                        v = n;
                    }
                    var t;
                    if (D && !(e instanceof _n) && (m && _.equivalent_to(e) || g && (t = g(e, this)))) {
                        if (v && (t || !b || !y)) {
                            E = true;
                            return e;
                        }
                        if (fe(e, n)) {
                            if (d) k++;
                            return e;
                        } else {
                            k++;
                            if (d && p instanceof Qe) return e;
                        }
                        ee = E = true;
                        me.info("Collapsing {name} [{file}:{line},{col}]", {
                            name: e.print_to_string(),
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (p instanceof fn) {
                            return re(un, p, p);
                        }
                        if (p instanceof Qe) {
                            var i = p.name.definition();
                            if (i.references.length - i.replaced == 1 && !u.exposed(i)) {
                                i.replaced++;
                                return oe(u, n, e, p.value);
                            }
                            return re(pn, p, {
                                operator: "=",
                                left: re(xn, p.name, p.name),
                                right: p.value
                            });
                        }
                        p.write_only = false;
                        return p;
                    }
                    var r;
                    if (O(e, n) || w(e)) {
                        h = e;
                        if (e instanceof $e) E = true;
                    }
                    return B(e);
                }, function(e) {
                    if (E) return;
                    if (h === e) E = true;
                    if (v === e) v = null;
                });
                var n = new tt(function(e) {
                    if (E) return e;
                    if (!A) {
                        if (e !== s[l]) return e;
                        l++;
                        if (l < s.length) return;
                        A = true;
                        return e;
                    }
                    if (e instanceof xn && e.name == C.name) {
                        if (!--k) E = true;
                        if (fe(e, n.parent())) return e;
                        C.replaced++;
                        d.replaced--;
                        return p.value.clone();
                    }
                    if (e instanceof Ye || e instanceof $e) return e;
                });
                while (--o >= 0) {
                    if (o == 0 && u.option("unused")) $();
                    var s = [];
                    z(t[o]);
                    while (c.length > 0) {
                        s = c.pop();
                        var l = 0;
                        var p = s[s.length - 1];
                        var d = null;
                        var h = null;
                        var v = null;
                        var _ = j(p);
                        var i = _ && _.has_side_effects(u);
                        var m = _ && !i && !ie(_, u);
                        var g = I(H(p));
                        if (!m && !g) continue;
                        var r = P(p);
                        var b = L(_);
                        if (!i) i = Y(p);
                        var y = J();
                        var w = p.may_throw(u) ? K ? function(e) {
                            return e.has_side_effects(u);
                        } : X : pe;
                        var x = p.name instanceof gn;
                        var A = x;
                        var E = false, k = 0, D = !f || !A;
                        if (!D) {
                            for (var e = u.self().argnames.lastIndexOf(p.name) + 1; !E && e < f.length; e++) {
                                f[e].transform(a);
                            }
                            D = true;
                        }
                        for (var F = o; !E && F < t.length; F++) {
                            t[F].transform(a);
                        }
                        if (d) {
                            var C = p.name.definition();
                            if (E && C.references.length - C.replaced > k) k = false; else {
                                E = false;
                                l = 0;
                                A = x;
                                for (var F = o; !E && F < t.length; F++) {
                                    t[F].transform(n);
                                }
                                d.single_use = false;
                            }
                        }
                        if (k && !V(p)) t.splice(o, 1);
                    }
                }
                function B(e) {
                    if (e instanceof $e) return e;
                    if (e instanceof Le) {
                        e.expression = e.expression.transform(a);
                        for (var n = 0; !E && n < e.body.length; n++) {
                            var t = e.body[n];
                            if (t instanceof Je) {
                                if (!A) {
                                    if (t !== s[l]) continue;
                                    l++;
                                }
                                t.expression = t.expression.transform(a);
                                if (!y) break;
                            }
                        }
                        E = true;
                        return e;
                    }
                }
                function S(e, n) {
                    if (n instanceof Se) return e !== n.init;
                    if (e instanceof pn) {
                        return e.operator != "=" && _.equivalent_to(e.left);
                    }
                    if (e instanceof en) {
                        return _ instanceof rn && _.equivalent_to(e.expression);
                    }
                    if (e instanceof be) return true;
                    if (e instanceof He) return x && _.name === e.name.name;
                    if (e instanceof De) return !(e instanceof Se);
                    if (e instanceof Ie) return true;
                    if (e instanceof We) return true;
                    if (e instanceof Oe) return true;
                    if (y) return false;
                    return e instanceof xn && !e.is_declared(u) && !(n instanceof pn && n.left === e);
                }
                function T(e, n) {
                    if (n instanceof cn) return se[n.operator] && n.left !== e;
                    if (n instanceof ln) return n.condition !== e;
                    return n instanceof Ve && n.condition !== e;
                }
                function O(e, n) {
                    if (e instanceof en) return true;
                    if (e instanceof Ne) {
                        return i || _ instanceof rn || G(_);
                    }
                    if (e instanceof je) {
                        return u.option("ie8") && e.name && e.name.name in r;
                    }
                    if (e instanceof rn) {
                        return i || e.expression.may_throw_on_access(u);
                    }
                    if (e instanceof xn) {
                        if (W(e, n)) {
                            return !n || n.operator != "=" || n.left !== e;
                        }
                        return i && G(e);
                    }
                    if (e instanceof An) return W(e, n);
                    if (e instanceof Qe) {
                        if (!e.value) return false;
                        return e.name.name in r || i && G(e.name);
                    }
                    var t = fe(e.left, e);
                    if (t && t.name in r) return true;
                    if (t instanceof rn) return true;
                }
                function $() {
                    var e, t = u.self();
                    if (t instanceof je && !t.name && !t.uses_arguments && !t.pinned() && (e = u.parent()) instanceof en && e.expression === t) {
                        var i = u.has_directive("use strict");
                        if (i && !ce(i, t.body)) i = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var r = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(re(Qe, a, {
                                name: a,
                                value: s
                            }));
                            if (a.name in r) continue;
                            r[a.name] = true;
                            if (!s) {
                                s = re(Sn, a).transform(u);
                            } else if (s instanceof Me && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new qn(function(e) {
                                    if (!s) return true;
                                    if (e instanceof xn && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== Q) while (n = n.parent_scope) {
                                            if (n === Q) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof An && (i || !this.find_parent($e))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) c.unshift([ re(Qe, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function z(e) {
                    s.push(e);
                    if (e instanceof pn) {
                        c.push(s.slice());
                        z(e.left);
                        z(e.right);
                    } else if (e instanceof cn) {
                        z(e.left);
                        z(e.right);
                    } else if (e instanceof en) {
                        z(e.expression);
                        e.args.forEach(z);
                    } else if (e instanceof Je) {
                        z(e.expression);
                    } else if (e instanceof ln) {
                        z(e.condition);
                        z(e.consequent);
                        z(e.alternative);
                    } else if (e instanceof Ze) {
                        e.definitions.forEach(z);
                    } else if (e instanceof on) {
                        z(e.expression);
                    } else if (e instanceof Fe) {
                        z(e.condition);
                        if (!(e.body instanceof xe)) {
                            z(e.body);
                        }
                    } else if (e instanceof Ne) {
                        if (e.value) z(e.value);
                    } else if (e instanceof Se) {
                        if (e.init) z(e.init);
                        if (e.condition) z(e.condition);
                        if (e.step) z(e.step);
                        if (!(e.body instanceof xe)) {
                            z(e.body);
                        }
                    } else if (e instanceof Te) {
                        z(e.object);
                        if (!(e.body instanceof xe)) {
                            z(e.body);
                        }
                    } else if (e instanceof Ve) {
                        z(e.condition);
                        if (!(e.body instanceof xe)) {
                            z(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof xe)) {
                            z(e.alternative);
                        }
                    } else if (e instanceof tn) {
                        e.expressions.forEach(z);
                    } else if (e instanceof we) {
                        z(e.body);
                    } else if (e instanceof an) {
                        z(e.expression);
                        z(e.property);
                    } else if (e instanceof Le) {
                        z(e.expression);
                        e.body.forEach(z);
                    } else if (e instanceof sn) {
                        if (ue[e.operator]) {
                            c.push(s.slice());
                        } else {
                            z(e.expression);
                        }
                    } else if (e instanceof Qe) {
                        if (e.value) {
                            var n = e.name.definition();
                            if (n.references.length > n.replaced) {
                                c.push(s.slice());
                            }
                            z(e.value);
                        }
                    }
                    s.pop();
                }
                function M(e, n, t) {
                    var i = a.parent(n);
                    if (i instanceof pn) {
                        if (t && !(i.left instanceof rn || i.left.name in r)) {
                            return M(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof cn) {
                        if (t && (!se[i.operator] || i.left === e)) {
                            return M(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof en) return e;
                    if (i instanceof Je) return e;
                    if (i instanceof ln) {
                        if (t && i.condition === e) {
                            return M(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof Ze) {
                        return M(i, n + 1, true);
                    }
                    if (i instanceof Ne) {
                        return t ? M(i, n + 1, t) : e;
                    }
                    if (i instanceof Ve) {
                        if (t && i.condition === e) {
                            return M(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof De) return e;
                    if (i instanceof rn) return e;
                    if (i instanceof tn) {
                        return M(i, n + 1, i.tail_node() !== e);
                    }
                    if (i instanceof we) {
                        return M(i, n + 1, true);
                    }
                    if (i instanceof Le) return e;
                    if (i instanceof sn) return e;
                    if (i instanceof Qe) return e;
                    return null;
                }
                function q(e) {
                    var n = e.value;
                    if (!(n instanceof xn)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (te(t)) return;
                    return d = t;
                }
                function j(e) {
                    if (e instanceof Qe) {
                        var n = e.name.definition();
                        if (!ce(e.name, n.orig)) return;
                        var t = n.references.length - n.replaced;
                        var i = n.orig.length - n.eliminated;
                        if (i > 1 && !(e.name instanceof gn) || (t > 1 ? q(e) : !u.exposed(n))) {
                            return re(xn, e.name, e.name);
                        }
                    } else {
                        return e[e instanceof pn ? "left" : "expression"];
                    }
                }
                function H(e) {
                    return p instanceof pn && p.operator == "=" && p.right;
                }
                function N(e) {
                    return e[e instanceof pn ? "right" : "value"];
                }
                function R(e) {
                    if (e instanceof dn) return false;
                    if (e instanceof cn && se[e.operator]) {
                        return R(e.left) && R(e.right);
                    }
                    if (e instanceof en) return false;
                    if (e instanceof ln) {
                        return R(e.consequent) && R(e.alternative);
                    }
                    if (e instanceof hn) return false;
                    return !e.has_side_effects(u);
                }
                function I(n) {
                    if (!n) return false;
                    if (n instanceof xn) {
                        var e = n.evaluate(u);
                        if (e === n) return r;
                        return U(e, r);
                    }
                    if (n instanceof An) return r;
                    if (n.is_truthy()) return U(true, pe);
                    if (n.is_constant()) {
                        return U(n.evaluate(u), r);
                    }
                    if (!(_ instanceof xn)) return false;
                    if (!R(n)) return false;
                    var t;
                    var i = _.definition();
                    n.walk(new qn(function(e) {
                        if (t) return true;
                        if (e instanceof xn && e.definition() === i) {
                            t = true;
                        }
                    }));
                    return !t && r;
                    function r(e) {
                        return n.equivalent_to(e);
                    }
                }
                function U(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(u)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(u) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function P(e) {
                    var t = Object.create(null);
                    if (p instanceof Qe) {
                        t[p.name.name] = _;
                    }
                    var i = new qn(function(e) {
                        var n;
                        if (e instanceof xn) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof An) {
                            n = e;
                        }
                        if (n && !t[e.name]) {
                            t[e.name] = ne(u, i, e, n, 0);
                        }
                    });
                    e.walk(i);
                    return t;
                }
                function V(i) {
                    if (i.name instanceof gn) {
                        var e = u.self().argnames.indexOf(i.name);
                        var n = u.parent().args;
                        if (n[e]) n[e] = re(Dn, n[e], {
                            value: 0
                        });
                        return true;
                    }
                    var r = false;
                    return t[o].transform(new tt(function(e, n, t) {
                        if (r) return e;
                        if (e !== i && e.body !== i) return;
                        if (e instanceof Qe) {
                            r = true;
                            e.value = null;
                            return e;
                        }
                        if (t) {
                            r = true;
                            return de.skip;
                        }
                        if (!this.parent()) {
                            r = true;
                            return null;
                        }
                    }, function(e) {
                        if (e instanceof tn) switch (e.expressions.length) {
                          case 0:
                            return null;

                          case 1:
                            return e.expressions[0];
                        }
                    }));
                }
                function L(e) {
                    var n = ae(e);
                    return n instanceof xn && n.definition().scope === Q && !(Z && (n.name in r && r[n.name] !== e || p instanceof sn || p instanceof pn && p.operator != "="));
                }
                function Y(e) {
                    if (e instanceof sn) return false;
                    return N(e).has_side_effects(u);
                }
                function J() {
                    if (i) return false;
                    if (d) return true;
                    if (_ instanceof xn) {
                        var e = _.definition();
                        if (e.references.length - e.replaced == (p instanceof Qe ? 1 : 2)) {
                            return true;
                        }
                    }
                    return false;
                }
                function W(e, n) {
                    var t = r[e.name];
                    if (!t) return;
                    if (t !== _) return !(n instanceof en && n.expression === e);
                    g = false;
                }
                function G(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof bn) return false;
                    if (n.scope !== Q) return true;
                    return !ve(n.references, function(e) {
                        return e.scope.resolve() === Q;
                    });
                }
                function X(e, n) {
                    if (e instanceof pn) return X(e.left, true);
                    if (e instanceof sn) return X(e.expression, true);
                    if (e instanceof Qe) return e.value && X(e.value);
                    if (n) {
                        if (e instanceof on) return X(e.expression, true);
                        if (e instanceof an) return X(e.expression, true);
                        if (e instanceof xn) return e.definition().scope !== Q;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof Ae) {
                        ee = true;
                        r(i.body);
                        [].splice.apply(e, [ t, 1 ].concat(i.body));
                        t += i.body.length;
                    } else if (i instanceof Ee) {
                        ee = true;
                        e.splice(t, 1);
                    } else if (i instanceof ye) {
                        if (!ce(i.value, n)) {
                            t++;
                            n.push(i.value);
                        } else {
                            ee = true;
                            e.splice(t, 1);
                        }
                    } else t++;
                }
            }
            function o(i, t) {
                var r = t.self();
                var e = h(i);
                var o = r instanceof Me;
                for (var n = i.length; --n >= 0; ) {
                    var a = i[n];
                    var s = b(n);
                    var u = i[s];
                    if (o && !u && a instanceof Re) {
                        if (!a.value) {
                            ee = true;
                            i.splice(n, 1);
                            continue;
                        }
                        if (a.value instanceof un && a.value.operator == "void") {
                            ee = true;
                            i[n] = re(we, a, {
                                body: a.value.expression
                            });
                            continue;
                        }
                    }
                    if (a instanceof Ve) {
                        var f = D(a.body);
                        if (_(f)) {
                            if (f.label) {
                                M(f.label.thedef.references, f);
                            }
                            ee = true;
                            a = a.clone();
                            a.condition = a.condition.negate(t);
                            var c = g(a.body, f);
                            a.body = re(Ae, a, {
                                body: x(a.alternative).concat(m())
                            });
                            a.alternative = re(Ae, a, {
                                body: c
                            });
                            i[n] = a.transform(t);
                            continue;
                        }
                        if (f && !a.alternative && a.body instanceof Ae && u instanceof N) {
                            var l = a.condition.negate(t);
                            if (l.print_to_string().length <= a.condition.print_to_string().length) {
                                ee = true;
                                a = a.clone();
                                a.condition = l;
                                i[s] = a.body;
                                a.body = u;
                                i[n] = a.transform(t);
                                continue;
                            }
                        }
                        var f = D(a.alternative);
                        if (_(f)) {
                            if (f.label) {
                                M(f.label.thedef.references, f);
                            }
                            ee = true;
                            a = a.clone();
                            a.body = re(Ae, a.body, {
                                body: x(a.body).concat(m())
                            });
                            var c = g(a.alternative, f);
                            a.alternative = re(Ae, a.alternative, {
                                body: c
                            });
                            i[n] = a.transform(t);
                            continue;
                        }
                    }
                    if (a instanceof Ve && a.body instanceof Re) {
                        var p = a.body.value;
                        if (!p && !a.alternative && (o && !u || u instanceof Re && !u.value)) {
                            ee = true;
                            i[n] = re(we, a.condition, {
                                body: a.condition
                            });
                            continue;
                        }
                        if (p && !a.alternative && u instanceof Re && u.value) {
                            ee = true;
                            a = a.clone();
                            a.alternative = u;
                            i.splice(n, 1, a.transform(t));
                            i.splice(s, 1);
                            continue;
                        }
                        if (p && !a.alternative && (!u && o && e || u instanceof Re)) {
                            ee = true;
                            a = a.clone();
                            a.alternative = u || re(Re, a, {
                                value: null
                            });
                            i.splice(n, 1, a.transform(t));
                            if (u) i.splice(s, 1);
                            continue;
                        }
                        var d = i[y(n)];
                        if (t.option("sequences") && o && !a.alternative && d instanceof Ve && d.body instanceof Re && b(s) == i.length && u instanceof we) {
                            ee = true;
                            a = a.clone();
                            a.alternative = re(Ae, u, {
                                body: [ u, re(Re, u, {
                                    value: null
                                }) ]
                            });
                            i.splice(n, 1, a.transform(t));
                            i.splice(s, 1);
                            continue;
                        }
                    }
                }
                function h(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof Ve && i.body instanceof Re) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function v(e) {
                    return !e || e instanceof un && e.operator == "void";
                }
                function _(e) {
                    if (!e) return false;
                    var n = e instanceof Ie ? t.loopcontrol_target(e) : null;
                    return e instanceof Re && o && v(e.value) || e instanceof Pe && r === A(n) || e instanceof Ue && n instanceof Ae && r === n;
                }
                function m() {
                    var e = i.slice(n + 1);
                    i.length = n + 1;
                    return e.filter(function(e) {
                        if (e instanceof He) {
                            i.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function g(e, n) {
                    var t = x(e).slice(0, -1);
                    if (n.value) {
                        t.push(re(we, n.value, {
                            body: n.value.expression
                        }));
                    }
                    return t;
                }
                function b(e) {
                    for (var n = e + 1; n < i.length; n++) {
                        var t = i[n];
                        if (!(t instanceof Ke && w(t))) {
                            break;
                        }
                    }
                    return n;
                }
                function y(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = i[n];
                        if (!(t instanceof Ke && w(t))) {
                            break;
                        }
                    }
                    return n;
                }
            }
            function a(n, e) {
                var t;
                var i = e.self();
                for (var r = 0, o = 0, a = n.length; r < a; r++) {
                    var s = n[r];
                    if (s instanceof Ie) {
                        var u = e.loopcontrol_target(s);
                        if (s instanceof Ue && !(u instanceof De) && A(u) === i || s instanceof Pe && A(u) === i) {
                            if (s.label) {
                                M(s.label.thedef.references, s);
                            }
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (D(s)) {
                        t = n.slice(r + 1);
                        break;
                    }
                }
                n.length = o;
                ee = o != a;
                if (t) t.forEach(function(e) {
                    b(e, n);
                });
            }
            function w(e) {
                return ve(e.definitions, function(e) {
                    return !e.value;
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = P(t[0], t);
                    n[i++] = re(we, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof we) {
                        if (t.length >= e.sequences_limit) r();
                        var u = s.body;
                        if (t.length > 0) u = u.drop_side_effect_free(e);
                        if (u) h(t, u);
                    } else if (s instanceof Ze && w(s) || s instanceof He) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != a) ee = true;
            }
            function p(e, n) {
                if (!(e instanceof Ae)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Ke && w(r)) {
                        n.push(r);
                    } else if (t) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function f(e, n) {
                function t(e) {
                    i--;
                    ee = true;
                    var n = r.body;
                    return P(n, [ n, e ]);
                }
                var i = 0, r;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (r) {
                        if (a instanceof Ne) {
                            a.value = t(a.value || re(Sn, a)).transform(n);
                        } else if (a instanceof Se) {
                            if (!(a.init instanceof Ze)) {
                                var s = false;
                                r.body.walk(new qn(function(e) {
                                    if (s || e instanceof $e) return true;
                                    if (e instanceof cn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = t(a.init); else {
                                        a.init = r.body;
                                        i--;
                                        ee = true;
                                    }
                                }
                            }
                        } else if (a instanceof Te) {
                            a.object = t(a.object);
                        } else if (a instanceof Ve) {
                            a.condition = t(a.condition);
                        } else if (a instanceof Le) {
                            a.expression = t(a.expression);
                        } else if (a instanceof Oe) {
                            a.expression = t(a.expression);
                        }
                    }
                    if (n.option("conditionals") && a instanceof Ve) {
                        var u = [];
                        var f = p(a.body, u);
                        var c = p(a.alternative, u);
                        if (f !== false && c !== false && u.length > 0) {
                            var l = u.length;
                            u.push(re(Ve, a, {
                                condition: a.condition,
                                body: f || re(Ee, a.body),
                                alternative: c
                            }));
                            u.unshift(i, 1);
                            [].splice.apply(e, u);
                            o += l;
                            i += l + 1;
                            r = null;
                            ee = true;
                            continue;
                        }
                    }
                    e[i++] = a;
                    r = a instanceof we ? a : null;
                }
                e.length = i;
            }
            function c(e, n) {
                var t;
                if (n instanceof pn) {
                    t = [ n ];
                } else if (n instanceof tn) {
                    t = n.expressions.slice();
                }
                if (!t) return;
                if (e instanceof Ze) {
                    var i = e.definitions[e.definitions.length - 1];
                    if (l(i.name, i.value, t)) return t;
                }
                for (var r = t.length - 1; --r >= 0; ) {
                    var o = t[r];
                    if (!(o instanceof pn)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof xn)) continue;
                    var a = t.slice(r + 1);
                    if (!l(o.left, o.right, a)) continue;
                    return t.slice(0, r + 1).concat(a);
                }
            }
            function l(e, n, t) {
                if (!(n instanceof hn)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof pn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof rn)) break;
                    var o = r.left.expression;
                    if (!(o instanceof xn)) break;
                    if (e.name != o.name) break;
                    if (!r.right.is_constant_expression(Q)) break;
                    var a = r.left.property;
                    if (a instanceof me) {
                        a = a.evaluate(u);
                    }
                    if (a instanceof me) break;
                    a = "" + a;
                    var s = u.has_directive("use strict") ? function(e) {
                        return e.key != a && e.key.name != a;
                    } : function(e) {
                        return e.key.name != a;
                    };
                    if (!ve(n.properties, s)) break;
                    n.properties.push(re(vn, r, {
                        key: a,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function d(i) {
                var e;
                for (var n = 0, r = -1; n < i.length; n++) {
                    var o = i[n];
                    var a = i[r];
                    if (o instanceof Ze) {
                        if (a && a.TYPE == o.TYPE) {
                            a.definitions = a.definitions.concat(o.definitions);
                            ee = true;
                        } else if (e && e.TYPE == o.TYPE && w(o)) {
                            e.definitions = e.definitions.concat(o.definitions);
                            ee = true;
                        } else {
                            i[++r] = o;
                            e = o;
                        }
                    } else if (o instanceof Ne) {
                        o.value = s(o.value);
                    } else if (o instanceof Se) {
                        var t = c(a, o.init);
                        if (t) {
                            ee = true;
                            o.init = t.length ? P(o.init, t) : null;
                            i[++r] = o;
                        } else if (a instanceof Ke && (!o.init || o.init.TYPE == a.TYPE)) {
                            if (o.init) {
                                a.definitions = a.definitions.concat(o.init.definitions);
                            }
                            o.init = a;
                            i[r] = o;
                            ee = true;
                        } else if (e && o.init && e.TYPE == o.init.TYPE && w(o.init)) {
                            e.definitions = e.definitions.concat(o.init.definitions);
                            o.init = null;
                            i[++r] = o;
                            ee = true;
                        } else {
                            i[++r] = o;
                        }
                    } else if (o instanceof Te) {
                        o.object = s(o.object);
                    } else if (o instanceof Ve) {
                        o.condition = s(o.condition);
                    } else if (o instanceof we) {
                        var t = c(a, o.body);
                        if (t) {
                            ee = true;
                            if (!t.length) continue;
                            o.body = P(o.body, t);
                        }
                        i[++r] = o;
                    } else if (o instanceof Le) {
                        o.expression = s(o.expression);
                    } else if (o instanceof Oe) {
                        o.expression = s(o.expression);
                    } else {
                        i[++r] = o;
                    }
                }
                i.length = r + 1;
                function s(e) {
                    i[++r] = o;
                    var n = c(a, e);
                    if (!n) return e;
                    ee = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return P(e, n);
                }
            }
        }
        function b(e, n) {
            if (!(e instanceof He)) {
                me.warn("Dropping unreachable code [{file}:{line},{col}]", e.start);
            }
            e.walk(new qn(function(e) {
                if (e instanceof Ze) {
                    me.warn("Declarations in unreachable code! [{file}:{line},{col}]", e.start);
                    e.remove_initializers();
                    n.push(e);
                    return true;
                }
                if (e instanceof He) {
                    n.push(e);
                    return true;
                }
                if (e instanceof $e) {
                    return true;
                }
            }));
        }
        function E(e, n) {
            return e.is_undefined || e instanceof Sn || e instanceof un && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(me, pe);
            e(dn, ee);
            e(pn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Me, ee);
            e(hn, ee);
            e(Fn, ee);
            e(tn, function() {
                return this.tail_node().is_truthy();
            });
            e(xn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = pe;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            me.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function i(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(me, i);
            e(dn, pe);
            e(pn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof xn)) return true;
                if (n instanceof cn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(cn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(ln, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(En, pe);
            e(on, function(e) {
                if (!i(e)) return false;
                var n = this.expression;
                if (n instanceof xn) n = n.fixed_value();
                return !(n instanceof Me && this.property == "prototype");
            });
            e(Me, pe);
            e(Cn, ee);
            e(hn, function(e) {
                if (!i(e)) return false;
                for (var n = this.properties.length; --n >= 0; ) if (this.properties[n].value instanceof qe) return true;
                return false;
            });
            e(tn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(xn, function(e) {
                if (this.is_undefined) return true;
                if (!i(e)) return false;
                if (J(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (te(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = ee;
                var t = n._dot_throw(e);
                delete this._dot_throw;
                return t;
            });
            e(un, function() {
                return this.operator == "void";
            });
            e(fn, pe);
            e(Sn, ee);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(me, pe);
            e(dn, ee);
            e(pn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(cn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(ln, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(En, ee);
            e(Me, ee);
            e(hn, ee);
            e(tn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(xn, function(e) {
                if (this.is_undefined) return false;
                if (J(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = pe;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(un, function() {
                return this.operator != "void";
            });
            e(fn, ee);
            e(Sn, pe);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(me, pe);
            e(pn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = he("in instanceof == != === !== < <= >= >");
            e(cn, function(e) {
                return n[this.operator] || se[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e($n, ee);
            var t = he("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(en, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof on && (t[n.property] || n.property == "test" && n.expression instanceof Fn);
            });
            e(ln, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(nn, pe);
            e(tn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(xn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = pe;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = he("! delete");
            e(un, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(me, pe);
            var n = he("- * / % & | ^ << >> >>>");
            e(pn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(cn, function(e) {
                return n[this.operator] || this.operator == "+" && this.left.is_number(e) && this.right.is_number(e);
            });
            var t = he([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(en, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof on && (t[n.property] || J(n.expression) && n.expression.name == "Math");
            });
            e(ln, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(nn, pe);
            e(Dn, ee);
            e(tn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(xn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = pe;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = he("+ - ~ ++ --");
            e(sn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(me, pe);
            e(pn, function(e) {
                return (this.operator == "=" || this.operator == "+=") && this.right.is_string(e);
            });
            e(cn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = he([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(en, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof on && t[n.property];
            });
            e(ln, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(tn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(kn, ee);
            e(xn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = pe;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(un, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var se = he("&& ||");
        var ue = he("++ --");
        var y = he("delete ++ --");
        function fe(e, n) {
            if (n instanceof sn && y[n.operator]) return n.expression;
            if (n instanceof pn && n.left === e) return e;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof me) return re(e.CTOR, n, e);
                if (Array.isArray(e)) return re(dn, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (_e(e, i)) {
                        t.push(re(vn, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return re(hn, n, {
                        properties: t
                    });
                }
                return V(e, n);
            }
            function a(e) {
                me.warn("global_defs " + e.print_to_string() + " redefined [{file}:{line},{col}]", e.start);
            }
            ze.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new tt(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof rn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (fe(i, r)) {
                        a(e);
                        return;
                    }
                    return n;
                }));
            });
            e(me, Q);
            e(on, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(_n, function(e) {
                if (!this.global()) return;
                if (_e(e.option("global_defs"), this.name)) a(this);
            });
            e(xn, function(e, n) {
                if (!this.global()) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (_e(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function k(e, n) {
            return e.print_to_string().length > n.print_to_string().length ? n : e;
        }
        function u(e, n) {
            return k(re(we, e, {
                body: e
            }), re(we, n, {
                body: n
            })).body;
        }
        function G(e, n, t) {
            return (j(e) ? u : k)(n, t);
        }
        function t(n) {
            Object.keys(n).forEach(function(e) {
                n[e] = he(n[e]);
            });
        }
        var r = [ "constructor", "toString", "valueOf" ];
        var v = {
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(r),
            Boolean: r,
            Function: r,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(r),
            Object: r,
            RegExp: [ "test" ].concat(r),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(r)
        };
        t(v);
        var _ = {
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        };
        t(_);
        (function(e) {
            me.DEFMETHOD("evaluate", function(e) {
                if (!e.option("evaluate")) return this;
                var n = [];
                var t = this._eval(e, n, 1);
                n.forEach(function(e) {
                    delete e._eval;
                });
                if (!t || t instanceof RegExp) return t;
                if (typeof t == "function" || typeof t == "object") return this;
                return t;
            });
            var n = he("! ~ - + void");
            me.DEFMETHOD("is_constant", function() {
                if (this instanceof En) {
                    return !(this instanceof Fn);
                } else {
                    return this instanceof un && this.expression instanceof En && n[this.operator];
                }
            });
            e(ge, function() {
                throw new Error(z("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Me, O);
            e(me, O);
            e(En, function() {
                return this.getValue();
            });
            e(je, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(dn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var r = 0; r < this.elements.length; r++) {
                        var o = this.elements[r];
                        var a = o._eval(e, n, t);
                        if (o === a) return this;
                        i.push(a);
                    }
                    return i;
                }
                return this;
            });
            e(hn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var r = 0; r < this.properties.length; r++) {
                        var o = this.properties[r];
                        var a = o.key;
                        if (a instanceof U) {
                            a = a.name;
                        } else if (a instanceof me) {
                            a = a._eval(e, n, t);
                            if (a === o.key) return this;
                        }
                        if (typeof Object.prototype[a] === "function") {
                            return this;
                        }
                        if (o.value instanceof je) continue;
                        i[a] = o.value._eval(e, n, t);
                        if (i[a] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var a = he("! typeof void");
            e(un, function(e, n, t) {
                var i = this.expression;
                if (e.option("typeofs") && this.operator == "typeof" && (i instanceof Me || i instanceof xn && i.fixed_value() instanceof Me)) {
                    return typeof function() {};
                }
                if (!a[this.operator]) t++;
                var r = i._eval(e, n, t);
                if (r === this.expression) return this;
                switch (this.operator) {
                  case "!":
                    return !r;

                  case "typeof":
                    if (r instanceof RegExp) return this;
                    return typeof r;

                  case "void":
                    return void r;

                  case "~":
                    return ~r;

                  case "-":
                    return -r;

                  case "+":
                    return +r;

                  case "++":
                  case "--":
                    if (i instanceof xn) {
                        var o = i.definition().references;
                        if (o[o.length - 1] === i) return r;
                    }
                }
                return this;
            });
            var s = he("&& || === !==");
            e(cn, function(e, n, t) {
                if (!s[this.operator]) t++;
                var i = this.left._eval(e, n, t);
                if (i === this.left) return this;
                var r = this.right._eval(e, n, t);
                if (r === this.right) return this;
                var o;
                switch (this.operator) {
                  case "&&":
                    o = i && r;
                    break;

                  case "||":
                    o = i || r;
                    break;

                  case "|":
                    o = i | r;
                    break;

                  case "&":
                    o = i & r;
                    break;

                  case "^":
                    o = i ^ r;
                    break;

                  case "+":
                    o = i + r;
                    break;

                  case "*":
                    o = i * r;
                    break;

                  case "/":
                    o = i / r;
                    break;

                  case "%":
                    o = i % r;
                    break;

                  case "-":
                    o = i - r;
                    break;

                  case "<<":
                    o = i << r;
                    break;

                  case ">>":
                    o = i >> r;
                    break;

                  case ">>>":
                    o = i >>> r;
                    break;

                  case "==":
                    o = i == r;
                    break;

                  case "===":
                    o = i === r;
                    break;

                  case "!=":
                    o = i != r;
                    break;

                  case "!==":
                    o = i !== r;
                    break;

                  case "<":
                    o = i < r;
                    break;

                  case "<=":
                    o = i <= r;
                    break;

                  case ">":
                    o = i > r;
                    break;

                  case ">=":
                    o = i >= r;
                    break;

                  default:
                    return this;
                }
                return isNaN(o) && e.find_parent(Oe) ? this : o;
            });
            e(ln, function(e, n, t) {
                var i = this.condition._eval(e, n, t);
                if (i === this.condition) return this;
                var r = i ? this.consequent : this.alternative;
                var o = r._eval(e, n, t);
                return o === r ? this : o;
            });
            e(xn, function(e, n, t) {
                var i = this.fixed_value();
                if (!i) return this;
                var r;
                if (ce(i, n)) {
                    r = i._eval();
                } else {
                    this._eval = O;
                    r = i._eval(e, n, t);
                    delete this._eval;
                    if (r === i) return this;
                    i._eval = function() {
                        return r;
                    };
                    n.push(i);
                }
                if (r && typeof r == "object") {
                    var o = this.definition().escaped;
                    switch (o.length) {
                      case 0:
                        break;

                      case 1:
                        if (a(o[0], this)) break;

                      default:
                        if (t > o.depth) return this;
                    }
                }
                return r;
                function a(e, n) {
                    var t = false;
                    e.walk(new qn(function(e) {
                        if (t) return true;
                        if (e === n) return t = true;
                    }));
                    return t;
                }
            });
            var d = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var u = {
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            };
            t(u);
            e(rn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = this.property;
                    if (i instanceof me) {
                        i = i._eval(e, n, t);
                        if (i === this.property) return this;
                    }
                    var r = this.expression;
                    var o;
                    if (J(r)) {
                        var a = u[r.name];
                        if (!a || !a[i]) return this;
                        o = d[r.name];
                    } else {
                        o = r._eval(e, n, t + 1);
                        if (!o || o === r) return this;
                        if (typeof o == "object" && !_e(o, i)) return this;
                        if (typeof o == "function") switch (i) {
                          case "name":
                            return o.node.name ? o.node.name.name : "";

                          case "length":
                            return o.node.argnames.length;

                          default:
                            return this;
                        }
                    }
                    return o[i];
                }
                return this;
            });
            e(en, function(e, n, t) {
                var i = this.expression;
                if (e.option("unsafe") && i instanceof rn) {
                    var r = i.property;
                    if (r instanceof me) {
                        r = r._eval(e, n, t);
                        if (r === i.property) return this;
                    }
                    var o;
                    var a = i.expression;
                    if (J(a)) {
                        var s = _[a.name];
                        if (!s || !s[r]) return this;
                        o = d[a.name];
                    } else {
                        o = a._eval(e, n, t + 1);
                        if (o === a || !o) return this;
                        var u = v[o.constructor.name];
                        if (!u || !u[r]) return this;
                    }
                    var f = [];
                    for (var c = 0; c < this.args.length; c++) {
                        var l = this.args[c];
                        var p = l._eval(e, n, t);
                        if (l === p) return this;
                        f.push(p);
                    }
                    if (r == "replace" && typeof f[1] == "function") return this;
                    try {
                        return o[r].apply(o, f);
                    } catch (e) {
                        me.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this.print_to_string(),
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    }
                }
                return this;
            });
            e(nn, O);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return re(un, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = o(e);
                if (t) {
                    var r = re(we, n, {
                        body: n
                    });
                    return k(i, r) === r ? n : i;
                }
                return k(i, n);
            }
            e(me, function() {
                return o(this);
            });
            e(ge, function() {
                throw new Error("Cannot negate a statement");
            });
            e(je, function() {
                return o(this);
            });
            e(un, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(tn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return P(this, n);
            });
            e(ln, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(cn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var f = he("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        en.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (J(n) && f[n.name]) return true;
                if (n instanceof on && J(n.expression)) {
                    var t = _[n.expression.name];
                    return t && t[n.property];
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        me.DEFMETHOD("is_call_pure", pe);
        en.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof on)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof dn) {
                i = v.Array;
            } else if (t.is_boolean(e)) {
                i = v.Boolean;
            } else if (t.is_number(e)) {
                i = v.Number;
            } else if (t instanceof Fn) {
                i = v.RegExp;
            } else if (t.is_string(e)) {
                i = v.String;
                if (r == "replace") {
                    var o = this.args[1];
                    if (o && !o.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = v.Object;
            }
            return i && i[r];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(me, ee);
            e(dn, function(e) {
                return n(this.elements, e);
            });
            e(pn, ee);
            e(cn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(xe, function(e) {
                return n(this.body, e);
            });
            e(en, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(Je, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(ln, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(En, pe);
            e(Ze, function(e) {
                return n(this.definitions, e);
            });
            e(on, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Ee, pe);
            e(Ve, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(ke, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Me, pe);
            e(hn, function(e) {
                return n(this.properties, e);
            });
            e(I, function(e) {
                return this.value.has_side_effects(e);
            });
            e(an, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(tn, function(e) {
                return n(this.expressions, e);
            });
            e(we, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Le, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(_n, pe);
            e(xn, function(e) {
                return !this.is_declared(e);
            });
            e(An, pe);
            e(We, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(sn, function(e) {
                return y[this.operator] || this.expression.has_side_effects(e);
            });
            e(Qe, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(me, ee);
            e(En, pe);
            e(Ee, pe);
            e(Me, pe);
            e(_n, pe);
            e(An, pe);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(dn, function(e) {
                return n(this.elements, e);
            });
            e(pn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof xn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(cn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e);
            });
            e(xe, function(e) {
                return n(this.body, e);
            });
            e(en, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof Me) || n(this.expression.body, e);
            });
            e(Je, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(ln, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Ze, function(e) {
                return n(this.definitions, e);
            });
            e(on, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(Ve, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(ke, function(e) {
                return this.body.may_throw(e);
            });
            e(hn, function(e) {
                return n(this.properties, e);
            });
            e(I, function(e) {
                return this.value.may_throw(e);
            });
            e(Re, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(tn, function(e) {
                return n(this.expressions, e);
            });
            e(we, function(e) {
                return this.body.may_throw(e);
            });
            e(an, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Le, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(xn, function(e) {
                return !this.is_declared(e);
            });
            e(We, function(e) {
                return this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(sn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof xn) return false;
                return this.expression.may_throw(e);
            });
            e(Qe, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(me, pe);
            e(dn, function() {
                return n(this.elements);
            });
            e(cn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression();
            });
            e(En, ee);
            e(Me, function(r) {
                var o = this;
                var a = true;
                var s = [];
                o.walk(new qn(function(e, n) {
                    if (!a) return true;
                    if (e instanceof Ge) {
                        s.push(e.argname.scope);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof $e && e !== o) {
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof xn) {
                        if (o.inlined) {
                            a = false;
                            return true;
                        }
                        var t = e.definition();
                        if (!o.variables.has(t.name) && !ce(t.scope, s)) {
                            if (r) {
                                var i = r.find_variable(e);
                                if (t.undeclared ? !i : i === t) {
                                    a = "f";
                                    return true;
                                }
                            }
                            a = false;
                        }
                        return true;
                    }
                }));
                return a;
            });
            e(hn, function() {
                return n(this.properties);
            });
            e(I, function() {
                return this.value.is_constant_expression();
            });
            e(sn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function D(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(ge, $);
            e(N, O);
            function n() {
                var e = this.body.length;
                return e > 0 && D(this.body[e - 1]);
            }
            e(Ae, n);
            e(R, n);
            e(Ve, function() {
                return this.alternative && D(this.body) && D(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var l = he([ "use asm", "use strict" ]);
        e(ye, function(e, n) {
            if (n.option("directives") && (!l[e.value] || n.has_directive(e.value) !== e)) {
                return re(Ee, e);
            }
            return e;
        });
        e(be, function(e, n) {
            if (n.option("drop_debugger")) return re(Ee, e);
            return e;
        });
        e(ke, function(e, n) {
            if (e.body instanceof Ue && n.loopcontrol_target(e.body) === e.body) {
                return re(Ee, e);
            }
            return e.label.references.length == 0 ? e.body : e;
        });
        e(xe, function(e, n) {
            i(e.body, n);
            return e;
        });
        e(Ae, function(e, n) {
            i(e.body, n);
            switch (e.body.length) {
              case 1:
                return e.body[0];

              case 0:
                return re(Ee, e);
            }
            return e;
        });
        e(Me, function(e, n) {
            i(e.body, n);
            if (n.option("side_effects") && e.body.length == 1 && e.body[0] === n.has_directive("use strict")) {
                e.body.length = 0;
            }
            return e;
        });
        $e.DEFMETHOD("drop_unused", function(b) {
            if (!b.option("unused")) return;
            if (b.has_directive("use asm")) return;
            var y = this;
            if (y.pinned()) return;
            var w = !(y instanceof ze) || b.toplevel.funcs;
            var x = !(y instanceof ze) || b.toplevel.vars;
            var A = /keep_assign/.test(b.option("unused")) ? pe : function(e, n) {
                var t;
                if (e instanceof pn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof sn) {
                    if (e.write_only) t = e.expression;
                }
                if (!/strict/.test(b.option("pure_getters"))) return t instanceof xn && t;
                while (t instanceof rn && !t.expression.may_throw_on_access(b)) {
                    if (t instanceof an) n.unshift(t.property);
                    t = t.expression;
                }
                return t instanceof xn && ve(t.definition().orig, function(e) {
                    return !(e instanceof yn);
                }) && t;
            };
            var u = [];
            var E = Object.create(null);
            var k = Object.create(null);
            var f = Object.create(null);
            var c = Object.create(null);
            if (y instanceof ze && b.top_retain) {
                y.variables.each(function(e) {
                    if (b.top_retain(e) && !(e.id in E)) {
                        E[e.id] = true;
                        u.push(e);
                    }
                });
            }
            var D = new q();
            var i = new q();
            var F = this;
            var l = new qn(function(e, n) {
                if (e instanceof Me && e.uses_arguments && !l.has_directive("use strict")) {
                    e.argnames.forEach(function(e) {
                        var n = e.definition();
                        if (!(n.id in E)) {
                            E[n.id] = true;
                            u.push(n);
                        }
                    });
                }
                if (e === y) return;
                if (e instanceof He) {
                    var t = e.name.definition();
                    if (!w && F === y) {
                        if (!(t.id in E)) {
                            E[t.id] = true;
                            u.push(t);
                        }
                    }
                    i.add(t.id, e);
                    return true;
                }
                if (e instanceof gn && F === y) {
                    D.add(e.definition().id, e);
                }
                if (e instanceof Ze && F === y) {
                    e.definitions.forEach(function(e) {
                        var n = e.name.definition();
                        D.add(n.id, e);
                        if (!x) {
                            if (!(n.id in E)) {
                                E[n.id] = true;
                                u.push(n);
                            }
                        }
                        if (e.value) {
                            i.add(n.id, e.value);
                            if (e.value.has_side_effects(b)) {
                                e.value.walk(l);
                            }
                            if (!n.chained && e.name.fixed_value(true) === e.value) {
                                k[n.id] = e;
                            }
                        }
                    });
                    return true;
                }
                return r(e, n);
            });
            y.walk(l);
            l = new qn(r);
            for (var e = 0; e < u.length; e++) {
                var n = i.get(u[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(l);
                });
            }
            var C = b.option("keep_fnames") ? pe : b.option("ie8") ? function(e) {
                return !b.exposed(e) && !e.references.length;
            } : function(e) {
                return !(e.id in E) || e.orig.length > 1;
            };
            var B = [];
            var S = new tt(function(c, e, n) {
                var l = S.parent();
                if (x) {
                    var t = [], i = A(c, t);
                    if (i) {
                        var r = i.definition();
                        var o = r.id in E;
                        var a;
                        if (c instanceof pn) {
                            if (!o || c.left === i && r.id in k && k[r.id] !== c) {
                                a = T(c);
                            }
                        } else if (!o) {
                            a = re(Dn, c, {
                                value: 0
                            });
                        }
                        if (a) {
                            t.push(a);
                            return oe(b, l, c, P(c, t.map(function(e) {
                                return e.transform(S);
                            })));
                        }
                    }
                }
                if (F !== y) return;
                if (c instanceof je && c.name && C(c.name.definition())) {
                    B.push(c);
                }
                if (c instanceof Me && !(c instanceof qe)) {
                    var s = b.drop_fargs(c, l);
                    for (var u = c.argnames, f = u.length; --f >= 0; ) {
                        var i = u[f];
                        if (!(i.definition().id in E)) {
                            i.__unused = true;
                            if (s) {
                                u.pop();
                                me[i.unreferenced() ? "warn" : "info"]("Dropping unused function argument {name} [{file}:{line},{col}]", g(i));
                            }
                        } else {
                            s = false;
                        }
                    }
                }
                if (w && c instanceof He && c !== y) {
                    var r = c.name.definition();
                    if (!(r.id in E)) {
                        me[c.name.unreferenced() ? "warn" : "info"]("Dropping unused function {name} [{file}:{line},{col}]", g(c.name));
                        r.eliminated++;
                        return re(Ee, c);
                    }
                }
                if (c instanceof Ze && !(l instanceof Te && l.init === c)) {
                    var p = [], d = [], h = [];
                    var v = [];
                    c.definitions.forEach(function(e) {
                        if (e.value) e.value = e.value.transform(S);
                        var n = e.name.definition();
                        if (!x || n.id in E) {
                            if (e.value && n.id in k && k[n.id] !== e) {
                                e.value = e.value.drop_side_effect_free(b);
                            }
                            var t = D.get(n.id);
                            if (t.length > 1 && (!e.value || n.orig.indexOf(e.name) > n.eliminated)) {
                                me.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", g(e.name));
                                if (e.value) {
                                    var i = re(xn, e.name, e.name);
                                    n.references.push(i);
                                    var r = re(pn, e, {
                                        operator: "=",
                                        left: i,
                                        right: e.value
                                    });
                                    if (k[n.id] === e) {
                                        k[n.id] = r;
                                    }
                                    v.push(r.transform(S));
                                }
                                M(t, e);
                                n.eliminated++;
                                return;
                            }
                            if (!e.value) {
                                d.push(e);
                            } else if (b.option("functions") && !b.option("ie8") && e.value === e.name.fixed_value() && e.value instanceof je && !(e.value.name && e.value.name.definition().assignments) && f(e.value, e.name.name) && (!b.has_directive("use strict") || l instanceof $e)) {
                                me.warn("Declaring {name} as function [{file}:{line},{col}]", g(e.name));
                                var o = re(He, e, e.value);
                                o.name = re(bn, e.name, e.name);
                                var a = e.name.scope.resolve().def_function(o.name);
                                if (e.value.name) {
                                    var s = e.value.name.definition();
                                    e.value.walk(new qn(function(e) {
                                        if (e instanceof xn && e.definition() === s) {
                                            e.name = a.name;
                                            e.thedef = a;
                                            e.reference({});
                                        }
                                    }));
                                }
                                p.push(o);
                            } else {
                                if (v.length > 0) {
                                    if (h.length > 0) {
                                        v.push(e.value);
                                        e.value = P(e.value, v);
                                    } else {
                                        p.push(re(we, c, {
                                            body: P(c, v)
                                        }));
                                    }
                                    v = [];
                                }
                                h.push(e);
                            }
                        } else if (n.orig[0] instanceof wn) {
                            var u = e.value && e.value.drop_side_effect_free(b);
                            if (u) v.push(u);
                            e.value = null;
                            d.push(e);
                        } else {
                            var u = e.value && e.value.drop_side_effect_free(b);
                            if (u) {
                                me.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", g(e.name));
                                v.push(u);
                            } else {
                                me[e.name.unreferenced() ? "warn" : "info"]("Dropping unused variable {name} [{file}:{line},{col}]", g(e.name));
                            }
                            n.eliminated++;
                        }
                        function f(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                    });
                    if (d.length > 0 || h.length > 0) {
                        c.definitions = d.concat(h);
                        p.push(c);
                    }
                    if (v.length > 0) {
                        p.push(re(we, c, {
                            body: P(c, v)
                        }));
                    }
                    switch (p.length) {
                      case 0:
                        return n ? de.skip : re(Ee, c);

                      case 1:
                        return p[0];

                      default:
                        return n ? de.splice(p) : re(Ae, c, {
                            body: p
                        });
                    }
                }
                if (c instanceof Se) {
                    e(c, this);
                    var _;
                    if (c.init instanceof Ae) {
                        _ = c.init;
                        c.init = _.body.pop();
                        _.body.push(c);
                    }
                    if (c.init instanceof He) {
                        if (!_) {
                            _ = re(Ae, c, {
                                body: [ c ]
                            });
                        }
                        _.body.splice(-1, 0, c.init);
                        c.init = null;
                    } else if (c.init instanceof we) {
                        c.init = c.init.body;
                    } else if (L(c.init)) {
                        c.init = null;
                    }
                    return !_ ? c : n ? de.splice(_.body) : _;
                }
                if (c instanceof ke && c.body instanceof Se) {
                    e(c, this);
                    if (c.body instanceof Ae) {
                        var _ = c.body;
                        c.body = _.body.pop();
                        _.body.push(c);
                        return n ? de.splice(_.body) : _;
                    }
                    return c;
                }
                if (c instanceof $e) {
                    var m = F;
                    F = c;
                    e(c, this);
                    F = m;
                    return c;
                }
                function g(e) {
                    return {
                        name: e.name,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    };
                }
            });
            S.push(b.parent());
            y.transform(S);
            B.forEach(function(e) {
                e.name = null;
            });
            function p(e, n, t) {
                if (e.id in E) return;
                if (n && t) {
                    E[e.id] = true;
                    u.push(e);
                } else {
                    f[e.id] = n;
                    c[e.id] = t;
                }
            }
            function T(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof cn && se[n.operator])) return n;
                var t = e.left;
                if (!(t instanceof xn) || t.name != n.left.name) return n;
                return n.right.has_side_effects(b) ? n : n.right;
            }
            function r(e, n) {
                var t, i = [], r = A(e, i);
                if (r && y.variables.get(r.name) === (t = r.definition())) {
                    i.forEach(function(e) {
                        e.walk(l);
                    });
                    if (e instanceof pn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(b)) return;
                        var o = T(e);
                        o.walk(l);
                        if (e.left === r) {
                            if (!t.chained && r.fixed_value(true) === o) {
                                k[t.id] = e;
                            }
                            if (!e.write_only) {
                                p(t, true, c[t.id]);
                            }
                        } else {
                            var a = r.fixed_value();
                            if (!a || !a.is_constant()) {
                                p(t, f[t.id], true);
                            }
                        }
                    }
                    return true;
                }
                if (e instanceof xn) {
                    t = e.definition();
                    if (!(t.id in E)) {
                        E[t.id] = true;
                        u.push(t);
                    }
                    return true;
                }
                if (e instanceof $e) {
                    var s = F;
                    F = e;
                    n();
                    F = s;
                    return true;
                }
            }
        });
        $e.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var o = r.option("hoist_funs");
            var a = r.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new qn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof $e && e !== s) return true;
                    if (e instanceof Ke) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var u = [];
            var f = [];
            var c = new q(), l = 0;
            var p = new tt(function(e) {
                if (e === s) return;
                if (e instanceof ye) {
                    u.push(e);
                    return re(Ee, e);
                }
                if (o && e instanceof He && (p.parent() === s || !r.has_directive("use strict"))) {
                    f.push(e);
                    return re(Ee, e);
                }
                if (a && e instanceof Ke) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments(r);
                    var t = p.parent();
                    if (t instanceof Te && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return re(xn, i, i);
                    }
                    if (t instanceof Se && t.init === e) return n;
                    if (!n) return re(Ee, e);
                    return re(we, e, {
                        body: n
                    });
                }
                if (e instanceof $e) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof Me && !ve(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof we) {
                            var i = s.body[e].body, d, h;
                            if (i instanceof pn && i.operator == "=" && (d = i.left) instanceof U && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = i.right;
                                M(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof tn && (h = i.expressions[0]) instanceof pn && h.operator == "=" && (d = h.left) instanceof U && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = h.right;
                                M(t, v);
                                t.push(v);
                                s.body[e].body = P(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Ee) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof Ae) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = re(Ke, s, {
                        definitions: t
                    });
                    f.push(t);
                }
            }
            s.body = u.concat(f, s.body);
        });
        $e.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        $e.DEFMETHOD("make_var_name", function(e) {
            var n = this.var_names();
            e = e.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var t = e;
            for (var i = 0; n[t]; i++) t = e + "$" + i;
            n[t] = true;
            return t;
        });
        $e.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var u = this;
            var r = u instanceof ze && e.top_retain || pe;
            var f = Object.create(null);
            u.transform(new tt(function(i, e) {
                if (i instanceof pn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== u) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new q();
                    var o = [];
                    var a = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        a.push(re(Qe, i, {
                            name: n,
                            value: null
                        }));
                        var t = re(xn, i, {
                            name: n.name,
                            scope: u,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(re(pn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    f[i.left.definition().id] = r;
                    u.body.splice(u.body.indexOf(this.stack[1]) + 1, 0, re(Ke, i, {
                        definitions: a
                    }));
                    return P(i, o);
                }
                if (i instanceof $e) return i === u ? undefined : i;
                if (i instanceof Qe) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new q();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(re(Qe, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    f[i.name.definition().id] = r;
                    return de.splice(n);
                }
                function s(e, n) {
                    var t = re(mn, e, {
                        name: u.make_var_name(e.name + "_" + n),
                        scope: u
                    });
                    var i = u.def_variable(t);
                    r.set(n, i);
                    u.enclosed.push(i);
                    return t;
                }
            }));
            u.transform(new tt(function(e, n) {
                if (e instanceof rn) {
                    if (!(e.expression instanceof xn)) return;
                    var t = f[e.expression.definition().id];
                    if (!t) return;
                    var i = t.get(e.getProperty());
                    var r = re(xn, e, {
                        name: i.name,
                        scope: e.expression.scope,
                        thedef: i
                    });
                    r.reference({});
                    return r;
                }
                if (e instanceof sn) {
                    if (y[e.operator]) return;
                    if (!(e.expression instanceof xn)) return;
                    if (!(e.expression.definition().id in f)) return;
                    var o = e.clone();
                    o.expression = re(hn, e, {
                        properties: []
                    });
                    return o;
                }
            }));
            function t(e, n, t) {
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof hn;
            }
        });
        function X(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return ve(t.references, function(e) {
                return !(e instanceof xn);
            });
        }
        (function(e) {
            function a(e, n, t) {
                var i = e.length;
                if (!i) return null;
                var r = [], o = false;
                for (var a = 0; a < i; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        r.push(s);
                        t = false;
                    }
                }
                return o ? r.length ? r : null : e;
            }
            e(me, O);
            e(qe, $);
            e(dn, function(e, n) {
                var t = a(this.elements, e, n);
                return t && P(this, t);
            });
            e(pn, function(e) {
                var n = this.left;
                if (n instanceof rn) {
                    var t = n.expression;
                    if (t instanceof pn && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (ae(n).is_constant_expression(e.find_parent($e))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(cn, function(e, n) {
                var t = this.right.drop_side_effect_free(e, n);
                if (!t) return this.left.drop_side_effect_free(e, n);
                if (se[this.operator]) {
                    var i = this;
                    if (t !== i.right) {
                        i = this.clone();
                        i.right = t.drop_side_effect_free(e);
                    }
                    return (n ? u : k)(i, re(cn, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var r = this.left.drop_side_effect_free(e, n);
                    if (!r) return t;
                    return P(this, [ r, t.drop_side_effect_free(e) ]);
                }
            });
            e(en, function(n, e) {
                if (!this.is_expr_pure(n)) {
                    var t = this.expression;
                    if (this.is_call_pure(n)) {
                        var i = this.args.slice();
                        i.unshift(t.expression);
                        i = a(i, n, e);
                        return i && P(this, i);
                    }
                    if (t instanceof je && (!t.name || !t.name.definition().references.length)) {
                        var r = this.clone();
                        t.process_expression(false, n);
                        t.walk(new qn(function(e) {
                            if (e instanceof Re && e.value) {
                                e.value = e.value.drop_side_effect_free(n);
                                return true;
                            }
                            if (e instanceof $e && e !== t) return true;
                        }));
                        return r;
                    }
                    return this;
                }
                if (this.pure) me.warn("Dropping __PURE__ call [{file}:{line},{col}]", this.start);
                var o = a(this.args, n, e);
                return o && P(this, o);
            });
            e(ln, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                if (!n) return t ? re(cn, this, {
                    operator: "||",
                    left: this.condition,
                    right: t
                }) : this.condition.drop_side_effect_free(e);
                if (!t) return re(cn, this, {
                    operator: "&&",
                    left: this.condition,
                    right: n
                });
                var i = this.clone();
                i.consequent = n;
                i.alternative = t;
                return i;
            });
            e(En, $);
            e(on, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(je, function(e) {
                return X(this, e) ? null : this;
            });
            e(hn, function(e, n) {
                var t = a(this.properties, e, n);
                return t && P(this, t);
            });
            e(I, function(e, n) {
                return this.value.drop_side_effect_free(e, n);
            });
            e(tn, function(e, n) {
                var t = a(this.expressions, e, n);
                if (t === this.expressions) return this;
                if (!t) return null;
                return P(this, t);
            });
            e(an, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return P(this, [ t, i ]);
            });
            e(xn, function(e) {
                if (!this.is_declared(e)) return this;
                this.definition().replaced++;
                return null;
            });
            e(An, $);
            e(sn, function(e, n) {
                if (y[this.operator]) {
                    this.write_only = !this.expression.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && this.expression instanceof xn) {
                    this.expression.definition().replaced++;
                    return null;
                }
                var t = this.expression.drop_side_effect_free(e, n);
                if (n && t && Y(t)) {
                    if (t === this.expression && this.operator == "!") return this;
                    return t.negate(e, n);
                }
                return t;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(we, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    me.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return re(Ee, e);
                }
                if (i !== t) {
                    return re(we, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Be, function(e, n) {
            return n.option("loops") ? re(Se, e, e).optimize(n) : e;
        });
        function w(n, e) {
            var t = false;
            var i = new qn(function(e) {
                if (t || e instanceof $e) return true;
                if (e instanceof Ie && i.loopcontrol_target(e) === n) {
                    return t = true;
                }
            });
            if (e instanceof ke) i.push(e);
            i.push(n);
            n.body.walk(i);
            return t;
        }
        e(Ce, function(e, n) {
            if (!n.option("loops")) return e;
            var t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
            if (!(t instanceof me)) {
                if (t) return re(Se, e, {
                    body: re(Ae, e.body, {
                        body: [ e.body, re(we, e.condition, {
                            body: e.condition
                        }) ]
                    })
                }).optimize(n);
                if (!w(e, n.parent())) {
                    return re(Ae, e.body, {
                        body: [ e.body, re(we, e.condition, {
                            body: e.condition
                        }) ]
                    }).optimize(n);
                }
            }
            if (e.body instanceof we) return re(Se, e, {
                condition: P(e.condition, [ e.body.body, e.condition ]),
                body: re(Ee, e)
            }).optimize(n);
            return e;
        });
        function p(n, t) {
            var e = n.body instanceof Ae ? n.body.body[0] : n.body;
            if (t.option("dead_code") && r(e)) {
                var i = [];
                if (n.init instanceof ge) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(re(we, n.init, {
                        body: n.init
                    }));
                }
                if (n.condition) {
                    i.push(re(we, n.condition, {
                        body: n.condition
                    }));
                }
                b(n.body, i);
                return re(Ae, n, {
                    body: i
                });
            }
            if (e instanceof Ve) {
                if (r(e.body)) {
                    if (n.condition) {
                        n.condition = re(cn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    o(e.alternative);
                } else if (r(e.alternative)) {
                    if (n.condition) {
                        n.condition = re(cn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    o(e.body);
                }
            }
            return n;
            function r(e) {
                return e instanceof Ue && t.loopcontrol_target(e) === t.self();
            }
            function o(e) {
                e = x(e);
                if (n.body instanceof Ae) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = re(Ae, n.body, {
                        body: e
                    }).transform(t);
                }
                n = p(n, t);
            }
        }
        e(Se, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (!(t instanceof me)) {
                    if (t) e.condition = null; else if (!n.option("dead_code")) {
                        var i = e.condition;
                        e.condition = V(t, e.condition);
                        e.condition = k(e.condition.transform(n), i);
                    }
                }
                if (t instanceof me) {
                    t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        b(e.body, r);
                        if (e.init instanceof ge) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(re(we, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(re(we, e.condition, {
                            body: e.condition
                        }));
                        return re(Ae, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof me)) {
                    e.body = re(Ae, e.body, {
                        body: [ re(we, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return p(e, n);
        });
        e(Ve, function(e, n) {
            if (L(e.alternative)) e.alternative = null;
            if (!n.option("conditionals")) return e;
            var t = e.condition.evaluate(n);
            if (!n.option("dead_code") && !(t instanceof me)) {
                var i = e.condition;
                e.condition = V(t, i);
                e.condition = k(e.condition.transform(n), i);
            }
            if (n.option("dead_code")) {
                if (t instanceof me) {
                    t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
                }
                if (!t) {
                    me.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var r = [];
                    b(e.body, r);
                    r.push(re(we, e.condition, {
                        body: e.condition
                    }));
                    if (e.alternative) r.push(e.alternative);
                    return re(Ae, e, {
                        body: r
                    }).optimize(n);
                } else if (!(t instanceof me)) {
                    me.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var r = [];
                    if (e.alternative) b(e.alternative, r);
                    r.push(re(we, e.condition, {
                        body: e.condition
                    }));
                    r.push(e.body);
                    return re(Ae, e, {
                        body: r
                    }).optimize(n);
                }
            }
            var o = e.condition.negate(n);
            var a = e.condition.print_to_string().length;
            var s = o.print_to_string().length;
            var u = s < a;
            if (e.alternative && u) {
                u = false;
                e.condition = o;
                var f = e.body;
                e.body = e.alternative || re(Ee, e);
                e.alternative = f;
            }
            if (L(e.body) && L(e.alternative)) {
                return re(we, e.condition, {
                    body: e.condition.clone()
                }).optimize(n);
            }
            if (e.body instanceof we && e.alternative instanceof we) {
                return re(we, e, {
                    body: re(ln, e, {
                        condition: e.condition,
                        consequent: e.body.body,
                        alternative: e.alternative.body
                    })
                }).optimize(n);
            }
            if (L(e.alternative) && e.body instanceof we) {
                if (a === s && !u && e.condition instanceof cn && e.condition.operator == "||") {
                    u = true;
                }
                if (u) return re(we, e, {
                    body: re(cn, e, {
                        operator: "||",
                        left: o,
                        right: e.body.body
                    }).transform(n)
                }).optimize(n);
                return re(we, e, {
                    body: re(cn, e, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.body
                    }).transform(n)
                }).optimize(n);
            }
            if (e.body instanceof Ee && e.alternative instanceof we) {
                return re(we, e, {
                    body: re(cn, e, {
                        operator: "||",
                        left: e.condition,
                        right: e.alternative.body
                    }).transform(n)
                }).optimize(n);
            }
            if (e.body instanceof Ne && e.alternative instanceof Ne && e.body.TYPE == e.alternative.TYPE) {
                return re(e.body.CTOR, e, {
                    value: re(ln, e, {
                        condition: e.condition,
                        consequent: e.body.value || re(Sn, e.body),
                        alternative: e.alternative.value || re(Sn, e.alternative)
                    }).transform(n)
                }).optimize(n);
            }
            if (e.body instanceof Ve && !e.body.alternative && !e.alternative) {
                e = re(Ve, e, {
                    condition: re(cn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (D(e.body)) {
                if (e.alternative) {
                    var c = e.alternative;
                    e.alternative = null;
                    return re(Ae, e, {
                        body: [ e, c ]
                    }).optimize(n);
                }
            }
            if (D(e.alternative)) {
                var r = e.body;
                e.body = e.alternative;
                e.condition = u ? o : e.condition.negate(n);
                e.alternative = null;
                return re(Ae, e, {
                    body: [ e, r ]
                }).optimize(n);
            }
            return e;
        });
        e(Le, function(n, e) {
            if (!e.option("switches")) return n;
            var t;
            var i = n.expression.evaluate(e);
            if (!(i instanceof me)) {
                var r = n.expression;
                n.expression = V(i, r);
                n.expression = k(n.expression.transform(e), r);
            }
            if (!e.option("dead_code")) return n;
            if (i instanceof me) {
                i = n.expression.tail_node().evaluate(e);
            }
            var o = [];
            var a = [];
            var s;
            var u;
            for (var f = 0, c = n.body.length; f < c && !u; f++) {
                t = n.body[f];
                if (t instanceof Ye) {
                    if (!s) {
                        s = t;
                    } else {
                        g(t, a[a.length - 1]);
                    }
                } else if (!(i instanceof me)) {
                    var l = t.expression.evaluate(e);
                    if (!(l instanceof me) && l !== i) {
                        g(t, a[a.length - 1]);
                        continue;
                    }
                    if (l instanceof me) l = t.expression.tail_node().evaluate(e);
                    if (l === i) {
                        u = t;
                        if (s) {
                            var p = a.indexOf(s);
                            a.splice(p, 1);
                            g(s, a[p - 1]);
                            s = null;
                        }
                    }
                }
                if (D(t)) {
                    var d = a[a.length - 1];
                    if (D(d) && d.body.length == t.body.length && re(Ae, d, d).equivalent_to(re(Ae, t, t))) {
                        d.body = [];
                    }
                }
                a.push(t);
            }
            while (f < c) g(n.body[f++], a[a.length - 1]);
            if (a.length > 0) {
                a[0].body = o.concat(a[0].body);
            }
            n.body = a;
            while (t = a[a.length - 1]) {
                var h = t.body[t.body.length - 1];
                if (h instanceof Ue && e.loopcontrol_target(h) === n) t.body.pop();
                if (t.body.length || t instanceof Je && (s || t.expression.has_side_effects(e))) break;
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return re(Ae, n, {
                    body: o.concat(re(we, n.expression, {
                        body: n.expression
                    }))
                }).optimize(e);
            }
            if (a.length == 1 && (a[0] === u || a[0] === s)) {
                var v = false;
                var _ = new qn(function(e) {
                    if (v || e instanceof Me || e instanceof we) return true;
                    if (e instanceof Ue && _.loopcontrol_target(e) === n) v = true;
                });
                n.walk(_);
                if (!v) {
                    var m = a[0].body.slice();
                    var l = a[0].expression;
                    if (l) m.unshift(re(we, l, {
                        body: l
                    }));
                    m.unshift(re(we, n.expression, {
                        body: n.expression
                    }));
                    return re(Ae, n, {
                        body: m
                    }).optimize(e);
                }
            }
            return n;
            function g(e, n) {
                if (n && !D(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    b(e, o);
                }
            }
        });
        e(We, function(e, n) {
            i(e.body, n);
            if (e.bcatch && e.bfinally && ve(e.bfinally.body, L)) e.bfinally = null;
            if (n.option("dead_code") && ve(e.body, L)) {
                var t = [];
                if (e.bcatch) {
                    b(e.bcatch, t);
                    t.forEach(function(e) {
                        if (!(e instanceof Ze)) return;
                        e.definitions.forEach(function(e) {
                            var n = e.name.definition().redefined();
                            if (!n) return;
                            e.name = e.name.clone();
                            e.name.thedef = n;
                        });
                    });
                }
                if (e.bfinally) t = t.concat(e.bfinally.body);
                return re(Ae, e, {
                    body: t
                }).optimize(n);
            }
            return e;
        });
        Ze.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        Ze.DEFMETHOD("to_assignments", function(e) {
            var i = e.option("reduce_vars");
            var n = this.definitions.reduce(function(e, n) {
                if (n.value) {
                    var t = re(xn, n.name, n.name);
                    e.push(re(pn, n, {
                        operator: "=",
                        left: t,
                        right: n.value
                    }));
                    if (i) t.definition().fixed = false;
                }
                n = n.name.definition();
                n.eliminated++;
                n.replaced--;
                return e;
            }, []);
            if (n.length == 0) return null;
            return P(this, n);
        });
        e(Ze, function(e, n) {
            return e.definitions.length ? e : re(Ee, e);
        });
        en.DEFMETHOD("lift_sequences", function(e) {
            if (!e.option("sequences")) return this;
            var n = this.expression;
            if (!(n instanceof tn)) return this;
            var t = n.tail_node();
            if (a(e, t) && !(this instanceof nn)) return this;
            var i = n.expressions.slice(0, -1);
            var r = this.clone();
            r.expression = t;
            i.push(r);
            return P(this, i).optimize(e);
        });
        e(en, function(s, r) {
            var e = s.lift_sequences(r);
            if (e !== s) {
                return e;
            }
            var o = s.expression;
            var l = o;
            if (r.option("reduce_vars") && l instanceof xn) {
                l = l.fixed_value();
            }
            var n = l instanceof Me;
            if (r.option("unused") && n && !l.uses_arguments && !l.pinned()) {
                var t = 0, i = 0;
                for (var a = 0; a < s.args.length; a++) {
                    var u = a >= l.argnames.length;
                    if (u || l.argnames[a].__unused) {
                        var f = s.args[a].drop_side_effect_free(r);
                        if (f) {
                            s.args[t++] = f;
                        } else if (!u) {
                            s.args[t++] = re(Dn, s.args[a], {
                                value: 0
                            });
                            continue;
                        }
                    } else {
                        s.args[t++] = s.args[a];
                    }
                    i = t;
                }
                s.args.length = i;
            }
            if (r.option("unsafe")) {
                if (J(o)) switch (o.name) {
                  case "Array":
                    if (s.args.length == 1) {
                        var c = s.args[0];
                        if (c instanceof Dn) try {
                            var p = c.getValue();
                            if (p > 6) break;
                            var d = Array(p);
                            for (var a = 0; a < p; a++) d[a] = re(Tn, s);
                            return re(dn, s, {
                                elements: d
                            });
                        } catch (e) {
                            me.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: p,
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                            break;
                        }
                        if (!c.is_boolean(r) && !c.is_string(r)) break;
                    }
                    return re(dn, s, {
                        elements: s.args
                    });

                  case "Object":
                    if (s.args.length == 0) {
                        return re(hn, s, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (s.args.length == 0) return re(kn, s, {
                        value: ""
                    });
                    if (s.args.length <= 1) return re(cn, s, {
                        left: s.args[0],
                        operator: "+",
                        right: re(kn, s, {
                            value: ""
                        })
                    }).optimize(r);
                    break;

                  case "Number":
                    if (s.args.length == 0) return re(Dn, s, {
                        value: 0
                    });
                    if (s.args.length == 1) return re(un, s, {
                        expression: s.args[0],
                        operator: "+"
                    }).optimize(r);

                  case "Boolean":
                    if (s.args.length == 0) return re(zn, s);
                    if (s.args.length == 1) return re(un, s, {
                        expression: re(un, s, {
                            expression: s.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(r);
                    break;

                  case "RegExp":
                    var h = [];
                    if (ve(s.args, function(e) {
                        var n = e.evaluate(r);
                        h.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return G(r, s, re(Fn, s, {
                                value: RegExp.apply(RegExp, h)
                            }));
                        } catch (e) {
                            me.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: s.print_to_string(),
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof on) switch (o.property) {
                  case "toString":
                    if (s.args.length == 0 && !o.expression.may_throw_on_access(r)) {
                        return re(cn, s, {
                            left: re(kn, s, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(r);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof dn) e: {
                        var v;
                        if (s.args.length > 0) {
                            v = s.args[0].evaluate(r);
                            if (v === s.args[0]) break e;
                        }
                        var d = [];
                        var _ = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(r);
                            if (n !== e) {
                                _.push(n);
                            } else {
                                if (_.length > 0) {
                                    d.push(re(kn, s, {
                                        value: _.join(v)
                                    }));
                                    _.length = 0;
                                }
                                d.push(e);
                            }
                        });
                        if (_.length > 0) {
                            d.push(re(kn, s, {
                                value: _.join(v)
                            }));
                        }
                        if (d.length == 0) return re(kn, s, {
                            value: ""
                        });
                        if (d.length == 1) {
                            if (d[0].is_string(r)) {
                                return d[0];
                            }
                            return re(cn, d[0], {
                                operator: "+",
                                left: re(kn, s, {
                                    value: ""
                                }),
                                right: d[0]
                            });
                        }
                        if (v == "") {
                            var c;
                            if (d[0].is_string(r) || d[1].is_string(r)) {
                                c = d.shift();
                            } else {
                                c = re(kn, s, {
                                    value: ""
                                });
                            }
                            return d.reduce(function(e, n) {
                                return re(cn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, c).optimize(r);
                        }
                        var f = s.clone();
                        f.expression = f.expression.clone();
                        f.expression.expression = f.expression.expression.clone();
                        f.expression.expression.elements = d;
                        return G(r, s, f);
                    }
                    break;

                  case "charAt":
                    if (s.args.length < 2) {
                        var f = re(an, s, {
                            expression: o.expression,
                            property: s.args.length ? re(cn, s.args[0], {
                                operator: "|",
                                left: re(Dn, s, {
                                    value: 0
                                }),
                                right: s.args[0]
                            }) : re(Dn, s, {
                                value: 0
                            })
                        });
                        f.is_string = ee;
                        return f.optimize(r);
                    }
                    break;

                  case "apply":
                    if (s.args.length == 2 && s.args[1] instanceof dn) {
                        var m = s.args[1].elements.slice();
                        m.unshift(s.args[0]);
                        return re(en, s, {
                            expression: re(on, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: m
                        }).optimize(r);
                    }
                    break;

                  case "call":
                    var g = o.expression;
                    if (g instanceof xn) {
                        g = g.fixed_value();
                    }
                    if (g instanceof Me && !g.contains_this()) {
                        return (s.args.length ? P(this, [ s.args[0], re(en, s, {
                            expression: o.expression,
                            args: s.args.slice(1)
                        }) ]) : re(en, s, {
                            expression: o.expression,
                            args: []
                        })).optimize(r);
                    }
                    break;
                }
            }
            if (r.option("unsafe_Function") && J(o) && o.name == "Function") {
                if (s.args.length == 0) return re(je, s, {
                    argnames: [],
                    body: []
                });
                if (ve(s.args, function(e) {
                    return e instanceof kn;
                })) {
                    try {
                        var b = "n(function(" + s.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + s.args[s.args.length - 1].value + "})";
                        var y = nt(b);
                        var w = {
                            ie8: r.option("ie8")
                        };
                        y.figure_out_scope(w);
                        var x = new at(r.options);
                        y = y.transform(x);
                        y.figure_out_scope(w);
                        y.compute_char_frequency(w);
                        y.mangle_names(w);
                        var A;
                        y.walk(new qn(function(e) {
                            if (A) return true;
                            if (e instanceof Me) {
                                A = e;
                                return true;
                            }
                        }));
                        var b = ot();
                        Ae.prototype._codegen.call(A, A, b);
                        s.args = [ re(kn, s, {
                            value: A.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), re(kn, s.args[s.args.length - 1], {
                            value: b.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return s;
                    } catch (e) {
                        if (e instanceof Ln) {
                            me.warn("Error parsing code passed to new Function [{file}:{line},{col}]", s.args[s.args.length - 1].start);
                            me.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var E = n && l.body[0];
            var k = r.option("inline") && !s.is_expr_pure(r);
            if (k && E instanceof Re) {
                var D = E.value;
                if (!D || D.is_constant_expression()) {
                    if (D) {
                        D = D.clone(true);
                    } else {
                        D = re(Sn, s);
                    }
                    var m = s.args.concat(D);
                    return P(s, m).optimize(r);
                }
            }
            if (n) {
                var F, D, C, B, S = -1;
                if (k && !l.uses_arguments && !l.pinned() && !(l.name && l instanceof je) && (D = z(E)) && (o === l || r.option("unused") && (F = o.definition()).references.length == 1 && !Z(r, F) && l.is_constant_expression(o.scope)) && !s.pure && !l.contains_this() && H()) {
                    l._squeezed = true;
                    return P(s, U()).optimize(r);
                }
                if (r.option("side_effects") && ve(l.body, L) && (l !== o || X(l, r))) {
                    var m = s.args.concat(re(Sn, s));
                    return P(s, m).optimize(r);
                }
            }
            if (r.option("drop_console")) {
                if (o instanceof rn) {
                    var T = o.expression;
                    while (T.expression) {
                        T = T.expression;
                    }
                    if (J(T) && T.name == "console") {
                        return re(Sn, s).optimize(r);
                    }
                }
            }
            if (r.option("negate_iife") && r.parent() instanceof we && Y(s)) {
                return s.negate(r, true);
            }
            var O = s.evaluate(r);
            if (O !== s) {
                O = V(O, s).optimize(r);
                return G(r, O, s);
            }
            return s;
            function $(e) {
                if (!e) return re(Sn, s);
                if (e instanceof Re) {
                    if (!e.value) return re(Sn, s);
                    return e.value.clone(true);
                }
                if (e instanceof we) {
                    return re(un, e, {
                        operator: "void",
                        expression: e.body.clone(true)
                    });
                }
            }
            function z(e) {
                var n = l.body.length;
                if (r.option("inline") < 3) {
                    return n == 1 && $(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = l.body[t];
                    if (i instanceof Ke) {
                        if (e && !ve(i.definitions, function(e) {
                            return !e.value;
                        })) {
                            return false;
                        }
                    } else if (i instanceof He || i instanceof Ee) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return $(e);
            }
            function M(e, n) {
                return e[n] || W[n] || C.var_names()[n];
            }
            function q(e, n, t) {
                for (var i = 0; i < l.argnames.length; i++) {
                    var r = l.argnames[i];
                    if (r.__unused) continue;
                    if (!t || M(e, r.name)) return false;
                    n[r.name] = true;
                    if (B) B.push(r.definition());
                }
                return true;
            }
            function j(e, n, t) {
                for (var i = 0; i < l.body.length; i++) {
                    var r = l.body[i];
                    if (r instanceof He) {
                        if (!t || M(n, r.name.name)) return false;
                        continue;
                    }
                    if (!(r instanceof Ke)) continue;
                    if (!t) return false;
                    for (var o = r.definitions.length; --o >= 0; ) {
                        var a = r.definitions[o].name;
                        if (M(e, a.name)) return false;
                        if (B) B.push(a.definition());
                    }
                }
                return true;
            }
            function H() {
                var e = Object.create(null);
                do {
                    C = r.parent(++S);
                    if (C instanceof Ge) {
                        e[C.argname.name] = true;
                    } else if (C instanceof De) {
                        B = [];
                    } else if (C instanceof xn) {
                        if (C.fixed_value() instanceof $e) return false;
                    }
                } while (!(C instanceof $e));
                var n = (!(C instanceof ze) || r.toplevel.vars) && (o !== l || l.parent_scope === r.find_parent($e));
                var t = r.option("inline");
                var i = Object.create(e);
                if (!q(e, i, t >= 2 && n)) return false;
                if (!j(e, i, t >= 3 && n)) return false;
                return !B || B.length == 0 || !K(l, B);
            }
            function N(e, n, t, i) {
                var r = t.definition();
                C.variables.set(t.name, r);
                C.enclosed.push(r);
                if (!C.var_names()[t.name]) {
                    C.var_names()[t.name] = true;
                    e.push(re(Qe, t, {
                        name: t,
                        value: null
                    }));
                }
                var o = re(xn, t, t);
                r.references.push(o);
                if (i) n.push(re(pn, s, {
                    operator: "=",
                    left: o,
                    right: i
                }));
            }
            function R(e, n) {
                var t = l.argnames.length;
                for (var i = s.args.length; --i >= t; ) {
                    n.push(s.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = l.argnames[i];
                    var o = s.args[i];
                    if (r.__unused || C.var_names()[r.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = re(mn, r, r);
                        r.definition().orig.push(a);
                        if (!o && B) o = re(Sn, s);
                        N(e, n, a, o);
                    }
                }
                e.reverse();
                n.reverse();
            }
            function I(e, n) {
                var t = n.length;
                for (var i = 0; i < l.body.length; i++) {
                    var r = l.body[i];
                    if (!(r instanceof Ke)) continue;
                    for (var o = 0; o < r.definitions.length; o++) {
                        var a = r.definitions[o];
                        var s = a.name;
                        var u = s.definition().redefined();
                        if (u) {
                            s = s.clone();
                            s.thedef = u;
                        }
                        N(e, n, s, a.value);
                        if (B && ve(l.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var f = l.variables.get(s.name);
                            var c = re(xn, s, s);
                            f.references.push(c);
                            n.splice(t++, 0, re(pn, a, {
                                operator: "=",
                                left: c,
                                right: re(Sn, s)
                            }));
                        }
                    }
                }
            }
            function U() {
                var e = [];
                var n = [];
                R(e, n);
                I(e, n);
                n.push(D);
                var t = l.body.filter(function(e) {
                    if (e instanceof He) {
                        var n = e.name.definition();
                        C.functions.set(n.name, n);
                        C.variables.set(n.name, n);
                        C.enclosed.push(n);
                        C.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(C.body.indexOf(r.parent(S - 1)) + 1, 0);
                if (e.length) t.push(re(Ke, l, {
                    definitions: e
                }));
                [].splice.apply(C.body, t);
                return n;
            }
        });
        e(nn, function(e, n) {
            var t = e.lift_sequences(n);
            if (t !== e) {
                return t;
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (J(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return re(en, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        e(tn, function(e, r) {
            if (!r.option("side_effects")) return e;
            var o = [];
            t();
            var n = o.length - 1;
            i();
            if (n == 0) {
                e = oe(r, r.parent(), r.self(), o[0]);
                if (!(e instanceof tn)) e = e.optimize(r);
                return e;
            }
            e.expressions = o;
            return e;
            function t() {
                var t = j(r);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(r, t);
                    if (e) {
                        h(o, e);
                        t = false;
                    }
                });
            }
            function i() {
                while (n > 0 && E(o[n], r)) n--;
                if (n < o.length - 1) {
                    o[n] = re(un, e, {
                        operator: "void",
                        expression: o[n]
                    });
                    o.length = n + 1;
                }
            }
        });
        sn.DEFMETHOD("lift_sequences", function(e) {
            if (e.option("sequences") && this.expression instanceof tn) {
                var n = this.expression.expressions.slice();
                var t = this.clone();
                t.expression = n.pop();
                n.push(t);
                return P(this, n).optimize(e);
            }
            return this;
        });
        e(fn, function(e, n) {
            return e.lift_sequences(n);
        });
        e(un, function(e, n) {
            var t = e.expression;
            if (n.option("evaluate") && e.operator == "delete" && !(t instanceof xn || t instanceof rn || s(t))) {
                if (t instanceof tn) {
                    t = t.expressions.slice();
                    t.push(re(Mn, e));
                    return P(e, t).optimize(n);
                }
                return P(e, [ t, re(Mn, e) ]).optimize(n);
            }
            var i = e.lift_sequences(n);
            if (i !== e) {
                return i;
            }
            if (n.option("side_effects") && e.operator == "void") {
                t = t.drop_side_effect_free(n);
                if (t) {
                    e.expression = t;
                    return e;
                } else {
                    return re(Sn, e).optimize(n);
                }
            }
            if (n.option("booleans")) {
                if (e.operator == "!" && t.is_truthy()) {
                    return P(e, [ t, re(zn, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (e.operator) {
                  case "!":
                    if (t instanceof un && t.operator == "!") {
                        return t.expression;
                    }
                    if (t instanceof cn) {
                        e = G(n, e, t.negate(n, j(n)));
                    }
                    break;

                  case "typeof":
                    me.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    return (t instanceof xn ? re(Mn, e) : P(e, [ t, re(Mn, e) ])).optimize(n);
                }
            }
            if (e.operator == "-" && t instanceof On) {
                t = t.transform(n);
            }
            if (t instanceof cn && (e.operator == "+" || e.operator == "-") && (t.operator == "*" || t.operator == "/" || t.operator == "%")) {
                return re(cn, e, {
                    operator: t.operator,
                    left: re(un, t.left, {
                        operator: e.operator,
                        expression: t.left
                    }),
                    right: t.right
                });
            }
            if (e.operator != "-" || !(t instanceof Dn || t instanceof On)) {
                var r = e.evaluate(n);
                if (r !== e) {
                    r = V(r, e).optimize(n);
                    return G(n, r, e);
                }
            }
            return e;
        });
        cn.DEFMETHOD("lift_sequences", function(e) {
            if (e.option("sequences")) {
                if (this.left instanceof tn) {
                    var n = this.left.expressions.slice();
                    var t = this.clone();
                    t.left = n.pop();
                    n.push(t);
                    return P(this, n).optimize(e);
                }
                if (this.right instanceof tn && !this.left.has_side_effects(e)) {
                    var i = this.operator == "=" && this.left instanceof xn;
                    var n = this.right.expressions;
                    var r = n.length - 1;
                    for (var o = 0; o < r; o++) {
                        if (!i && n[o].has_side_effects(e)) break;
                    }
                    if (o == r) {
                        n = n.slice();
                        var t = this.clone();
                        t.right = n.pop();
                        n.push(t);
                        return P(this, n).optimize(e);
                    } else if (o > 0) {
                        var t = this.clone();
                        t.right = P(this.right, n.slice(o));
                        n = n.slice(0, o);
                        n.push(t);
                        return P(this, n).optimize(e);
                    }
                }
            }
            return this;
        });
        var F = he("indexOf lastIndexOf");
        var C = he("== === != !== * & | ^");
        function B(e) {
            return e instanceof dn || e instanceof Me || e instanceof hn;
        }
        e(cn, function(t, n) {
            function i() {
                return t.left.is_constant() || t.right.is_constant() || !t.left.has_side_effects(n) && !t.right.has_side_effects(n);
            }
            function e(e) {
                if (i()) {
                    if (e) t.operator = e;
                    var n = t.left;
                    t.left = t.right;
                    t.right = n;
                }
            }
            if (C[t.operator] && t.right.is_constant() && !t.left.is_constant()) {
                if (!(t.left instanceof cn && Qn[t.left.operator] >= Qn[t.operator])) {
                    e();
                }
            }
            t = t.lift_sequences(n);
            if (n.option("assignments") && se[t.operator]) {
                var r = t.right;
                if (t.left instanceof xn && r instanceof pn && r.operator == "=" && t.left.equivalent_to(r.left)) {
                    t.right = r.right;
                    r.right = t;
                    return r;
                }
            }
            if (n.option("comparisons")) switch (t.operator) {
              case "===":
              case "!==":
                if (E(t.left, n) && t.right.is_defined(n)) {
                    me.warn("Expression always defined [{file}:{line},{col}]", t.start);
                    return P(t, [ t.right, re(t.operator == "===" ? zn : Mn, t) ]).optimize(n);
                }
                var o = true;
                if (t.left.is_string(n) && t.right.is_string(n) || t.left.is_number(n) && t.right.is_number(n) || t.left.is_boolean(n) && t.right.is_boolean(n) || t.left.equivalent_to(t.right)) {
                    t.operator = t.operator.substr(0, 2);
                }

              case "==":
              case "!=":
                if (!o && E(t.left, n)) {
                    t.left = re(Cn, t.left);
                } else if (n.option("typeofs") && t.left instanceof kn && t.left.value == "undefined" && t.right instanceof un && t.right.operator == "typeof") {
                    var a = t.right.expression;
                    if (a instanceof xn ? a.is_declared(n) : !(a instanceof rn && n.option("ie8"))) {
                        t.right = a;
                        t.left = re(Sn, t.left).optimize(n);
                        if (t.operator.length == 2) t.operator += "=";
                    }
                } else if (t.left instanceof xn && t.right instanceof xn && t.left.definition() === t.right.definition() && B(t.left.fixed_value())) {
                    return re(t.operator[0] == "=" ? Mn : zn, t);
                }
                break;

              case "&&":
              case "||":
                var s = t.left;
                if (s.operator == t.operator) {
                    s = s.right;
                }
                if (s instanceof cn && s.operator == (t.operator == "&&" ? "!==" : "===") && t.right instanceof cn && s.operator == t.right.operator && (E(s.left, n) && t.right.left instanceof Cn || s.left instanceof Cn && E(t.right.left, n)) && !s.right.has_side_effects(n) && s.right.equivalent_to(t.right.right)) {
                    var u = re(cn, t, {
                        operator: s.operator.slice(0, -1),
                        left: re(Cn, t),
                        right: s.right
                    });
                    if (s !== t.left) {
                        u = re(cn, t, {
                            operator: t.operator,
                            left: t.left.left,
                            right: u
                        });
                    }
                    return u;
                }
                break;
            }
            var f = n.option("booleans") && n.in_boolean_context();
            if (f) switch (t.operator) {
              case "+":
                var c = t.left.evaluate(n);
                var l = t.right.evaluate(n);
                if (c && typeof c == "string") {
                    me.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return P(t, [ t.right, re(Mn, t) ]).optimize(n);
                }
                if (l && typeof l == "string") {
                    me.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return P(t, [ t.left, re(Mn, t) ]).optimize(n);
                }
                break;

              case "==":
                if (t.left instanceof kn && t.left.getValue() == "" && t.right.is_string(n)) {
                    return re(un, t, {
                        operator: "!",
                        expression: t.right
                    }).optimize(n);
                }
                break;

              case "!=":
                if (t.left instanceof kn && t.left.getValue() == "" && t.right.is_string(n)) {
                    return t.right.optimize(n);
                }
                break;
            }
            var p = n.parent();
            if (n.option("comparisons") && t.is_boolean(n)) {
                if (!(p instanceof cn) || p instanceof pn) {
                    var d = re(un, t, {
                        operator: "!",
                        expression: t.negate(n, j(n))
                    });
                    t = G(n, t, d);
                }
                switch (t.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (t.operator == "+") {
                if (t.right instanceof kn && t.right.getValue() == "" && t.left.is_string(n)) {
                    return t.left.optimize(n);
                }
                if (t.left instanceof kn && t.left.getValue() == "" && t.right.is_string(n)) {
                    return t.right.optimize(n);
                }
                if (t.left instanceof cn && t.left.operator == "+" && t.left.left instanceof kn && t.left.left.getValue() == "" && t.right.is_string(n)) {
                    t.left = t.left.right;
                    return t.optimize(n);
                }
            }
            if (n.option("evaluate")) {
                switch (t.operator) {
                  case "&&":
                    var c = w(t.left);
                    if (!c) {
                        me.warn("Condition left of && always false [{file}:{line},{col}]", t.start);
                        return oe(n, p, n.self(), t.left).optimize(n);
                    } else if (!(c instanceof me)) {
                        me.warn("Condition left of && always true [{file}:{line},{col}]", t.start);
                        return P(t, [ t.left, t.right ]).optimize(n);
                    }
                    var l = t.right.evaluate(n);
                    if (!l) {
                        if (f) {
                            me.warn("Boolean && always false [{file}:{line},{col}]", t.start);
                            return P(t, [ t.left, re(zn, t) ]).optimize(n);
                        } else t.falsy = true;
                    } else if (!(l instanceof me)) {
                        if (f || p.operator == "&&" && p.left === n.self()) {
                            me.warn("Dropping side-effect-free && [{file}:{line},{col}]", t.start);
                            return t.left.optimize(n);
                        }
                    }
                    if (t.left.operator == "||") {
                        var h = t.left.right.evaluate(n);
                        if (!h) return re(ln, t, {
                            condition: t.left.left,
                            consequent: t.right,
                            alternative: t.left.right
                        }).optimize(n);
                    }
                    break;

                  case "||":
                    var c = w(t.left);
                    if (!c) {
                        me.warn("Condition left of || always false [{file}:{line},{col}]", t.start);
                        return P(t, [ t.left, t.right ]).optimize(n);
                    } else if (!(c instanceof me)) {
                        me.warn("Condition left of || always true [{file}:{line},{col}]", t.start);
                        return oe(n, p, n.self(), t.left).optimize(n);
                    }
                    var l = t.right.evaluate(n);
                    if (!l) {
                        if (f || p.operator == "||" && p.left === n.self()) {
                            me.warn("Dropping side-effect-free || [{file}:{line},{col}]", t.start);
                            return t.left.optimize(n);
                        }
                    } else if (!(l instanceof me)) {
                        if (f) {
                            me.warn("Boolean || always true [{file}:{line},{col}]", t.start);
                            return P(t, [ t.left, re(Mn, t) ]).optimize(n);
                        } else t.truthy = true;
                    }
                    if (t.left.operator == "&&") {
                        var h = t.left.right.evaluate(n);
                        if (h && !(h instanceof me)) return re(ln, t, {
                            condition: t.left.left,
                            consequent: t.left.right,
                            alternative: t.right
                        }).optimize(n);
                    }
                    break;
                }
                var v = true;
                switch (t.operator) {
                  case "+":
                    if (t.left instanceof En && t.right instanceof cn && t.right.operator == "+" && t.right.left instanceof En && t.right.is_string(n)) {
                        t = re(cn, t, {
                            operator: "+",
                            left: re(kn, t.left, {
                                value: "" + t.left.getValue() + t.right.left.getValue(),
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof En && t.left instanceof cn && t.left.operator == "+" && t.left.right instanceof En && t.left.is_string(n)) {
                        t = re(cn, t, {
                            operator: "+",
                            left: t.left.left,
                            right: re(kn, t.right, {
                                value: "" + t.left.right.getValue() + t.right.getValue(),
                                start: t.left.right.start,
                                end: t.right.end
                            })
                        });
                    }
                    if (t.left instanceof cn && t.left.operator == "+" && t.left.is_string(n) && t.left.right instanceof En && t.right instanceof cn && t.right.operator == "+" && t.right.left instanceof En && t.right.is_string(n)) {
                        t = re(cn, t, {
                            operator: "+",
                            left: re(cn, t.left, {
                                operator: "+",
                                left: t.left.left,
                                right: re(kn, t.left.right, {
                                    value: "" + t.left.right.getValue() + t.right.left.getValue(),
                                    start: t.left.right.start,
                                    end: t.right.left.end
                                })
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof un && t.right.operator == "-" && t.left.is_number(n)) {
                        t = re(cn, t, {
                            operator: "-",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }
                    if (t.left instanceof un && t.left.operator == "-" && i() && t.right.is_number(n)) {
                        t = re(cn, t, {
                            operator: "-",
                            left: t.right,
                            right: t.left.expression
                        });
                        break;
                    }

                  case "*":
                    v = n.option("unsafe_math");

                  case "&":
                  case "|":
                  case "^":
                    if (t.left.is_number(n) && t.right.is_number(n) && i() && !(t.left instanceof cn && t.left.operator != t.operator && Qn[t.left.operator] >= Qn[t.operator])) {
                        var _ = re(cn, t, {
                            operator: t.operator,
                            left: t.right,
                            right: t.left
                        });
                        if (t.right instanceof En && !(t.left instanceof En)) {
                            t = G(n, _, t);
                        } else {
                            t = G(n, t, _);
                        }
                    }
                    if (v && t.is_number(n)) {
                        if (t.right instanceof cn && t.right.operator == t.operator) {
                            t = re(cn, t, {
                                operator: t.operator,
                                left: re(cn, t.left, {
                                    operator: t.operator,
                                    left: t.left,
                                    right: t.right.left,
                                    start: t.left.start,
                                    end: t.right.left.end
                                }),
                                right: t.right.right
                            });
                        }
                        if (t.right instanceof En && t.left instanceof cn && t.left.operator == t.operator) {
                            if (t.left.left instanceof En) {
                                t = re(cn, t, {
                                    operator: t.operator,
                                    left: re(cn, t.left, {
                                        operator: t.operator,
                                        left: t.left.left,
                                        right: t.right,
                                        start: t.left.left.start,
                                        end: t.right.end
                                    }),
                                    right: t.left.right
                                });
                            } else if (t.left.right instanceof En) {
                                t = re(cn, t, {
                                    operator: t.operator,
                                    left: re(cn, t.left, {
                                        operator: t.operator,
                                        left: t.left.right,
                                        right: t.right,
                                        start: t.left.right.start,
                                        end: t.right.end
                                    }),
                                    right: t.left.left
                                });
                            }
                        }
                        if (t.left instanceof cn && t.left.operator == t.operator && t.left.right instanceof En && t.right instanceof cn && t.right.operator == t.operator && t.right.left instanceof En) {
                            t = re(cn, t, {
                                operator: t.operator,
                                left: re(cn, t.left, {
                                    operator: t.operator,
                                    left: re(cn, t.left.left, {
                                        operator: t.operator,
                                        left: t.left.right,
                                        right: t.right.left,
                                        start: t.left.right.start,
                                        end: t.right.left.end
                                    }),
                                    right: t.left.left
                                }),
                                right: t.right.right
                            });
                        }
                    }
                }
            }
            if (n.option("unsafe")) {
                var m = x(t.right);
                if (f && m && (t.operator == "==" || t.operator == "!=") && t.left instanceof Dn && t.left.getValue() == 0) {
                    return (t.operator == "==" ? re(un, t, {
                        operator: "!",
                        expression: t.right
                    }) : t.right).optimize(n);
                }
                var g = x(t.left);
                if (n.option("comparisons") && A()) {
                    var b = re(un, t, {
                        operator: "!",
                        expression: re(un, t, {
                            operator: "~",
                            expression: g ? t.left : t.right
                        })
                    });
                    switch (t.operator) {
                      case "<":
                        if (g) break;

                      case "<=":
                      case "!=":
                        b = re(un, t, {
                            operator: "!",
                            expression: b
                        });
                        break;
                    }
                    return b.optimize(n);
                }
            }
            if (t.right instanceof cn && t.right.operator == t.operator && (se[t.operator] || t.operator == "+" && (t.right.left.is_string(n) || t.left.is_string(n) && t.right.right.is_string(n)))) {
                t.left = re(cn, t.left, {
                    operator: t.operator,
                    left: t.left,
                    right: t.right.left
                });
                t.right = t.right.right;
                return t.transform(n);
            }
            var y = t.evaluate(n);
            if (y !== t) {
                y = V(y, t).optimize(n);
                return G(n, y, t);
            }
            return t;
            function w(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(n);
            }
            function x(e) {
                return e instanceof en && e.expression instanceof on && F[e.expression.property];
            }
            function A() {
                switch (t.operator) {
                  case "<=":
                    return m && t.left instanceof Dn && t.left.getValue() == 0;

                  case "<":
                    if (g && t.right instanceof Dn && t.right.getValue() == 0) return true;

                  case "==":
                  case "!=":
                    if (!m) return false;
                    return t.left instanceof Dn && t.left.getValue() == -1 || t.left instanceof un && t.left.operator == "-" && t.left.expression instanceof Dn && t.left.expression.getValue() == 1;
                }
            }
        });
        function Z(e, n) {
            var t;
            for (var i = 0; t = e.parent(i); i++) {
                if (t instanceof Me) {
                    var r = t.name;
                    if (r && r.definition() === n) break;
                }
            }
            return t;
        }
        e(xn, function(e, n) {
            if (!n.option("ie8") && J(e) && !(e.scope.uses_with && n.find_parent(Oe))) {
                switch (e.name) {
                  case "undefined":
                    return re(Sn, e).optimize(n);

                  case "NaN":
                    return re(Bn, e).optimize(n);

                  case "Infinity":
                    return re(On, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && fe(n.self(), t) !== n.self()) {
                var i = e.definition();
                var o = e.fixed_value();
                var r = i.single_use && !(t instanceof en && t.is_expr_pure(n));
                if (r && o instanceof Me) {
                    if (i.scope !== e.scope && (!n.option("reduce_funcs") || i.escaped.depth == 1 || o.inlined)) {
                        r = false;
                    } else if (Z(n, i)) {
                        r = false;
                    } else if (i.scope !== e.scope || i.orig[0] instanceof gn) {
                        r = o.is_constant_expression(e.scope);
                        if (r == "f") {
                            var a = e.scope;
                            do {
                                if (a instanceof He || a instanceof je) {
                                    a.inlined = true;
                                }
                            } while (a = a.parent_scope);
                        }
                    }
                }
                if (r && o) {
                    i.single_use = false;
                    o._squeezed = true;
                    if (o instanceof He) {
                        o = re(je, o, o);
                        o.name = re(yn, o.name, o.name);
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = o.clone(true);
                        var u = s.name.definition();
                        var f = s.variables.get(s.name.name);
                        var c = f && f.orig[0];
                        if (!(c instanceof yn)) {
                            c = re(yn, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            f = s.def_function(c);
                        }
                        s.walk(new qn(function(e) {
                            if (!(e instanceof xn)) return;
                            var n = e.definition();
                            if (n === u) {
                                e.thedef = f;
                                f.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof Me)) return;
                                if (!t.name) return;
                                var i = t.name.definition();
                                if (i.scope !== t.name.scope) return;
                                if (o.variables.get(t.name.name) !== i) return;
                                t.name = t.name.clone();
                                var r = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = r;
                                r.references.push(e);
                            }
                        }));
                    } else {
                        s = o.optimize(n);
                    }
                    i.replaced++;
                    return s;
                }
                if (o && i.should_replace === undefined) {
                    var l;
                    if (o instanceof An) {
                        if (!(i.orig[0] instanceof gn) && ve(i.references, function(e) {
                            return i.scope === e.scope;
                        })) {
                            l = o;
                        }
                    } else {
                        var p = o.evaluate(n);
                        if (p !== o && (n.option("unsafe_regexp") || !(p instanceof RegExp))) {
                            l = V(p, o);
                        }
                    }
                    if (l) {
                        var d = l.optimize(n).print_to_string().length;
                        var h;
                        if (m(o)) {
                            h = function() {
                                var e = l.optimize(n);
                                return e === l ? e.clone(true) : e;
                            };
                        } else {
                            d = Math.min(d, o.print_to_string().length);
                            h = function() {
                                var e = k(l.optimize(n), o);
                                return e === l || e === o ? e.clone(true) : e;
                            };
                        }
                        var v = i.name.length;
                        var _ = 0;
                        if (n.option("unused") && !n.exposed(i)) {
                            _ = (v + 2 + d) / (i.references.length - i.assignments);
                        }
                        i.should_replace = d <= v + _ ? h : false;
                    } else {
                        i.should_replace = false;
                    }
                }
                if (i.should_replace) {
                    var s = i.should_replace();
                    i.replaced++;
                    return s;
                }
            }
            return e;
            function m(e) {
                var n;
                e.walk(new qn(function(e) {
                    if (e instanceof xn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function d(e, n) {
            return e instanceof xn || e.TYPE === n.TYPE;
        }
        e(Sn, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = o(n, "undefined");
                if (t) {
                    var i = re(xn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = fe(n.self(), n.parent());
            if (r && d(r, e)) return e;
            return re(un, e, {
                operator: "void",
                expression: re(Dn, e, {
                    value: 0
                })
            });
        });
        e(On, function(e, n) {
            var t = fe(n.self(), n.parent());
            if (t && d(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !d(t, e)) && !o(n, "Infinity")) return e;
            return re(cn, e, {
                operator: "/",
                left: re(Dn, e, {
                    value: 1
                }),
                right: re(Dn, e, {
                    value: 0
                })
            });
        });
        e(Bn, function(e, n) {
            var t = fe(n.self(), n.parent());
            if (t && !d(t, e) || o(n, "NaN")) {
                return re(cn, e, {
                    operator: "/",
                    left: re(Dn, e, {
                        value: 0
                    }),
                    right: re(Dn, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function K(t, n) {
            var i = false;
            var r = new qn(function(e) {
                if (i) return true;
                if (e instanceof xn && ce(e.definition(), n)) {
                    return i = true;
                }
            });
            var o = new qn(function(e) {
                if (i) return true;
                if (e instanceof $e && e !== t) {
                    var n = o.parent();
                    if (n instanceof en && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(o);
            return i;
        }
        var m = he("+ - / * % >> << >>> | ^ &");
        var S = he("* | ^ &");
        e(pn, function(a, s) {
            var e;
            if (s.option("dead_code") && a.left instanceof xn && (e = a.left.definition()).scope === s.find_parent(Me)) {
                if (a.left.is_immutable()) return u();
                var n = 0, t, i = a;
                do {
                    t = i;
                    i = s.parent(n++);
                    if (i instanceof Ne) {
                        if (o(n, i)) break;
                        if (K(e.scope, [ e ])) break;
                        e.fixed = false;
                        return u();
                    }
                } while (i instanceof cn && i.right === t || i instanceof tn && i.tail_node() === t || i instanceof un);
            }
            a = a.lift_sequences(s);
            if (!s.option("assignments")) return a;
            if (a.operator == "=" && a.left instanceof xn && a.right instanceof cn) {
                if (a.right.left instanceof xn && a.right.left.name == a.left.name && m[a.right.operator]) {
                    a.operator = a.right.operator + "=";
                    a.right = a.right.right;
                } else if (a.right.right instanceof xn && a.right.right.name == a.left.name && S[a.right.operator] && !a.right.left.has_side_effects(s)) {
                    a.operator = a.right.operator + "=";
                    a.right = a.right.left;
                }
            }
            if ((a.operator == "+=" || a.operator == "-=") && a.left.is_number(s) && a.right instanceof Dn && a.right.getValue() === 1) {
                var r = a.operator.slice(0, -1);
                return re(un, a, {
                    operator: r + r,
                    expression: a.left
                });
            }
            return a;
            function o(e, n) {
                var t = a.right;
                a.right = re(Cn, t);
                var i = n.may_throw(s);
                a.right = t;
                var r = a.left.definition().scope;
                var o;
                while ((o = s.parent(e++)) !== r) {
                    if (o instanceof We) {
                        if (o.bfinally) return true;
                        if (i && o.bcatch) return true;
                    }
                }
            }
            function u() {
                return (a.operator != "=" ? re(cn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : oe(s, s.parent(), a, a.right)).optimize(s);
            }
        });
        e(ln, function(e, r) {
            if (!r.option("conditionals")) return e;
            if (e.condition instanceof tn) {
                var n = e.condition.expressions.slice();
                e.condition = n.pop();
                n.push(e);
                return P(e, n);
            }
            var t = e.condition.is_truthy() || e.condition.tail_node().evaluate(r);
            if (!t) {
                me.warn("Condition always false [{file}:{line},{col}]", e.start);
                return P(e, [ e.condition, e.alternative ]).optimize(r);
            } else if (!(t instanceof me)) {
                me.warn("Condition always true [{file}:{line},{col}]", e.start);
                return P(e, [ e.condition, e.consequent ]).optimize(r);
            }
            var i = t.negate(r, j(r));
            if (G(r, t, i) === i) {
                e = re(ln, e, {
                    condition: i,
                    consequent: e.alternative,
                    alternative: e.consequent
                });
            }
            var o = e.condition;
            var a = e.consequent;
            var s = e.alternative;
            if (o instanceof xn && a instanceof xn && o.definition() === a.definition()) {
                return re(cn, e, {
                    operator: "||",
                    left: o,
                    right: s
                });
            }
            var u = a.tail_node();
            if (u instanceof pn) {
                var f = u.operator == "=";
                var c = f ? s.tail_node() : s;
                if ((f || a === u) && c instanceof pn && u.operator == c.operator && u.left.equivalent_to(c.left) && (f && !u.left.has_side_effects(r) || !o.has_side_effects(r) && g(a) && g(s))) {
                    return re(pn, e, {
                        operator: u.operator,
                        left: u.left,
                        right: re(ln, e, {
                            condition: o,
                            consequent: b(a),
                            alternative: b(s)
                        })
                    });
                }
            }
            var l;
            if (a instanceof en && s.TYPE === a.TYPE && a.args.length > 0 && a.args.length == s.args.length && a.expression.equivalent_to(s.expression) && !o.has_side_effects(r) && !a.expression.has_side_effects(r) && typeof (l = m()) == "number") {
                var p = a.clone();
                p.args[l] = re(ln, e, {
                    condition: o,
                    consequent: a.args[l],
                    alternative: s.args[l]
                });
                return p;
            }
            if (a instanceof ln && a.alternative.equivalent_to(s)) {
                return re(ln, e, {
                    condition: re(cn, e, {
                        left: o,
                        operator: "&&",
                        right: a.condition
                    }),
                    consequent: a.consequent,
                    alternative: s
                });
            }
            if (a.equivalent_to(s)) {
                return P(e, [ o, a ]).optimize(r);
            }
            if ((a instanceof tn || s instanceof tn) && a.tail_node().equivalent_to(s.tail_node())) {
                return P(e, [ re(ln, e, {
                    condition: o,
                    consequent: y(a),
                    alternative: y(s)
                }), a.tail_node() ]).optimize(r);
            }
            if (a instanceof cn && a.operator == "||" && a.right.equivalent_to(s)) {
                return re(cn, e, {
                    operator: "||",
                    left: re(cn, e, {
                        operator: "&&",
                        left: o,
                        right: a.left
                    }),
                    right: s
                }).optimize(r);
            }
            var d = r.option("booleans") && r.in_boolean_context();
            if (v(e.consequent)) {
                if (_(e.alternative)) {
                    return h(o);
                }
                return re(cn, e, {
                    operator: "||",
                    left: h(o),
                    right: e.alternative
                });
            }
            if (_(e.consequent)) {
                if (v(e.alternative)) {
                    return h(o.negate(r));
                }
                return re(cn, e, {
                    operator: "&&",
                    left: h(o.negate(r)),
                    right: e.alternative
                });
            }
            if (v(e.alternative)) {
                return re(cn, e, {
                    operator: "||",
                    left: h(o.negate(r)),
                    right: e.consequent
                });
            }
            if (_(e.alternative)) {
                return re(cn, e, {
                    operator: "&&",
                    left: h(o),
                    right: e.consequent
                });
            }
            return e;
            function h(e) {
                if (e.is_boolean(r)) return e;
                return re(un, e, {
                    operator: "!",
                    expression: e.negate(r)
                });
            }
            function v(e) {
                return e instanceof Mn || d && e instanceof En && e.getValue() || e instanceof un && e.operator == "!" && e.expression instanceof En && !e.expression.getValue();
            }
            function _(e) {
                return e instanceof zn || d && e instanceof En && !e.getValue() || e instanceof un && e.operator == "!" && e.expression instanceof En && e.expression.getValue();
            }
            function m() {
                var e = a.args;
                var n = s.args;
                for (var t = 0, i = e.length; t < i; t++) {
                    if (!e[t].equivalent_to(n[t])) {
                        for (var r = t + 1; r < i; r++) {
                            if (!e[r].equivalent_to(n[r])) return;
                        }
                        return t;
                    }
                }
            }
            function g(e) {
                if (e === e.tail_node()) return true;
                var n = e.expressions;
                for (var t = n.length - 1; --t >= 0; ) {
                    var i = n[t];
                    if (!(i instanceof pn) && i.has_side_effects(r) || i.operator != "=" || i.left.has_side_effects(r) || i.right.has_side_effects(r)) return false;
                }
                return true;
            }
            function b(e) {
                if (!(e instanceof tn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return P(e, n);
            }
            function y(e) {
                if (!(e instanceof tn)) return re(Dn, e, {
                    value: 0
                });
                return P(e, e.expressions.slice(0, -1));
            }
        });
        e($n, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return re(Dn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof cn && (t.operator == "==" || t.operator == "!=")) {
                me.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return re(Dn, e, {
                    value: +e.value
                });
            }
            return re(un, e, {
                operator: "!",
                expression: re(Dn, e, {
                    value: 1 - e.value
                })
            });
        });
        function T(e, n) {
            if (e instanceof xn) {
                e = e.fixed_value();
            }
            if (!e) return false;
            return !(e instanceof Me) || n.parent() instanceof nn || !e.contains_this();
        }
        e(an, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var o = parseFloat(r);
                            if (o.toString() == r) {
                                r = o;
                            }
                        }
                    }
                    i = e.property = k(i, V(r, i).transform(t));
                    var a = "" + r;
                    if (Pn(a) && a.length <= i.print_to_string().length + 1) {
                        return re(on, e, {
                            expression: n,
                            property: a
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var u, f, c;
            if (t.option("arguments") && n instanceof xn && te(u = n.definition()) && i instanceof Dn && (f = n.scope) === x()) {
                var l = i.getValue();
                if (s instanceof un && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[l] = true;
                }
                var p = f.argnames[l];
                if (u.deleted && u.deleted[l]) {
                    p = null;
                } else if (p && t.has_directive("use strict")) {
                    var d = p.definition();
                    if (!t.option("reduce_vars") || u.reassigned || d.assignments || d.orig.length > 1) {
                        p = null;
                    }
                } else if (!p && l < f.argnames.length + 5 && t.drop_fargs(f, c)) {
                    while (l >= f.argnames.length) {
                        p = re(gn, f, {
                            name: f.make_var_name("argument_" + f.argnames.length),
                            scope: f
                        });
                        f.argnames.push(p);
                        f.enclosed.push(f.def_variable(p));
                    }
                }
                if (p && le(function(e) {
                    return e.name === p.name;
                }, f.argnames) === p) {
                    u.reassigned = false;
                    var h = re(xn, e, p);
                    h.reference({});
                    delete p.__unused;
                    return h;
                }
            }
            if (fe(t.self(), s)) return e;
            if (r !== i) {
                var v = e.flatten_object(a, t);
                if (v) {
                    n = e.expression = v.expression;
                    i = e.property = v.property;
                }
            }
            if (t.option("properties") && t.option("side_effects") && i instanceof Dn && n instanceof dn) {
                var l = i.getValue();
                var _ = n.elements;
                var m = _[l];
                if (T(m, t)) {
                    var g = true;
                    var b = [];
                    for (var y = _.length; --y > l; ) {
                        var o = _[y].drop_side_effect_free(t);
                        if (o) {
                            b.unshift(o);
                            if (g && o.has_side_effects(t)) g = false;
                        }
                    }
                    m = m instanceof Tn ? re(Sn, m) : m;
                    if (!g) b.unshift(m);
                    while (--y >= 0) {
                        var o = _[y].drop_side_effect_free(t);
                        if (o) b.unshift(o); else l--;
                    }
                    if (g) {
                        b.push(m);
                        return P(e, b).optimize(t);
                    } else return re(an, e, {
                        expression: re(dn, n, {
                            elements: b
                        }),
                        property: re(Dn, i, {
                            value: l
                        })
                    });
                }
            }
            var w = e.evaluate(t);
            if (w !== e) {
                w = V(w, e).optimize(t);
                return G(t, w, e);
            }
            return e;
            function x() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Me) {
                        c = t.parent(e);
                        return n;
                    }
                }
            }
        });
        $e.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new qn(function(e) {
                if (n) return true;
                if (e instanceof An) return n = true;
                if (e !== t && e instanceof $e) return true;
            }));
            return n;
        });
        rn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof hn) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if ("" + o.key == e) {
                        if (!ve(i, function(e) {
                            return e instanceof vn;
                        })) break;
                        if (!T(o.value, n)) break;
                        return re(an, this, {
                            expression: re(dn, t, {
                                elements: i.map(function(e) {
                                    return e.value;
                                })
                            }),
                            property: re(Dn, this, {
                                value: r
                            })
                        });
                    }
                }
            }
        });
        e(on, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                me.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            if (fe(n.self(), n.parent())) return e;
            if (n.option("unsafe_proto") && e.expression instanceof on && e.expression.property == "prototype") {
                var t = e.expression.expression;
                if (J(t)) switch (t.name) {
                  case "Array":
                    e.expression = re(dn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = re(je, e.expression, {
                        argnames: [],
                        body: []
                    });
                    break;

                  case "Number":
                    e.expression = re(Dn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = re(hn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = re(Fn, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = re(kn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var i = e.flatten_object(e.property, n);
            if (i) return i.optimize(n);
            var r = e.evaluate(n);
            if (r !== e) {
                r = V(r, e).optimize(n);
                return G(n, r, e);
            }
            return e;
        });
        e(Re, function(e, n) {
            if (e.value && E(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function w(u) {
        u = te(u, {
            file: null,
            root: null,
            orig: null,
            orig_line_diff: 0,
            dest_line_diff: 0
        }, true);
        var f = new MOZ_SourceMap.SourceMapGenerator({
            file: u.file,
            sourceRoot: u.root
        });
        var c = u.orig && Object.create(null);
        if (c) for (var e in u.orig) {
            var t = new MOZ_SourceMap.SourceMapConsumer(u.orig[e]);
            if (Array.isArray(u.orig[e].sources)) {
                t._sources.toArray().forEach(function(e) {
                    var n = t.sourceContentFor(e, true);
                    if (n) f.setSourceContent(e, n);
                });
            }
            c[e] = t;
        }
        return {
            add: function(e, n, t, i, r, o) {
                var a = c && c[e];
                if (a) {
                    var s = a.originalPositionFor({
                        line: i,
                        column: r
                    });
                    if (s.source === null) return;
                    e = s.source;
                    i = s.line;
                    r = s.column;
                    o = s.name || o;
                }
                f.addMapping({
                    name: o,
                    source: e,
                    generated: {
                        line: n + u.dest_line_diff,
                        column: t
                    },
                    original: {
                        line: i + u.orig_line_diff,
                        column: r
                    }
                });
            },
            get: function() {
                return f;
            },
            toString: function() {
                return JSON.stringify(f.toJSON());
            }
        };
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof ge && e[t].body instanceof kn) {
                    e[t] = new ye({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof ge && e[t].body instanceof kn)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new ze({
                    start: s(e),
                    end: u(e),
                    body: n(e.body.map(f))
                });
            },
            FunctionDeclaration: function(e) {
                return new He({
                    start: s(e),
                    end: u(e),
                    name: f(e.id),
                    argnames: e.params.map(f),
                    body: n(f(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new je({
                    start: s(e),
                    end: u(e),
                    name: f(e.id),
                    argnames: e.params.map(f),
                    body: n(f(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new we({
                    start: s(e),
                    end: u(e),
                    body: f(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new We({
                    start: s(e),
                    end: u(e),
                    body: f(e.block).body,
                    bcatch: f(n[0]),
                    bfinally: e.finalizer ? new Xe(f(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: u(e.value),
                    key: n.type == "Identifier" ? n.name : n.value,
                    value: f(e.value)
                };
                if (e.kind == "init") return new vn(t);
                t.key = new ae({
                    name: t.key
                });
                t.value = new qe(t.value);
                if (e.kind == "get") return new oe(t);
                if (e.kind == "set") return new re(t);
            },
            ArrayExpression: function(e) {
                return new dn({
                    start: s(e),
                    end: u(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Tn() : f(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new hn({
                    start: s(e),
                    end: u(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return f(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new tn({
                    start: s(e),
                    end: u(e),
                    expressions: e.expressions.map(f)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? an : on)({
                    start: s(e),
                    end: u(e),
                    property: e.computed ? f(e.property) : e.property.name,
                    expression: f(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Je : Ye)({
                    start: s(e),
                    end: u(e),
                    expression: f(e.test),
                    body: e.consequent.map(f)
                });
            },
            VariableDeclaration: function(e) {
                return new Ke({
                    start: s(e),
                    end: u(e),
                    definitions: e.declarations.map(f)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: u(e)
                };
                if (n === null) return new Cn(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new Fn(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new Fn(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new kn(t);

                  case "number":
                    t.value = n;
                    return new Dn(t);

                  case "boolean":
                    return new (n ? Mn : zn)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? se : n.type == "VariableDeclarator" && n.id === e ? mn : n.type == "FunctionExpression" ? n.id === e ? yn : gn : n.type == "FunctionDeclaration" ? n.id === e ? bn : gn : n.type == "CatchClause" ? wn : n.type == "BreakStatement" || n.type == "ContinueStatement" ? ue : xn)({
                    start: s(e),
                    end: u(e),
                    name: e.name
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? un : fn)({
                start: s(n),
                end: u(n),
                operator: n.operator,
                expression: f(n.argument)
            });
        };
        e("EmptyStatement", Ee);
        e("BlockStatement", Ae, "body@body");
        e("IfStatement", Ve, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", ke, "label>label, body>body");
        e("BreakStatement", Ue, "label>label");
        e("ContinueStatement", Pe, "label>label");
        e("WithStatement", Oe, "object>expression, body>body");
        e("SwitchStatement", Le, "discriminant>expression, cases@body");
        e("ReturnStatement", Re, "argument>value");
        e("ThrowStatement", ie, "argument>value");
        e("WhileStatement", Be, "test>condition, body>body");
        e("DoWhileStatement", Ce, "test>condition, body>body");
        e("ForStatement", Se, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Te, "left>init, right>object, body>body");
        e("DebuggerStatement", be);
        e("VariableDeclarator", Qe, "id>name, init>value");
        e("CatchClause", Ge, "param>argname, body%body");
        e("ThisExpression", An);
        e("BinaryExpression", cn, "operator=operator, left>left, right>right");
        e("LogicalExpression", cn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", pn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", ln, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", nn, "callee>expression, arguments@args");
        e("CallExpression", en, "callee>expression, arguments@args");
        c(ze, function e(n) {
            return d("Program", n);
        });
        c(He, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(je, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(ye, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(we, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(R, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(We, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(Ge, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Ze, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(tn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(rn, function e(n) {
            var t = n instanceof an;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(sn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof un,
                argument: l(n.expression)
            };
        });
        c(cn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(dn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(hn, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(I, function e(n) {
            var t = {
                type: "Literal",
                value: n.key instanceof ae ? n.key.name : n.key
            };
            var i;
            if (n instanceof vn) {
                i = "init";
            } else if (n instanceof oe) {
                i = "get";
            } else if (n instanceof re) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(U, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Fn, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(En, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(a, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        $n.DEFMETHOD("to_mozilla_ast", En.prototype.to_mozilla_ast);
        Cn.DEFMETHOD("to_mozilla_ast", En.prototype.to_mozilla_ast);
        Tn.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        xe.DEFMETHOD("to_mozilla_ast", Ae.prototype.to_mozilla_ast);
        Me.DEFMETHOD("to_mozilla_ast", je.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function u(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                o += ",\n" + r + ": ";
                a += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + r;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(h, s, u, f);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, d);
            i[e] = o;
            c(n, a);
        }
        var o = null;
        function f(e) {
            o.push(e);
            var n = e != null ? i[e.type](e) : null;
            o.pop();
            return n;
        }
        me.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = f(e);
            o = n;
            t.walk(new qn(function(e) {
                if (e instanceof ue) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof $e) break;
                        if (t instanceof ke && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        Yn("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof we && n.body[0].body instanceof kn) {
                t.unshift(l(new Ee(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function x(n) {
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        function t(e) {
            v(n, e);
        }
    }
    function A(e, n) {
        e.walk(new qn(function(e) {
            if (e instanceof vn && e.quote) {
                t(e.key);
            } else if (e instanceof an) {
                E(e.property, t);
            }
        }));
        function t(e) {
            v(n, e);
        }
    }
    function E(e, n) {
        e.walk(new qn(function(e) {
            if (e instanceof tn) {
                E(e.tail_node(), n);
            } else if (e instanceof kn) {
                n(e.value);
            } else if (e instanceof ln) {
                E(e.consequent, n);
                E(e.alternative, n);
            }
            return true;
        }));
    }
    function k(e, n) {
        n = te(n, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            only_cache: false,
            regex: null,
            reserved: null
        }, true);
        var t = n.reserved;
        if (!Array.isArray(t)) t = [];
        if (!n.builtins) x(t);
        var i = -1;
        var r;
        if (n.cache) {
            r = n.cache.props;
            r.each(function(e) {
                v(t, e);
            });
        } else {
            r = new q();
        }
        var o = n.regex;
        var a = n.debug !== false;
        var s;
        if (a) s = n.debug === true ? "" : n.debug;
        var u = [];
        var f = [];
        e.walk(new qn(function(e) {
            if (e instanceof vn) {
                p(e.key);
            } else if (e instanceof I) {
                p(e.key.name);
            } else if (e instanceof on) {
                p(e.property);
            } else if (e instanceof an) {
                E(e.property, p);
            } else if (e instanceof en && e.expression.print_to_string() == "Object.defineProperty") {
                E(e.args[1], p);
            }
        }));
        return e.transform(new tt(function(e) {
            if (e instanceof vn) {
                e.key = d(e.key);
            } else if (e instanceof I) {
                e.key.name = d(e.key.name);
            } else if (e instanceof on) {
                e.property = d(e.property);
            } else if (!n.keep_quoted && e instanceof an) {
                e.property = h(e.property);
            } else if (e instanceof en && e.expression.print_to_string() == "Object.defineProperty") {
                e.args[1] = h(e.args[1]);
            }
        }));
        function c(e) {
            if (f.indexOf(e) >= 0) return false;
            if (t.indexOf(e) >= 0) return false;
            if (n.only_cache) return r.has(e);
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (o && !o.test(e)) return false;
            if (t.indexOf(e) >= 0) return false;
            return r.has(e) || u.indexOf(e) >= 0;
        }
        function p(e) {
            if (c(e)) v(u, e);
            if (!l(e)) v(f, e);
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = y(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            return e.transform(new tt(function(e) {
                if (e instanceof tn) {
                    var n = e.expressions.length - 1;
                    e.expressions[n] = h(e.expressions[n]);
                } else if (e instanceof kn) {
                    e.value = d(e.value);
                } else if (e instanceof ln) {
                    e.consequent = h(e.consequent);
                    e.alternative = h(e.alternative);
                }
                return e;
            }));
        }
    }
    "use strict";
    var D, F;
    if (typeof Buffer == "undefined") {
        D = atob;
        F = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        D = function(e) {
            return new Buffer(e, "base64").toString();
        };
        F = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        D = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        F = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function C(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var o = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!o) break;
            if (o[1] == "sourceMappingURL") {
                o = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(o[2]);
                if (!o) break;
                return D(o[2]);
            }
        }
        me.warn("inline source map not found: " + e);
    }
    function B(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function S(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function T(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new q();
        } else if (!(e.props instanceof q)) {
            e.props = q.fromObject(e.props);
        }
    }
    function st(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ut(i, r) {
        try {
            r = te(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                warnings: false,
                wrap: false
            }, true);
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            S("ie8", r, [ "compress", "mangle", "output" ]);
            S("keep_fnames", r, [ "compress", "mangle" ]);
            S("toplevel", r, [ "compress", "mangle" ]);
            var n;
            if (r.mangle) {
                r.mangle = te(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                T(r.mangle.cache);
                T(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = te(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) me.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var o, a;
            if (i instanceof ze) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var s = r.sourceMap && r.sourceMap.content;
                if (typeof s == "string" && s != "inline") {
                    s = B(s);
                }
                o = s && Object.create(null);
                for (var u in i) if (_e(i, u)) {
                    r.parse.filename = u;
                    r.parse.toplevel = a = nt(i[u], r.parse);
                    if (o) {
                        if (s == "inline") {
                            var f = C(u, a);
                            if (f) {
                                o[u] = B(f);
                            }
                        } else {
                            o[u] = s;
                        }
                    }
                }
            }
            if (n) {
                A(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) a = new at(r.compress).compress(a);
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) {
                a = k(a, r.mangle.properties);
            }
            if (e) e.output = Date.now();
            var c = {};
            if (r.output.ast) {
                c.ast = a;
            }
            if (!_e(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = w({
                        file: r.sourceMap.filename,
                        orig: o,
                        root: r.sourceMap.root
                    });
                    if (r.sourceMap.includeSources) {
                        if (i instanceof ze) {
                            throw new Error("original source content unavailable");
                        } else for (var u in i) if (_e(i, u)) {
                            r.output.source_map.get().setSourceContent(u, i[u]);
                        }
                    } else {
                        r.output.source_map.get()._sourcesContents = null;
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var l = ot(r.output);
                a.print(l);
                c.code = l.get();
                if (r.sourceMap) {
                    c.map = r.output.source_map.toString();
                    var p = r.sourceMap.url;
                    if (p) {
                        c.code = c.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            c.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + F(c.map);
                        } else {
                            c.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = st(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = st(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                c.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                c.warnings = t;
            }
            return c;
        } catch (e) {
            return {
                error: e
            };
        }
    }
    h["Dictionary"] = q;
    h["minify"] = ut;
    h["parse"] = nt;
    h["push_uniq"] = v;
    h["TreeTransformer"] = tt;
    h["TreeWalker"] = qn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
